// Generated from net_conf.json. Do not edit!
#ifndef _GNU_SOURCE
#define _GNU_SOURCE
#endif
#include <string.h>
#include <read_file.h>
#include "cni_net_conf.h"

cni_net_conf_ipam *make_cni_net_conf_ipam(yajl_val tree, const struct parser_context *ctx, parser_error *err) {
    cni_net_conf_ipam *ret = NULL;
    *err = 0;
    if (tree == NULL)
        return ret;
    ret = safe_malloc(sizeof(*ret));
    {
        yajl_val val = get_val(tree, "type", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->type = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val val = get_val(tree, "subnet", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->subnet = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val val = get_val(tree, "gateway", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->gateway = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val val = get_val(tree, "range-start", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->range_start = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val val = get_val(tree, "range-end", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->range_end = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val tmp = get_val(tree, "routes", yajl_t_array);
        if (tmp != NULL && YAJL_GET_ARRAY(tmp) != NULL && YAJL_GET_ARRAY(tmp)->len > 0) {
            size_t i;
            ret->routes_len = YAJL_GET_ARRAY(tmp)->len;
            ret->routes = safe_malloc((YAJL_GET_ARRAY(tmp)->len + 1) * sizeof(*ret->routes));
            for (i = 0; i < YAJL_GET_ARRAY(tmp)->len; i++) {
                yajl_val val = YAJL_GET_ARRAY(tmp)->values[i];
                ret->routes[i] = make_cni_network_route(val, ctx, err);
                if (ret->routes[i] == NULL) {
                    free_cni_net_conf_ipam(ret);
                    return NULL;
                }
            }
        }
    }

    if (tree->type == yajl_t_object)
    {
        size_t i;
        size_t j = 0;
        size_t cnt = tree->u.object.len;
        yajl_val resi = NULL;

        if (ctx->options & OPT_PARSE_FULLKEY)
        {
            resi = calloc (1, sizeof(*tree));
            if (resi == NULL)
            {
                free_cni_net_conf_ipam(ret);
                return NULL;
            }
            resi->type = yajl_t_object;
            resi->u.object.keys = calloc (cnt, sizeof (const char *));
            if (resi->u.object.keys == NULL)
            {
               free_cni_net_conf_ipam(ret);
               yajl_tree_free(resi);
               return NULL;
            }
            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
            if (resi->u.object.values == NULL)
            {
               free_cni_net_conf_ipam(ret);
               yajl_tree_free(resi);
               return NULL;
            }
        }
        for (i = 0; i < tree->u.object.len; i++)
        {
           if (strcmp(tree->u.object.keys[i], "type") &&
                strcmp(tree->u.object.keys[i], "subnet") &&
                strcmp(tree->u.object.keys[i], "gateway") &&
                strcmp(tree->u.object.keys[i], "range-start") &&
                strcmp(tree->u.object.keys[i], "range-end") &&
                strcmp(tree->u.object.keys[i], "routes"))
           {
              if (ctx->options & OPT_PARSE_FULLKEY)
              {
                 resi->u.object.keys[j] = tree->u.object.keys[i];
                 tree->u.object.keys[i] = NULL;
                 resi->u.object.values[j] = tree->u.object.values[i];
                 tree->u.object.values[i] = NULL;
                 resi->u.object.len++;
              }
              j++;
           }
        }
        if (ctx->options & OPT_PARSE_STRICT)
        {
            if (j > 0 && ctx->stderr > 0)
                fprintf (ctx->stderr, "WARNING: unknown key found\n");
        }
        if (ctx->options & OPT_PARSE_FULLKEY)
            ret->_residual = resi;
        }
    return ret;
}

void free_cni_net_conf_ipam(cni_net_conf_ipam *ptr) {
    if (ptr == NULL)
        return;
    free(ptr->type);
    ptr->type = NULL;
    free(ptr->subnet);
    ptr->subnet = NULL;
    free(ptr->gateway);
    ptr->gateway = NULL;
    free(ptr->range_start);
    ptr->range_start = NULL;
    free(ptr->range_end);
    ptr->range_end = NULL;
    if (ptr->routes != NULL) {
        size_t i;
        for (i = 0; i < ptr->routes_len; i++)
            if (ptr->routes[i] != NULL) {
                free_cni_network_route(ptr->routes[i]);
                ptr->routes[i] = NULL;
            }
        free(ptr->routes);
        ptr->routes = NULL;
    }
    yajl_tree_free (ptr->_residual);
    ptr->_residual = NULL;
    free(ptr);
}

yajl_gen_status gen_cni_net_conf_ipam(yajl_gen g, const cni_net_conf_ipam *ptr, const struct parser_context *ctx, parser_error *err) {
    yajl_gen_status stat = yajl_gen_status_ok;
    *err = 0;
    stat = yajl_gen_map_open((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->type != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("type"), strlen("type"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->type != NULL) {
            str = ptr->type;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->subnet != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("subnet"), strlen("subnet"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->subnet != NULL) {
            str = ptr->subnet;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->gateway != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("gateway"), strlen("gateway"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->gateway != NULL) {
            str = ptr->gateway;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->range_start != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("range-start"), strlen("range-start"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->range_start != NULL) {
            str = ptr->range_start;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->range_end != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("range-end"), strlen("range-end"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->range_end != NULL) {
            str = ptr->range_end;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->routes != NULL)) {
        size_t len = 0, i;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("routes"), strlen("routes"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->routes != NULL) {
            len = ptr->routes_len;
        }
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 0);
        stat = yajl_gen_array_open((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        for (i = 0; i < len; i++) {
            stat = gen_cni_network_route(g, ptr->routes[i], ctx, err);
            if (yajl_gen_status_ok != stat)
                GEN_SET_ERROR_AND_RETURN(stat, err);
        }
        stat = yajl_gen_array_close((yajl_gen)g);
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 1);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if (ptr != NULL && ptr->_residual != NULL)
    {
        stat = gen_yajl_object_residual (ptr->_residual, g, err);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN (stat, err);
    }
    stat = yajl_gen_map_close((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    return yajl_gen_status_ok;
}

cni_net_conf_runtime_config *make_cni_net_conf_runtime_config(yajl_val tree, const struct parser_context *ctx, parser_error *err) {
    cni_net_conf_runtime_config *ret = NULL;
    *err = 0;
    if (tree == NULL)
        return ret;
    ret = safe_malloc(sizeof(*ret));
    {
        yajl_val tmp = get_val(tree, "portMappings", yajl_t_array);
        if (tmp != NULL && YAJL_GET_ARRAY(tmp) != NULL && YAJL_GET_ARRAY(tmp)->len > 0) {
            size_t i;
            ret->port_mappings_len = YAJL_GET_ARRAY(tmp)->len;
            ret->port_mappings = safe_malloc((YAJL_GET_ARRAY(tmp)->len + 1) * sizeof(*ret->port_mappings));
            for (i = 0; i < YAJL_GET_ARRAY(tmp)->len; i++) {
                yajl_val val = YAJL_GET_ARRAY(tmp)->values[i];
                ret->port_mappings[i] = make_cni_inner_port_mapping(val, ctx, err);
                if (ret->port_mappings[i] == NULL) {
                    free_cni_net_conf_runtime_config(ret);
                    return NULL;
                }
            }
        }
    }
    ret->bandwidth = make_cni_bandwidth_entry(get_val(tree, "bandwidth", yajl_t_object), ctx, err);
    if (ret->bandwidth == NULL && *err != 0) {
        free_cni_net_conf_runtime_config(ret);
        return NULL;
    }

    if (tree->type == yajl_t_object)
    {
        size_t i;
        size_t j = 0;
        size_t cnt = tree->u.object.len;
        yajl_val resi = NULL;

        if (ctx->options & OPT_PARSE_FULLKEY)
        {
            resi = calloc (1, sizeof(*tree));
            if (resi == NULL)
            {
                free_cni_net_conf_runtime_config(ret);
                return NULL;
            }
            resi->type = yajl_t_object;
            resi->u.object.keys = calloc (cnt, sizeof (const char *));
            if (resi->u.object.keys == NULL)
            {
               free_cni_net_conf_runtime_config(ret);
               yajl_tree_free(resi);
               return NULL;
            }
            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
            if (resi->u.object.values == NULL)
            {
               free_cni_net_conf_runtime_config(ret);
               yajl_tree_free(resi);
               return NULL;
            }
        }
        for (i = 0; i < tree->u.object.len; i++)
        {
           if (strcmp(tree->u.object.keys[i], "portMappings") &&
                strcmp(tree->u.object.keys[i], "bandwidth"))
           {
              if (ctx->options & OPT_PARSE_FULLKEY)
              {
                 resi->u.object.keys[j] = tree->u.object.keys[i];
                 tree->u.object.keys[i] = NULL;
                 resi->u.object.values[j] = tree->u.object.values[i];
                 tree->u.object.values[i] = NULL;
                 resi->u.object.len++;
              }
              j++;
           }
        }
        if (ctx->options & OPT_PARSE_STRICT)
        {
            if (j > 0 && ctx->stderr > 0)
                fprintf (ctx->stderr, "WARNING: unknown key found\n");
        }
        if (ctx->options & OPT_PARSE_FULLKEY)
            ret->_residual = resi;
        }
    return ret;
}

void free_cni_net_conf_runtime_config(cni_net_conf_runtime_config *ptr) {
    if (ptr == NULL)
        return;
    if (ptr->port_mappings != NULL) {
        size_t i;
        for (i = 0; i < ptr->port_mappings_len; i++)
            if (ptr->port_mappings[i] != NULL) {
                free_cni_inner_port_mapping(ptr->port_mappings[i]);
                ptr->port_mappings[i] = NULL;
            }
        free(ptr->port_mappings);
        ptr->port_mappings = NULL;
    }
    if (ptr->bandwidth != NULL) {
        free_cni_bandwidth_entry(ptr->bandwidth);
        ptr->bandwidth = NULL;
    }
    yajl_tree_free (ptr->_residual);
    ptr->_residual = NULL;
    free(ptr);
}

yajl_gen_status gen_cni_net_conf_runtime_config(yajl_gen g, const cni_net_conf_runtime_config *ptr, const struct parser_context *ctx, parser_error *err) {
    yajl_gen_status stat = yajl_gen_status_ok;
    *err = 0;
    stat = yajl_gen_map_open((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->port_mappings != NULL)) {
        size_t len = 0, i;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("portMappings"), strlen("portMappings"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->port_mappings != NULL) {
            len = ptr->port_mappings_len;
        }
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 0);
        stat = yajl_gen_array_open((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        for (i = 0; i < len; i++) {
            stat = gen_cni_inner_port_mapping(g, ptr->port_mappings[i], ctx, err);
            if (yajl_gen_status_ok != stat)
                GEN_SET_ERROR_AND_RETURN(stat, err);
        }
        stat = yajl_gen_array_close((yajl_gen)g);
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 1);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->bandwidth != NULL)) {
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("bandwidth"), strlen("bandwidth"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        stat = gen_cni_bandwidth_entry(g, ptr != NULL ? ptr->bandwidth : NULL, ctx, err);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if (ptr != NULL && ptr->_residual != NULL)
    {
        stat = gen_yajl_object_residual (ptr->_residual, g, err);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN (stat, err);
    }
    stat = yajl_gen_map_close((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    return yajl_gen_status_ok;
}

cni_net_conf *make_cni_net_conf(yajl_val tree, const struct parser_context *ctx, parser_error *err) {
    cni_net_conf *ret = NULL;
    *err = 0;
    if (tree == NULL)
        return ret;
    ret = safe_malloc(sizeof(*ret));
    {
        yajl_val val = get_val(tree, "cniVersion", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->cni_version = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val val = get_val(tree, "name", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->name = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val val = get_val(tree, "type", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->type = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val val = get_val(tree, "ipMasq", yajl_t_true);
        if (val != NULL)
            ret->ip_masq = YAJL_IS_TRUE(val);
    }
    ret->ipam = make_cni_net_conf_ipam(get_val(tree, "ipam", yajl_t_object), ctx, err);
    if (ret->ipam == NULL && *err != 0) {
        free_cni_net_conf(ret);
        return NULL;
    }
    ret->dns = make_cni_network_dns(get_val(tree, "dns", yajl_t_object), ctx, err);
    if (ret->dns == NULL && *err != 0) {
        free_cni_net_conf(ret);
        return NULL;
    }
    ret->args = make_cni_net_args(get_val(tree, "args", yajl_t_object), ctx, err);
    if (ret->args == NULL && *err != 0) {
        free_cni_net_conf(ret);
        return NULL;
    }
    ret->prev_result = make_cni_result_curr(get_val(tree, "prevResult", yajl_t_object), ctx, err);
    if (ret->prev_result == NULL && *err != 0) {
        free_cni_net_conf(ret);
        return NULL;
    }
    ret->runtime_config = make_cni_net_conf_runtime_config(get_val(tree, "runtimeConfig", yajl_t_object), ctx, err);
    if (ret->runtime_config == NULL && *err != 0) {
        free_cni_net_conf(ret);
        return NULL;
    }
    {
        yajl_val tmp = get_val(tree, "capabilities", yajl_t_object);
        if (tmp != NULL) {
            ret->capabilities = make_json_map_string_bool(tmp, ctx, err);
            if (ret->capabilities == NULL) {
                char *new_error = NULL;
                if (asprintf(&new_error, "Value error for key 'capabilities': %s", *err ? *err : "null") < 0) {
                    new_error = safe_strdup("error allocating memory");
                }
                free(*err);
                *err = new_error;
                free_cni_net_conf(ret);
                return NULL;
            }
        }
    }

    if (tree->type == yajl_t_object)
    {
        size_t i;
        size_t j = 0;
        size_t cnt = tree->u.object.len;
        yajl_val resi = NULL;

        if (ctx->options & OPT_PARSE_FULLKEY)
        {
            resi = calloc (1, sizeof(*tree));
            if (resi == NULL)
            {
                free_cni_net_conf(ret);
                return NULL;
            }
            resi->type = yajl_t_object;
            resi->u.object.keys = calloc (cnt, sizeof (const char *));
            if (resi->u.object.keys == NULL)
            {
               free_cni_net_conf(ret);
               yajl_tree_free(resi);
               return NULL;
            }
            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
            if (resi->u.object.values == NULL)
            {
               free_cni_net_conf(ret);
               yajl_tree_free(resi);
               return NULL;
            }
        }
        for (i = 0; i < tree->u.object.len; i++)
        {
           if (strcmp(tree->u.object.keys[i], "cniVersion") &&
                strcmp(tree->u.object.keys[i], "name") &&
                strcmp(tree->u.object.keys[i], "type") &&
                strcmp(tree->u.object.keys[i], "ipMasq") &&
                strcmp(tree->u.object.keys[i], "ipam") &&
                strcmp(tree->u.object.keys[i], "dns") &&
                strcmp(tree->u.object.keys[i], "args") &&
                strcmp(tree->u.object.keys[i], "prevResult") &&
                strcmp(tree->u.object.keys[i], "runtimeConfig") &&
                strcmp(tree->u.object.keys[i], "capabilities"))
           {
              if (ctx->options & OPT_PARSE_FULLKEY)
              {
                 resi->u.object.keys[j] = tree->u.object.keys[i];
                 tree->u.object.keys[i] = NULL;
                 resi->u.object.values[j] = tree->u.object.values[i];
                 tree->u.object.values[i] = NULL;
                 resi->u.object.len++;
              }
              j++;
           }
        }
        if (ctx->options & OPT_PARSE_STRICT)
        {
            if (j > 0 && ctx->stderr > 0)
                fprintf (ctx->stderr, "WARNING: unknown key found\n");
        }
        if (ctx->options & OPT_PARSE_FULLKEY)
            ret->_residual = resi;
        }
    return ret;
}

void free_cni_net_conf(cni_net_conf *ptr) {
    if (ptr == NULL)
        return;
    free(ptr->cni_version);
    ptr->cni_version = NULL;
    free(ptr->name);
    ptr->name = NULL;
    free(ptr->type);
    ptr->type = NULL;
    if (ptr->ipam != NULL) {
        free_cni_net_conf_ipam(ptr->ipam);
        ptr->ipam = NULL;
    }
    if (ptr->dns != NULL) {
        free_cni_network_dns(ptr->dns);
        ptr->dns = NULL;
    }
    if (ptr->args != NULL) {
        free_cni_net_args(ptr->args);
        ptr->args = NULL;
    }
    if (ptr->prev_result != NULL) {
        free_cni_result_curr(ptr->prev_result);
        ptr->prev_result = NULL;
    }
    if (ptr->runtime_config != NULL) {
        free_cni_net_conf_runtime_config(ptr->runtime_config);
        ptr->runtime_config = NULL;
    }
    free_json_map_string_bool(ptr->capabilities);
    ptr->capabilities = NULL;
    yajl_tree_free (ptr->_residual);
    ptr->_residual = NULL;
    free(ptr);
}

yajl_gen_status gen_cni_net_conf(yajl_gen g, const cni_net_conf *ptr, const struct parser_context *ctx, parser_error *err) {
    yajl_gen_status stat = yajl_gen_status_ok;
    *err = 0;
    stat = yajl_gen_map_open((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->cni_version != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("cniVersion"), strlen("cniVersion"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->cni_version != NULL) {
            str = ptr->cni_version;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->name != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("name"), strlen("name"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->name != NULL) {
            str = ptr->name;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->type != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("type"), strlen("type"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->type != NULL) {
            str = ptr->type;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->ip_masq)) {
        bool b = false;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("ipMasq"), strlen("ipMasq"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->ip_masq) {
            b = ptr->ip_masq;
        }
        stat = yajl_gen_bool((yajl_gen)g, (int)(b));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->ipam != NULL)) {
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("ipam"), strlen("ipam"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        stat = gen_cni_net_conf_ipam(g, ptr != NULL ? ptr->ipam : NULL, ctx, err);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->dns != NULL)) {
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("dns"), strlen("dns"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        stat = gen_cni_network_dns(g, ptr != NULL ? ptr->dns : NULL, ctx, err);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->args != NULL)) {
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("args"), strlen("args"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        stat = gen_cni_net_args(g, ptr != NULL ? ptr->args : NULL, ctx, err);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->prev_result != NULL)) {
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("prevResult"), strlen("prevResult"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        stat = gen_cni_result_curr(g, ptr != NULL ? ptr->prev_result : NULL, ctx, err);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->runtime_config != NULL)) {
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("runtimeConfig"), strlen("runtimeConfig"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        stat = gen_cni_net_conf_runtime_config(g, ptr != NULL ? ptr->runtime_config : NULL, ctx, err);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->capabilities != NULL)) {
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)("capabilities"), strlen("capabilities"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        stat = gen_json_map_string_bool(g, ptr ? ptr->capabilities : NULL, ctx, err);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if (ptr != NULL && ptr->_residual != NULL)
    {
        stat = gen_yajl_object_residual (ptr->_residual, g, err);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN (stat, err);
    }
    stat = yajl_gen_map_close((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    return yajl_gen_status_ok;
}


cni_net_conf *cni_net_conf_parse_file(const char *filename, const struct parser_context *ctx, parser_error *err) {
    cni_net_conf *ptr = NULL;
    size_t filesize;
    char *content = NULL;

    if (filename == NULL || err == NULL)
        return NULL;

    *err = NULL;
    content = read_file(filename, &filesize);
    if (content == NULL) {
        if (asprintf(err, "cannot read the file: %s", filename) < 0)
            *err = safe_strdup("error allocating memory");
        return NULL;
    }
    ptr = cni_net_conf_parse_data(content, ctx, err);
    free(content);
    return ptr;
}

cni_net_conf *cni_net_conf_parse_file_stream(FILE *stream, const struct parser_context *ctx, parser_error *err) {
    cni_net_conf *ptr = NULL;
    size_t filesize;
    char *content = NULL ;

    if (stream == NULL || err == NULL)
        return NULL;

    *err = NULL;
    content = fread_file(stream, &filesize);
    if (content == NULL) {
        *err = safe_strdup("cannot read the file");
        return NULL;
    }
    ptr = cni_net_conf_parse_data(content, ctx, err);
    free(content);
    return ptr;
}

cni_net_conf *cni_net_conf_parse_data(const char *jsondata, const struct parser_context *ctx, parser_error *err) {
    cni_net_conf *ptr = NULL;
    yajl_val tree;
    char errbuf[1024];
    struct parser_context tmp_ctx = { 0 };

    if (jsondata == NULL || err == NULL)
        return NULL;

    *err = NULL;
    if (ctx == NULL) {
       ctx = (const struct parser_context *)(&tmp_ctx);
    }
    tree = yajl_tree_parse(jsondata, errbuf, sizeof(errbuf));
    if (tree == NULL) {
        if (asprintf(err, "cannot parse the data: %s", errbuf) < 0)
            *err = safe_strdup("error allocating memory");
        return NULL;
    }
    ptr = make_cni_net_conf(tree, ctx, err);
    yajl_tree_free(tree);
    return ptr;
}
char *cni_net_conf_generate_json(const cni_net_conf *ptr, const struct parser_context *ctx, parser_error *err) {
    yajl_gen g = NULL;
    struct parser_context tmp_ctx = { 0 };
    const unsigned char *gen_buf = NULL;
    char *json_buf = NULL;
    size_t gen_len = 0;

    if (ptr == NULL || err == NULL)
        return NULL;

    *err = NULL;
    if (ctx == NULL) {
        ctx = (const struct parser_context *)(&tmp_ctx);
    }

    if (!json_gen_init(&g, ctx)) {
        *err = safe_strdup("Json_gen init failed");
        goto out;
    }
    if (yajl_gen_status_ok != gen_cni_net_conf(g, ptr, ctx, err)) {
        if (*err == NULL)
            *err = safe_strdup("Failed to generate json");
        goto free_out;
    }
    yajl_gen_get_buf(g, &gen_buf, &gen_len);
    if (gen_buf == NULL) {
        *err = safe_strdup("Error to get generated json");
        goto free_out;
    }

    json_buf = safe_malloc(gen_len + 1);
    (void)memcpy(json_buf, gen_buf, gen_len);
    json_buf[gen_len] = '\0';

free_out:
    yajl_gen_clear(g);
    yajl_gen_free(g);
out:
    return json_buf;
}

