// Generated from exec-request.json. Do not edit!
#ifndef _GNU_SOURCE
#define _GNU_SOURCE
#endif
#include <string.h>
#include <read_file.h>
#include "container_exec_request.h"

container_exec_request *make_container_exec_request(yajl_val tree, const struct parser_context *ctx, parser_error *err) {
    container_exec_request *ret = NULL;
    *err = 0;
    if (tree == NULL)
        return ret;
    ret = safe_malloc(sizeof(*ret));
    {
        yajl_val val = get_val(tree, "container_id", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->container_id = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val val = get_val(tree, "suffix", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->suffix = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val val = get_val(tree, "tty", yajl_t_true);
        if (val != NULL)
            ret->tty = YAJL_IS_TRUE(val);
    }
    {
        yajl_val val = get_val(tree, "attach_stdin", yajl_t_true);
        if (val != NULL)
            ret->attach_stdin = YAJL_IS_TRUE(val);
    }
    {
        yajl_val val = get_val(tree, "attach_stdout", yajl_t_true);
        if (val != NULL)
            ret->attach_stdout = YAJL_IS_TRUE(val);
    }
    {
        yajl_val val = get_val(tree, "attach_stderr", yajl_t_true);
        if (val != NULL)
            ret->attach_stderr = YAJL_IS_TRUE(val);
    }
    {
        yajl_val val = get_val(tree, "stdin", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->stdin = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val val = get_val(tree, "stdout", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->stdout = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val val = get_val(tree, "stderr", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->stderr = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val tmp = get_val(tree, "argv", yajl_t_array);
        if (tmp != NULL && YAJL_GET_ARRAY(tmp) != NULL && YAJL_GET_ARRAY(tmp)->len > 0) {
            size_t i;
            ret->argv_len = YAJL_GET_ARRAY(tmp)->len;
            ret->argv = safe_malloc((YAJL_GET_ARRAY(tmp)->len + 1) * sizeof(*ret->argv));
            for (i = 0; i < YAJL_GET_ARRAY(tmp)->len; i++) {
                yajl_val val = YAJL_GET_ARRAY(tmp)->values[i];
                if (val != NULL) {
                    char *str = YAJL_GET_STRING(val);
                    ret->argv[i] = safe_strdup(str ? str : "");
                }
            }
        }
    }
    {
        yajl_val tmp = get_val(tree, "env", yajl_t_array);
        if (tmp != NULL && YAJL_GET_ARRAY(tmp) != NULL && YAJL_GET_ARRAY(tmp)->len > 0) {
            size_t i;
            ret->env_len = YAJL_GET_ARRAY(tmp)->len;
            ret->env = safe_malloc((YAJL_GET_ARRAY(tmp)->len + 1) * sizeof(*ret->env));
            for (i = 0; i < YAJL_GET_ARRAY(tmp)->len; i++) {
                yajl_val val = YAJL_GET_ARRAY(tmp)->values[i];
                if (val != NULL) {
                    char *str = YAJL_GET_STRING(val);
                    ret->env[i] = safe_strdup(str ? str : "");
                }
            }
        }
    }
    {
        yajl_val val = get_val(tree, "timeout", yajl_t_number);
        if (val != NULL) {
            int invalid = common_safe_int64(YAJL_GET_NUMBER(val), &ret->timeout);
            if (invalid) {
                if (asprintf(err, "Invalid value '%s' with type 'int64' for key 'timeout': %s", YAJL_GET_NUMBER(val), strerror(-invalid)) < 0)
                    *err = safe_strdup("error allocating memory");
                free_container_exec_request(ret);
                return NULL;
            }
        }
    }
    {
        yajl_val val = get_val(tree, "user", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->user = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val val = get_val(tree, "workdir", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->workdir = safe_strdup(str ? str : "");
        }
    }

    if (tree->type == yajl_t_object)
    {
        size_t i;
        size_t j = 0;
        size_t cnt = tree->u.object.len;
        yajl_val resi = NULL;

        if (ctx->options & OPT_PARSE_FULLKEY)
        {
            resi = calloc (1, sizeof(*tree));
            if (resi == NULL)
            {
                free_container_exec_request(ret);
                return NULL;
            }
            resi->type = yajl_t_object;
            resi->u.object.keys = calloc (cnt, sizeof (const char *));
            if (resi->u.object.keys == NULL)
            {
               free_container_exec_request(ret);
               yajl_tree_free(resi);
               return NULL;
            }
            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
            if (resi->u.object.values == NULL)
            {
               free_container_exec_request(ret);
               yajl_tree_free(resi);
               return NULL;
            }
        }
        for (i = 0; i < tree->u.object.len; i++)
        {
           if (strcmp(tree->u.object.keys[i], "container_id") &&
                strcmp(tree->u.object.keys[i], "suffix") &&
                strcmp(tree->u.object.keys[i], "tty") &&
                strcmp(tree->u.object.keys[i], "attach_stdin") &&
                strcmp(tree->u.object.keys[i], "attach_stdout") &&
                strcmp(tree->u.object.keys[i], "attach_stderr") &&
                strcmp(tree->u.object.keys[i], "stdin") &&
                strcmp(tree->u.object.keys[i], "stdout") &&
                strcmp(tree->u.object.keys[i], "stderr") &&
                strcmp(tree->u.object.keys[i], "argv") &&
                strcmp(tree->u.object.keys[i], "env") &&
                strcmp(tree->u.object.keys[i], "timeout") &&
                strcmp(tree->u.object.keys[i], "user") &&
                strcmp(tree->u.object.keys[i], "workdir"))
           {
              if (ctx->options & OPT_PARSE_FULLKEY)
              {
                 resi->u.object.keys[j] = tree->u.object.keys[i];
                 tree->u.object.keys[i] = NULL;
                 resi->u.object.values[j] = tree->u.object.values[i];
                 tree->u.object.values[i] = NULL;
                 resi->u.object.len++;
              }
              j++;
           }
        }
        if (ctx->options & OPT_PARSE_STRICT)
        {
            if (j > 0 && ctx->stderr > 0)
                fprintf (ctx->stderr, "WARNING: unknown key found\n");
        }
        if (ctx->options & OPT_PARSE_FULLKEY)
            ret->_residual = resi;
        }
    return ret;
}

void free_container_exec_request(container_exec_request *ptr) {
    if (ptr == NULL)
        return;
    free(ptr->container_id);
    ptr->container_id = NULL;
    free(ptr->suffix);
    ptr->suffix = NULL;
    free(ptr->stdin);
    ptr->stdin = NULL;
    free(ptr->stdout);
    ptr->stdout = NULL;
    free(ptr->stderr);
    ptr->stderr = NULL;
    if (ptr->argv != NULL) {
        size_t i;
        for (i = 0; i < ptr->argv_len; i++) {
            if (ptr->argv[i] != NULL) {
                free(ptr->argv[i]);
                ptr->argv[i] = NULL;
            }
        }
        free(ptr->argv);
        ptr->argv = NULL;
    }
    if (ptr->env != NULL) {
        size_t i;
        for (i = 0; i < ptr->env_len; i++) {
            if (ptr->env[i] != NULL) {
                free(ptr->env[i]);
                ptr->env[i] = NULL;
            }
        }
        free(ptr->env);
        ptr->env = NULL;
    }
    free(ptr->user);
    ptr->user = NULL;
    free(ptr->workdir);
    ptr->workdir = NULL;
    yajl_tree_free (ptr->_residual);
    ptr->_residual = NULL;
    free(ptr);
}

yajl_gen_status gen_container_exec_request(yajl_gen g, const container_exec_request *ptr, const struct parser_context *ctx, parser_error *err) {
    yajl_gen_status stat = yajl_gen_status_ok;
    *err = 0;
    stat = yajl_gen_map_open((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->container_id != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("container_id"), strlen("container_id"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->container_id != NULL) {
            str = ptr->container_id;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->suffix != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("suffix"), strlen("suffix"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->suffix != NULL) {
            str = ptr->suffix;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->tty)) {
        bool b = false;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("tty"), strlen("tty"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->tty) {
            b = ptr->tty;
        }
        stat = yajl_gen_bool((yajl_gen)g, (int)(b));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->attach_stdin)) {
        bool b = false;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("attach_stdin"), strlen("attach_stdin"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->attach_stdin) {
            b = ptr->attach_stdin;
        }
        stat = yajl_gen_bool((yajl_gen)g, (int)(b));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->attach_stdout)) {
        bool b = false;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("attach_stdout"), strlen("attach_stdout"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->attach_stdout) {
            b = ptr->attach_stdout;
        }
        stat = yajl_gen_bool((yajl_gen)g, (int)(b));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->attach_stderr)) {
        bool b = false;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("attach_stderr"), strlen("attach_stderr"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->attach_stderr) {
            b = ptr->attach_stderr;
        }
        stat = yajl_gen_bool((yajl_gen)g, (int)(b));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->stdin != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("stdin"), strlen("stdin"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->stdin != NULL) {
            str = ptr->stdin;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->stdout != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("stdout"), strlen("stdout"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->stdout != NULL) {
            str = ptr->stdout;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->stderr != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("stderr"), strlen("stderr"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->stderr != NULL) {
            str = ptr->stderr;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->argv != NULL)) {
        size_t len = 0, i;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("argv"), strlen("argv"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->argv != NULL) {
            len = ptr->argv_len;
        }
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 0);
        stat = yajl_gen_array_open((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        for (i = 0; i < len; i++) {
            stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(ptr->argv[i]), strlen(ptr->argv[i]));
            if (yajl_gen_status_ok != stat)
                GEN_SET_ERROR_AND_RETURN(stat, err);
        }
        stat = yajl_gen_array_close((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 1);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->env != NULL)) {
        size_t len = 0, i;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("env"), strlen("env"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->env != NULL) {
            len = ptr->env_len;
        }
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 0);
        stat = yajl_gen_array_open((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        for (i = 0; i < len; i++) {
            stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(ptr->env[i]), strlen(ptr->env[i]));
            if (yajl_gen_status_ok != stat)
                GEN_SET_ERROR_AND_RETURN(stat, err);
        }
        stat = yajl_gen_array_close((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 1);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->timeout)) {
        long long int num = 0;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("timeout"), strlen("timeout"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->timeout) {
            num = (long long int)ptr->timeout;
        }
        stat = map_int(g, num);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->user != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("user"), strlen("user"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->user != NULL) {
            str = ptr->user;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->workdir != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("workdir"), strlen("workdir"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->workdir != NULL) {
            str = ptr->workdir;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if (ptr != NULL && ptr->_residual != NULL)
    {
        stat = gen_yajl_object_residual (ptr->_residual, g, err);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN (stat, err);
    }
    stat = yajl_gen_map_close((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    return yajl_gen_status_ok;
}


container_exec_request *container_exec_request_parse_file(const char *filename, const struct parser_context *ctx, parser_error *err) {
    container_exec_request *ptr = NULL;
    size_t filesize;
    char *content = NULL;

    if (filename == NULL || err == NULL)
        return NULL;

    *err = NULL;
    content = read_file(filename, &filesize);
    if (content == NULL) {
        if (asprintf(err, "cannot read the file: %s", filename) < 0)
            *err = safe_strdup("error allocating memory");
        return NULL;
    }
    ptr = container_exec_request_parse_data(content, ctx, err);
    free(content);
    return ptr;
}

container_exec_request *container_exec_request_parse_file_stream(FILE *stream, const struct parser_context *ctx, parser_error *err) {
    container_exec_request *ptr = NULL;
    size_t filesize;
    char *content = NULL ;

    if (stream == NULL || err == NULL)
        return NULL;

    *err = NULL;
    content = fread_file(stream, &filesize);
    if (content == NULL) {
        *err = safe_strdup("cannot read the file");
        return NULL;
    }
    ptr = container_exec_request_parse_data(content, ctx, err);
    free(content);
    return ptr;
}

container_exec_request *container_exec_request_parse_data(const char *jsondata, const struct parser_context *ctx, parser_error *err) {
    container_exec_request *ptr = NULL;
    yajl_val tree;
    char errbuf[1024];
    struct parser_context tmp_ctx = { 0 };

    if (jsondata == NULL || err == NULL)
        return NULL;

    *err = NULL;
    if (ctx == NULL) {
       ctx = (const struct parser_context *)(&tmp_ctx);
    }
    tree = yajl_tree_parse(jsondata, errbuf, sizeof(errbuf));
    if (tree == NULL) {
        if (asprintf(err, "cannot parse the data: %s", errbuf) < 0)
            *err = safe_strdup("error allocating memory");
        return NULL;
    }
    ptr = make_container_exec_request(tree, ctx, err);
    yajl_tree_free(tree);
    return ptr;
}
char *container_exec_request_generate_json(const container_exec_request *ptr, const struct parser_context *ctx, parser_error *err) {
    yajl_gen g = NULL;
    struct parser_context tmp_ctx = { 0 };
    const unsigned char *gen_buf = NULL;
    char *json_buf = NULL;
    size_t gen_len = 0;

    if (ptr == NULL || err == NULL)
        return NULL;

    *err = NULL;
    if (ctx == NULL) {
        ctx = (const struct parser_context *)(&tmp_ctx);
    }

    if (!json_gen_init(&g, ctx)) {
        *err = safe_strdup("Json_gen init failed");
        goto out;
    }
    if (yajl_gen_status_ok != gen_container_exec_request(g, ptr, ctx, err)) {
        if (*err == NULL)
            *err = safe_strdup("Failed to generate json");
        goto free_out;
    }
    yajl_gen_get_buf(g, &gen_buf, &gen_len);
    if (gen_buf == NULL) {
        *err = safe_strdup("Error to get generated json");
        goto free_out;
    }

    json_buf = safe_malloc(gen_len + 1);
    (void)memcpy(json_buf, gen_buf, gen_len);
    json_buf[gen_len] = '\0';

free_out:
    yajl_gen_clear(g);
    yajl_gen_free(g);
out:
    return json_buf;
}

