// Generated from inspect.json. Do not edit!
#ifndef _GNU_SOURCE
#define _GNU_SOURCE
#endif
#include <string.h>
#include <read_file.h>
#include "container_inspect.h"

container_inspect_state *make_container_inspect_state(yajl_val tree, const struct parser_context *ctx, parser_error *err) {
    container_inspect_state *ret = NULL;
    *err = 0;
    if (tree == NULL)
        return ret;
    ret = safe_malloc(sizeof(*ret));
    {
        yajl_val val = get_val(tree, "Status", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->status = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val val = get_val(tree, "Running", yajl_t_true);
        if (val != NULL)
            ret->running = YAJL_IS_TRUE(val);
    }
    {
        yajl_val val = get_val(tree, "Paused", yajl_t_true);
        if (val != NULL)
            ret->paused = YAJL_IS_TRUE(val);
    }
    {
        yajl_val val = get_val(tree, "Restarting", yajl_t_true);
        if (val != NULL)
            ret->restarting = YAJL_IS_TRUE(val);
    }
    {
        yajl_val val = get_val(tree, "Pid", yajl_t_number);
        if (val != NULL) {
            int invalid = common_safe_int(YAJL_GET_NUMBER(val), (int *)&ret->pid);
            if (invalid) {
                if (asprintf(err, "Invalid value '%s' with type 'integer' for key 'Pid': %s", YAJL_GET_NUMBER(val), strerror(-invalid)) < 0)
                    *err = safe_strdup("error allocating memory");
                free_container_inspect_state(ret);
                return NULL;
            }
        }
    }
    {
        yajl_val val = get_val(tree, "ExitCode", yajl_t_number);
        if (val != NULL) {
            int invalid = common_safe_int(YAJL_GET_NUMBER(val), (int *)&ret->exit_code);
            if (invalid) {
                if (asprintf(err, "Invalid value '%s' with type 'integer' for key 'ExitCode': %s", YAJL_GET_NUMBER(val), strerror(-invalid)) < 0)
                    *err = safe_strdup("error allocating memory");
                free_container_inspect_state(ret);
                return NULL;
            }
        }
    }
    {
        yajl_val val = get_val(tree, "Error", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->error = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val val = get_val(tree, "StartedAt", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->started_at = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val val = get_val(tree, "FinishedAt", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->finished_at = safe_strdup(str ? str : "");
        }
    }
    ret->health = make_defs_health(get_val(tree, "Health", yajl_t_object), ctx, err);
    if (ret->health == NULL && *err != 0) {
        free_container_inspect_state(ret);
        return NULL;
    }

    if (tree->type == yajl_t_object)
    {
        size_t i;
        size_t j = 0;
        size_t cnt = tree->u.object.len;
        yajl_val resi = NULL;

        if (ctx->options & OPT_PARSE_FULLKEY)
        {
            resi = calloc (1, sizeof(*tree));
            if (resi == NULL)
            {
                free_container_inspect_state(ret);
                return NULL;
            }
            resi->type = yajl_t_object;
            resi->u.object.keys = calloc (cnt, sizeof (const char *));
            if (resi->u.object.keys == NULL)
            {
               free_container_inspect_state(ret);
               yajl_tree_free(resi);
               return NULL;
            }
            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
            if (resi->u.object.values == NULL)
            {
               free_container_inspect_state(ret);
               yajl_tree_free(resi);
               return NULL;
            }
        }
        for (i = 0; i < tree->u.object.len; i++)
        {
           if (strcmp(tree->u.object.keys[i], "Status") &&
                strcmp(tree->u.object.keys[i], "Running") &&
                strcmp(tree->u.object.keys[i], "Paused") &&
                strcmp(tree->u.object.keys[i], "Restarting") &&
                strcmp(tree->u.object.keys[i], "Pid") &&
                strcmp(tree->u.object.keys[i], "ExitCode") &&
                strcmp(tree->u.object.keys[i], "Error") &&
                strcmp(tree->u.object.keys[i], "StartedAt") &&
                strcmp(tree->u.object.keys[i], "FinishedAt") &&
                strcmp(tree->u.object.keys[i], "Health"))
           {
              if (ctx->options & OPT_PARSE_FULLKEY)
              {
                 resi->u.object.keys[j] = tree->u.object.keys[i];
                 tree->u.object.keys[i] = NULL;
                 resi->u.object.values[j] = tree->u.object.values[i];
                 tree->u.object.values[i] = NULL;
                 resi->u.object.len++;
              }
              j++;
           }
        }
        if (ctx->options & OPT_PARSE_STRICT)
        {
            if (j > 0 && ctx->stderr > 0)
                fprintf (ctx->stderr, "WARNING: unknown key found\n");
        }
        if (ctx->options & OPT_PARSE_FULLKEY)
            ret->_residual = resi;
        }
    return ret;
}

void free_container_inspect_state(container_inspect_state *ptr) {
    if (ptr == NULL)
        return;
    free(ptr->status);
    ptr->status = NULL;
    free(ptr->error);
    ptr->error = NULL;
    free(ptr->started_at);
    ptr->started_at = NULL;
    free(ptr->finished_at);
    ptr->finished_at = NULL;
    if (ptr->health != NULL) {
        free_defs_health(ptr->health);
        ptr->health = NULL;
    }
    yajl_tree_free (ptr->_residual);
    ptr->_residual = NULL;
    free(ptr);
}

yajl_gen_status gen_container_inspect_state(yajl_gen g, const container_inspect_state *ptr, const struct parser_context *ctx, parser_error *err) {
    yajl_gen_status stat = yajl_gen_status_ok;
    *err = 0;
    stat = yajl_gen_map_open((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->status != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("Status"), strlen("Status"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->status != NULL) {
            str = ptr->status;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->running)) {
        bool b = false;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("Running"), strlen("Running"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->running) {
            b = ptr->running;
        }
        stat = yajl_gen_bool((yajl_gen)g, (int)(b));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->paused)) {
        bool b = false;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("Paused"), strlen("Paused"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->paused) {
            b = ptr->paused;
        }
        stat = yajl_gen_bool((yajl_gen)g, (int)(b));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->restarting)) {
        bool b = false;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("Restarting"), strlen("Restarting"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->restarting) {
            b = ptr->restarting;
        }
        stat = yajl_gen_bool((yajl_gen)g, (int)(b));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->pid)) {
        long long int num = 0;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("Pid"), strlen("Pid"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->pid) {
            num = (long long int)ptr->pid;
        }
        stat = map_int(g, num);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->exit_code)) {
        long long int num = 0;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("ExitCode"), strlen("ExitCode"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->exit_code) {
            num = (long long int)ptr->exit_code;
        }
        stat = map_int(g, num);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->error != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("Error"), strlen("Error"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->error != NULL) {
            str = ptr->error;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->started_at != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("StartedAt"), strlen("StartedAt"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->started_at != NULL) {
            str = ptr->started_at;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->finished_at != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("FinishedAt"), strlen("FinishedAt"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->finished_at != NULL) {
            str = ptr->finished_at;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->health != NULL)) {
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("Health"), strlen("Health"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        stat = gen_defs_health(g, ptr != NULL ? ptr->health : NULL, ctx, err);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if (ptr != NULL && ptr->_residual != NULL)
    {
        stat = gen_yajl_object_residual (ptr->_residual, g, err);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN (stat, err);
    }
    stat = yajl_gen_map_close((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    return yajl_gen_status_ok;
}

container_inspect_graph_driver_data *make_container_inspect_graph_driver_data(yajl_val tree, const struct parser_context *ctx, parser_error *err) {
    container_inspect_graph_driver_data *ret = NULL;
    *err = 0;
    if (tree == NULL)
        return ret;
    ret = safe_malloc(sizeof(*ret));
    {
        yajl_val val = get_val(tree, "LowerDir", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->lower_dir = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val val = get_val(tree, "MergedDir", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->merged_dir = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val val = get_val(tree, "UpperDir", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->upper_dir = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val val = get_val(tree, "WorkDir", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->work_dir = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val val = get_val(tree, "DeviceId", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->device_id = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val val = get_val(tree, "DeviceName", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->device_name = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val val = get_val(tree, "DeviceSize", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->device_size = safe_strdup(str ? str : "");
        }
    }

    if (tree->type == yajl_t_object)
    {
        size_t i;
        size_t j = 0;
        size_t cnt = tree->u.object.len;
        yajl_val resi = NULL;

        if (ctx->options & OPT_PARSE_FULLKEY)
        {
            resi = calloc (1, sizeof(*tree));
            if (resi == NULL)
            {
                free_container_inspect_graph_driver_data(ret);
                return NULL;
            }
            resi->type = yajl_t_object;
            resi->u.object.keys = calloc (cnt, sizeof (const char *));
            if (resi->u.object.keys == NULL)
            {
               free_container_inspect_graph_driver_data(ret);
               yajl_tree_free(resi);
               return NULL;
            }
            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
            if (resi->u.object.values == NULL)
            {
               free_container_inspect_graph_driver_data(ret);
               yajl_tree_free(resi);
               return NULL;
            }
        }
        for (i = 0; i < tree->u.object.len; i++)
        {
           if (strcmp(tree->u.object.keys[i], "LowerDir") &&
                strcmp(tree->u.object.keys[i], "MergedDir") &&
                strcmp(tree->u.object.keys[i], "UpperDir") &&
                strcmp(tree->u.object.keys[i], "WorkDir") &&
                strcmp(tree->u.object.keys[i], "DeviceId") &&
                strcmp(tree->u.object.keys[i], "DeviceName") &&
                strcmp(tree->u.object.keys[i], "DeviceSize"))
           {
              if (ctx->options & OPT_PARSE_FULLKEY)
              {
                 resi->u.object.keys[j] = tree->u.object.keys[i];
                 tree->u.object.keys[i] = NULL;
                 resi->u.object.values[j] = tree->u.object.values[i];
                 tree->u.object.values[i] = NULL;
                 resi->u.object.len++;
              }
              j++;
           }
        }
        if (ctx->options & OPT_PARSE_STRICT)
        {
            if (j > 0 && ctx->stderr > 0)
                fprintf (ctx->stderr, "WARNING: unknown key found\n");
        }
        if (ctx->options & OPT_PARSE_FULLKEY)
            ret->_residual = resi;
        }
    return ret;
}

void free_container_inspect_graph_driver_data(container_inspect_graph_driver_data *ptr) {
    if (ptr == NULL)
        return;
    free(ptr->lower_dir);
    ptr->lower_dir = NULL;
    free(ptr->merged_dir);
    ptr->merged_dir = NULL;
    free(ptr->upper_dir);
    ptr->upper_dir = NULL;
    free(ptr->work_dir);
    ptr->work_dir = NULL;
    free(ptr->device_id);
    ptr->device_id = NULL;
    free(ptr->device_name);
    ptr->device_name = NULL;
    free(ptr->device_size);
    ptr->device_size = NULL;
    yajl_tree_free (ptr->_residual);
    ptr->_residual = NULL;
    free(ptr);
}

yajl_gen_status gen_container_inspect_graph_driver_data(yajl_gen g, const container_inspect_graph_driver_data *ptr, const struct parser_context *ctx, parser_error *err) {
    yajl_gen_status stat = yajl_gen_status_ok;
    *err = 0;
    stat = yajl_gen_map_open((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->lower_dir != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("LowerDir"), strlen("LowerDir"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->lower_dir != NULL) {
            str = ptr->lower_dir;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->merged_dir != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("MergedDir"), strlen("MergedDir"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->merged_dir != NULL) {
            str = ptr->merged_dir;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->upper_dir != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("UpperDir"), strlen("UpperDir"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->upper_dir != NULL) {
            str = ptr->upper_dir;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->work_dir != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("WorkDir"), strlen("WorkDir"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->work_dir != NULL) {
            str = ptr->work_dir;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->device_id != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("DeviceId"), strlen("DeviceId"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->device_id != NULL) {
            str = ptr->device_id;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->device_name != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("DeviceName"), strlen("DeviceName"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->device_name != NULL) {
            str = ptr->device_name;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->device_size != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("DeviceSize"), strlen("DeviceSize"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->device_size != NULL) {
            str = ptr->device_size;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if (ptr != NULL && ptr->_residual != NULL)
    {
        stat = gen_yajl_object_residual (ptr->_residual, g, err);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN (stat, err);
    }
    stat = yajl_gen_map_close((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    return yajl_gen_status_ok;
}

container_inspect_graph_driver *make_container_inspect_graph_driver(yajl_val tree, const struct parser_context *ctx, parser_error *err) {
    container_inspect_graph_driver *ret = NULL;
    *err = 0;
    if (tree == NULL)
        return ret;
    ret = safe_malloc(sizeof(*ret));
    ret->data = make_container_inspect_graph_driver_data(get_val(tree, "Data", yajl_t_object), ctx, err);
    if (ret->data == NULL && *err != 0) {
        free_container_inspect_graph_driver(ret);
        return NULL;
    }
    {
        yajl_val val = get_val(tree, "Name", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->name = safe_strdup(str ? str : "");
        }
    }

    if (tree->type == yajl_t_object)
    {
        size_t i;
        size_t j = 0;
        size_t cnt = tree->u.object.len;
        yajl_val resi = NULL;

        if (ctx->options & OPT_PARSE_FULLKEY)
        {
            resi = calloc (1, sizeof(*tree));
            if (resi == NULL)
            {
                free_container_inspect_graph_driver(ret);
                return NULL;
            }
            resi->type = yajl_t_object;
            resi->u.object.keys = calloc (cnt, sizeof (const char *));
            if (resi->u.object.keys == NULL)
            {
               free_container_inspect_graph_driver(ret);
               yajl_tree_free(resi);
               return NULL;
            }
            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
            if (resi->u.object.values == NULL)
            {
               free_container_inspect_graph_driver(ret);
               yajl_tree_free(resi);
               return NULL;
            }
        }
        for (i = 0; i < tree->u.object.len; i++)
        {
           if (strcmp(tree->u.object.keys[i], "Data") &&
                strcmp(tree->u.object.keys[i], "Name"))
           {
              if (ctx->options & OPT_PARSE_FULLKEY)
              {
                 resi->u.object.keys[j] = tree->u.object.keys[i];
                 tree->u.object.keys[i] = NULL;
                 resi->u.object.values[j] = tree->u.object.values[i];
                 tree->u.object.values[i] = NULL;
                 resi->u.object.len++;
              }
              j++;
           }
        }
        if (ctx->options & OPT_PARSE_STRICT)
        {
            if (j > 0 && ctx->stderr > 0)
                fprintf (ctx->stderr, "WARNING: unknown key found\n");
        }
        if (ctx->options & OPT_PARSE_FULLKEY)
            ret->_residual = resi;
        }
    return ret;
}

void free_container_inspect_graph_driver(container_inspect_graph_driver *ptr) {
    if (ptr == NULL)
        return;
    if (ptr->data != NULL) {
        free_container_inspect_graph_driver_data(ptr->data);
        ptr->data = NULL;
    }
    free(ptr->name);
    ptr->name = NULL;
    yajl_tree_free (ptr->_residual);
    ptr->_residual = NULL;
    free(ptr);
}

yajl_gen_status gen_container_inspect_graph_driver(yajl_gen g, const container_inspect_graph_driver *ptr, const struct parser_context *ctx, parser_error *err) {
    yajl_gen_status stat = yajl_gen_status_ok;
    *err = 0;
    stat = yajl_gen_map_open((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->data != NULL)) {
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("Data"), strlen("Data"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        stat = gen_container_inspect_graph_driver_data(g, ptr != NULL ? ptr->data : NULL, ctx, err);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->name != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("Name"), strlen("Name"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->name != NULL) {
            str = ptr->name;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if (ptr != NULL && ptr->_residual != NULL)
    {
        stat = gen_yajl_object_residual (ptr->_residual, g, err);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN (stat, err);
    }
    stat = yajl_gen_map_close((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    return yajl_gen_status_ok;
}

container_inspect_config *make_container_inspect_config(yajl_val tree, const struct parser_context *ctx, parser_error *err) {
    container_inspect_config *ret = NULL;
    *err = 0;
    if (tree == NULL)
        return ret;
    ret = safe_malloc(sizeof(*ret));
    {
        yajl_val val = get_val(tree, "Hostname", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->hostname = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val val = get_val(tree, "User", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->user = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val tmp = get_val(tree, "Env", yajl_t_array);
        if (tmp != NULL && YAJL_GET_ARRAY(tmp) != NULL && YAJL_GET_ARRAY(tmp)->len > 0) {
            size_t i;
            ret->env_len = YAJL_GET_ARRAY(tmp)->len;
            ret->env = safe_malloc((YAJL_GET_ARRAY(tmp)->len + 1) * sizeof(*ret->env));
            for (i = 0; i < YAJL_GET_ARRAY(tmp)->len; i++) {
                yajl_val val = YAJL_GET_ARRAY(tmp)->values[i];
                if (val != NULL) {
                    char *str = YAJL_GET_STRING(val);
                    ret->env[i] = safe_strdup(str ? str : "");
                }
            }
        }
    }
    {
        yajl_val val = get_val(tree, "Tty", yajl_t_true);
        if (val != NULL)
            ret->tty = YAJL_IS_TRUE(val);
    }
    {
        yajl_val tmp = get_val(tree, "Cmd", yajl_t_array);
        if (tmp != NULL && YAJL_GET_ARRAY(tmp) != NULL && YAJL_GET_ARRAY(tmp)->len > 0) {
            size_t i;
            ret->cmd_len = YAJL_GET_ARRAY(tmp)->len;
            ret->cmd = safe_malloc((YAJL_GET_ARRAY(tmp)->len + 1) * sizeof(*ret->cmd));
            for (i = 0; i < YAJL_GET_ARRAY(tmp)->len; i++) {
                yajl_val val = YAJL_GET_ARRAY(tmp)->values[i];
                if (val != NULL) {
                    char *str = YAJL_GET_STRING(val);
                    ret->cmd[i] = safe_strdup(str ? str : "");
                }
            }
        }
    }
    {
        yajl_val tmp = get_val(tree, "Entrypoint", yajl_t_array);
        if (tmp != NULL && YAJL_GET_ARRAY(tmp) != NULL && YAJL_GET_ARRAY(tmp)->len > 0) {
            size_t i;
            ret->entrypoint_len = YAJL_GET_ARRAY(tmp)->len;
            ret->entrypoint = safe_malloc((YAJL_GET_ARRAY(tmp)->len + 1) * sizeof(*ret->entrypoint));
            for (i = 0; i < YAJL_GET_ARRAY(tmp)->len; i++) {
                yajl_val val = YAJL_GET_ARRAY(tmp)->values[i];
                if (val != NULL) {
                    char *str = YAJL_GET_STRING(val);
                    ret->entrypoint[i] = safe_strdup(str ? str : "");
                }
            }
        }
    }
    {
        yajl_val tmp = get_val(tree, "Labels", yajl_t_object);
        if (tmp != NULL) {
            ret->labels = make_json_map_string_string(tmp, ctx, err);
            if (ret->labels == NULL) {
                char *new_error = NULL;
                if (asprintf(&new_error, "Value error for key 'Labels': %s", *err ? *err : "null") < 0) {
                    new_error = safe_strdup("error allocating memory");
                }
                free(*err);
                *err = new_error;
                free_container_inspect_config(ret);
                return NULL;
            }
        }
    }
    ret->volumes = make_defs_map_string_object(get_val(tree, "Volumes", yajl_t_object), ctx, err);
    if (ret->volumes == NULL && *err != 0) {
        free_container_inspect_config(ret);
        return NULL;
    }
    {
        yajl_val tmp = get_val(tree, "Annotations", yajl_t_object);
        if (tmp != NULL) {
            ret->annotations = make_json_map_string_string(tmp, ctx, err);
            if (ret->annotations == NULL) {
                char *new_error = NULL;
                if (asprintf(&new_error, "Value error for key 'Annotations': %s", *err ? *err : "null") < 0) {
                    new_error = safe_strdup("error allocating memory");
                }
                free(*err);
                *err = new_error;
                free_container_inspect_config(ret);
                return NULL;
            }
        }
    }
    ret->health_check = make_defs_health_check(get_val(tree, "HealthCheck", yajl_t_object), ctx, err);
    if (ret->health_check == NULL && *err != 0) {
        free_container_inspect_config(ret);
        return NULL;
    }
    {
        yajl_val val = get_val(tree, "Image", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->image = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val val = get_val(tree, "ImageRef", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->image_ref = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val val = get_val(tree, "StopSignal", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->stop_signal = safe_strdup(str ? str : "");
        }
    }

    if (tree->type == yajl_t_object)
    {
        size_t i;
        size_t j = 0;
        size_t cnt = tree->u.object.len;
        yajl_val resi = NULL;

        if (ctx->options & OPT_PARSE_FULLKEY)
        {
            resi = calloc (1, sizeof(*tree));
            if (resi == NULL)
            {
                free_container_inspect_config(ret);
                return NULL;
            }
            resi->type = yajl_t_object;
            resi->u.object.keys = calloc (cnt, sizeof (const char *));
            if (resi->u.object.keys == NULL)
            {
               free_container_inspect_config(ret);
               yajl_tree_free(resi);
               return NULL;
            }
            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
            if (resi->u.object.values == NULL)
            {
               free_container_inspect_config(ret);
               yajl_tree_free(resi);
               return NULL;
            }
        }
        for (i = 0; i < tree->u.object.len; i++)
        {
           if (strcmp(tree->u.object.keys[i], "Hostname") &&
                strcmp(tree->u.object.keys[i], "User") &&
                strcmp(tree->u.object.keys[i], "Env") &&
                strcmp(tree->u.object.keys[i], "Tty") &&
                strcmp(tree->u.object.keys[i], "Cmd") &&
                strcmp(tree->u.object.keys[i], "Entrypoint") &&
                strcmp(tree->u.object.keys[i], "Labels") &&
                strcmp(tree->u.object.keys[i], "Volumes") &&
                strcmp(tree->u.object.keys[i], "Annotations") &&
                strcmp(tree->u.object.keys[i], "HealthCheck") &&
                strcmp(tree->u.object.keys[i], "Image") &&
                strcmp(tree->u.object.keys[i], "ImageRef") &&
                strcmp(tree->u.object.keys[i], "StopSignal"))
           {
              if (ctx->options & OPT_PARSE_FULLKEY)
              {
                 resi->u.object.keys[j] = tree->u.object.keys[i];
                 tree->u.object.keys[i] = NULL;
                 resi->u.object.values[j] = tree->u.object.values[i];
                 tree->u.object.values[i] = NULL;
                 resi->u.object.len++;
              }
              j++;
           }
        }
        if (ctx->options & OPT_PARSE_STRICT)
        {
            if (j > 0 && ctx->stderr > 0)
                fprintf (ctx->stderr, "WARNING: unknown key found\n");
        }
        if (ctx->options & OPT_PARSE_FULLKEY)
            ret->_residual = resi;
        }
    return ret;
}

void free_container_inspect_config(container_inspect_config *ptr) {
    if (ptr == NULL)
        return;
    free(ptr->hostname);
    ptr->hostname = NULL;
    free(ptr->user);
    ptr->user = NULL;
    if (ptr->env != NULL) {
        size_t i;
        for (i = 0; i < ptr->env_len; i++) {
            if (ptr->env[i] != NULL) {
                free(ptr->env[i]);
                ptr->env[i] = NULL;
            }
        }
        free(ptr->env);
        ptr->env = NULL;
    }
    if (ptr->cmd != NULL) {
        size_t i;
        for (i = 0; i < ptr->cmd_len; i++) {
            if (ptr->cmd[i] != NULL) {
                free(ptr->cmd[i]);
                ptr->cmd[i] = NULL;
            }
        }
        free(ptr->cmd);
        ptr->cmd = NULL;
    }
    if (ptr->entrypoint != NULL) {
        size_t i;
        for (i = 0; i < ptr->entrypoint_len; i++) {
            if (ptr->entrypoint[i] != NULL) {
                free(ptr->entrypoint[i]);
                ptr->entrypoint[i] = NULL;
            }
        }
        free(ptr->entrypoint);
        ptr->entrypoint = NULL;
    }
    free_json_map_string_string(ptr->labels);
    ptr->labels = NULL;
    free_defs_map_string_object(ptr->volumes);
    ptr->volumes = NULL;
    free_json_map_string_string(ptr->annotations);
    ptr->annotations = NULL;
    if (ptr->health_check != NULL) {
        free_defs_health_check(ptr->health_check);
        ptr->health_check = NULL;
    }
    free(ptr->image);
    ptr->image = NULL;
    free(ptr->image_ref);
    ptr->image_ref = NULL;
    free(ptr->stop_signal);
    ptr->stop_signal = NULL;
    yajl_tree_free (ptr->_residual);
    ptr->_residual = NULL;
    free(ptr);
}

yajl_gen_status gen_container_inspect_config(yajl_gen g, const container_inspect_config *ptr, const struct parser_context *ctx, parser_error *err) {
    yajl_gen_status stat = yajl_gen_status_ok;
    *err = 0;
    stat = yajl_gen_map_open((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->hostname != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("Hostname"), strlen("Hostname"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->hostname != NULL) {
            str = ptr->hostname;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->user != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("User"), strlen("User"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->user != NULL) {
            str = ptr->user;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->env != NULL)) {
        size_t len = 0, i;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("Env"), strlen("Env"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->env != NULL) {
            len = ptr->env_len;
        }
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 0);
        stat = yajl_gen_array_open((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        for (i = 0; i < len; i++) {
            stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(ptr->env[i]), strlen(ptr->env[i]));
            if (yajl_gen_status_ok != stat)
                GEN_SET_ERROR_AND_RETURN(stat, err);
        }
        stat = yajl_gen_array_close((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 1);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->tty)) {
        bool b = false;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("Tty"), strlen("Tty"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->tty) {
            b = ptr->tty;
        }
        stat = yajl_gen_bool((yajl_gen)g, (int)(b));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->cmd != NULL)) {
        size_t len = 0, i;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("Cmd"), strlen("Cmd"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->cmd != NULL) {
            len = ptr->cmd_len;
        }
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 0);
        stat = yajl_gen_array_open((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        for (i = 0; i < len; i++) {
            stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(ptr->cmd[i]), strlen(ptr->cmd[i]));
            if (yajl_gen_status_ok != stat)
                GEN_SET_ERROR_AND_RETURN(stat, err);
        }
        stat = yajl_gen_array_close((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 1);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->entrypoint != NULL)) {
        size_t len = 0, i;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("Entrypoint"), strlen("Entrypoint"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->entrypoint != NULL) {
            len = ptr->entrypoint_len;
        }
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 0);
        stat = yajl_gen_array_open((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        for (i = 0; i < len; i++) {
            stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(ptr->entrypoint[i]), strlen(ptr->entrypoint[i]));
            if (yajl_gen_status_ok != stat)
                GEN_SET_ERROR_AND_RETURN(stat, err);
        }
        stat = yajl_gen_array_close((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 1);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->labels != NULL)) {
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)("Labels"), strlen("Labels"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        stat = gen_json_map_string_string(g, ptr ? ptr->labels : NULL, ctx, err);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->volumes != NULL)) {
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("Volumes"), strlen("Volumes"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        stat = gen_defs_map_string_object(g, ptr != NULL ? ptr->volumes : NULL, ctx, err);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->annotations != NULL)) {
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)("Annotations"), strlen("Annotations"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        stat = gen_json_map_string_string(g, ptr ? ptr->annotations : NULL, ctx, err);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->health_check != NULL)) {
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("HealthCheck"), strlen("HealthCheck"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        stat = gen_defs_health_check(g, ptr != NULL ? ptr->health_check : NULL, ctx, err);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->image != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("Image"), strlen("Image"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->image != NULL) {
            str = ptr->image;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->image_ref != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("ImageRef"), strlen("ImageRef"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->image_ref != NULL) {
            str = ptr->image_ref;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->stop_signal != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("StopSignal"), strlen("StopSignal"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->stop_signal != NULL) {
            str = ptr->stop_signal;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if (ptr != NULL && ptr->_residual != NULL)
    {
        stat = gen_yajl_object_residual (ptr->_residual, g, err);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN (stat, err);
    }
    stat = yajl_gen_map_close((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    return yajl_gen_status_ok;
}

container_inspect_network_settings *make_container_inspect_network_settings(yajl_val tree, const struct parser_context *ctx, parser_error *err) {
    container_inspect_network_settings *ret = NULL;
    *err = 0;
    if (tree == NULL)
        return ret;
    ret = safe_malloc(sizeof(*ret));
    {
        yajl_val val = get_val(tree, "IPAddress", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->ip_address = safe_strdup(str ? str : "");
        }
    }

    if (tree->type == yajl_t_object)
    {
        size_t i;
        size_t j = 0;
        size_t cnt = tree->u.object.len;
        yajl_val resi = NULL;

        if (ctx->options & OPT_PARSE_FULLKEY)
        {
            resi = calloc (1, sizeof(*tree));
            if (resi == NULL)
            {
                free_container_inspect_network_settings(ret);
                return NULL;
            }
            resi->type = yajl_t_object;
            resi->u.object.keys = calloc (cnt, sizeof (const char *));
            if (resi->u.object.keys == NULL)
            {
               free_container_inspect_network_settings(ret);
               yajl_tree_free(resi);
               return NULL;
            }
            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
            if (resi->u.object.values == NULL)
            {
               free_container_inspect_network_settings(ret);
               yajl_tree_free(resi);
               return NULL;
            }
        }
        for (i = 0; i < tree->u.object.len; i++)
        {
           if (strcmp(tree->u.object.keys[i], "IPAddress"))
           {
              if (ctx->options & OPT_PARSE_FULLKEY)
              {
                 resi->u.object.keys[j] = tree->u.object.keys[i];
                 tree->u.object.keys[i] = NULL;
                 resi->u.object.values[j] = tree->u.object.values[i];
                 tree->u.object.values[i] = NULL;
                 resi->u.object.len++;
              }
              j++;
           }
        }
        if (ctx->options & OPT_PARSE_STRICT)
        {
            if (j > 0 && ctx->stderr > 0)
                fprintf (ctx->stderr, "WARNING: unknown key found\n");
        }
        if (ctx->options & OPT_PARSE_FULLKEY)
            ret->_residual = resi;
        }
    return ret;
}

void free_container_inspect_network_settings(container_inspect_network_settings *ptr) {
    if (ptr == NULL)
        return;
    free(ptr->ip_address);
    ptr->ip_address = NULL;
    yajl_tree_free (ptr->_residual);
    ptr->_residual = NULL;
    free(ptr);
}

yajl_gen_status gen_container_inspect_network_settings(yajl_gen g, const container_inspect_network_settings *ptr, const struct parser_context *ctx, parser_error *err) {
    yajl_gen_status stat = yajl_gen_status_ok;
    *err = 0;
    stat = yajl_gen_map_open((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->ip_address != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("IPAddress"), strlen("IPAddress"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->ip_address != NULL) {
            str = ptr->ip_address;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if (ptr != NULL && ptr->_residual != NULL)
    {
        stat = gen_yajl_object_residual (ptr->_residual, g, err);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN (stat, err);
    }
    stat = yajl_gen_map_close((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    return yajl_gen_status_ok;
}

container_inspect *make_container_inspect(yajl_val tree, const struct parser_context *ctx, parser_error *err) {
    container_inspect *ret = NULL;
    *err = 0;
    if (tree == NULL)
        return ret;
    ret = safe_malloc(sizeof(*ret));
    {
        yajl_val val = get_val(tree, "Id", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->id = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val val = get_val(tree, "Created", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->created = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val val = get_val(tree, "Path", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->path = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val tmp = get_val(tree, "Args", yajl_t_array);
        if (tmp != NULL && YAJL_GET_ARRAY(tmp) != NULL && YAJL_GET_ARRAY(tmp)->len > 0) {
            size_t i;
            ret->args_len = YAJL_GET_ARRAY(tmp)->len;
            ret->args = safe_malloc((YAJL_GET_ARRAY(tmp)->len + 1) * sizeof(*ret->args));
            for (i = 0; i < YAJL_GET_ARRAY(tmp)->len; i++) {
                yajl_val val = YAJL_GET_ARRAY(tmp)->values[i];
                if (val != NULL) {
                    char *str = YAJL_GET_STRING(val);
                    ret->args[i] = safe_strdup(str ? str : "");
                }
            }
        }
    }
    ret->state = make_container_inspect_state(get_val(tree, "State", yajl_t_object), ctx, err);
    if (ret->state == NULL && *err != 0) {
        free_container_inspect(ret);
        return NULL;
    }
    {
        yajl_val val = get_val(tree, "Image", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->image = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val val = get_val(tree, "ResolvConfPath", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->resolv_conf_path = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val val = get_val(tree, "HostnamePath", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->hostname_path = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val val = get_val(tree, "HostsPath", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->hosts_path = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val val = get_val(tree, "LogPath", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->log_path = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val val = get_val(tree, "Name", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->name = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val val = get_val(tree, "RestartCount", yajl_t_number);
        if (val != NULL) {
            int invalid = common_safe_int(YAJL_GET_NUMBER(val), (int *)&ret->restart_count);
            if (invalid) {
                if (asprintf(err, "Invalid value '%s' with type 'integer' for key 'RestartCount': %s", YAJL_GET_NUMBER(val), strerror(-invalid)) < 0)
                    *err = safe_strdup("error allocating memory");
                free_container_inspect(ret);
                return NULL;
            }
        }
    }
    {
        yajl_val val = get_val(tree, "MountLabel", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->mount_label = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val val = get_val(tree, "ProcessLabel", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->process_label = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val val = get_val(tree, "SeccompProfile", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->seccomp_profile = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val val = get_val(tree, "NoNewPrivileges", yajl_t_true);
        if (val != NULL)
            ret->no_new_privileges = YAJL_IS_TRUE(val);
    }
    ret->host_config = make_host_config(get_val(tree, "HostConfig", yajl_t_object), ctx, err);
    if (ret->host_config == NULL && *err != 0) {
        free_container_inspect(ret);
        return NULL;
    }
    ret->graph_driver = make_container_inspect_graph_driver(get_val(tree, "GraphDriver", yajl_t_object), ctx, err);
    if (ret->graph_driver == NULL && *err != 0) {
        free_container_inspect(ret);
        return NULL;
    }
    {
        yajl_val tmp = get_val(tree, "Mounts", yajl_t_array);
        if (tmp != NULL && YAJL_GET_ARRAY(tmp) != NULL && YAJL_GET_ARRAY(tmp)->len > 0) {
            size_t i;
            ret->mounts_len = YAJL_GET_ARRAY(tmp)->len;
            ret->mounts = safe_malloc((YAJL_GET_ARRAY(tmp)->len + 1) * sizeof(*ret->mounts));
            for (i = 0; i < YAJL_GET_ARRAY(tmp)->len; i++) {
                yajl_val val = YAJL_GET_ARRAY(tmp)->values[i];
                ret->mounts[i] = make_docker_types_mount_point(val, ctx, err);
                if (ret->mounts[i] == NULL) {
                    free_container_inspect(ret);
                    return NULL;
                }
            }
        }
    }
    ret->config = make_container_inspect_config(get_val(tree, "Config", yajl_t_object), ctx, err);
    if (ret->config == NULL && *err != 0) {
        free_container_inspect(ret);
        return NULL;
    }
    ret->network_settings = make_container_inspect_network_settings(get_val(tree, "NetworkSettings", yajl_t_object), ctx, err);
    if (ret->network_settings == NULL && *err != 0) {
        free_container_inspect(ret);
        return NULL;
    }
    if (ret->id == NULL) {
        if (asprintf(err, "Required field '%s' not present",  "Id") < 0)
            *err = safe_strdup("error allocating memory");
        free_container_inspect(ret);
        return NULL;
    }
    if (ret->state == NULL) {
        if (asprintf(err, "Required field '%s' not present",  "State") < 0)
            *err = safe_strdup("error allocating memory");
        free_container_inspect(ret);
        return NULL;
    }
    if (ret->name == NULL) {
        if (asprintf(err, "Required field '%s' not present",  "Name") < 0)
            *err = safe_strdup("error allocating memory");
        free_container_inspect(ret);
        return NULL;
    }
    if (ret->host_config == NULL) {
        if (asprintf(err, "Required field '%s' not present",  "HostConfig") < 0)
            *err = safe_strdup("error allocating memory");
        free_container_inspect(ret);
        return NULL;
    }
    if (ret->network_settings == NULL) {
        if (asprintf(err, "Required field '%s' not present",  "NetworkSettings") < 0)
            *err = safe_strdup("error allocating memory");
        free_container_inspect(ret);
        return NULL;
    }

    if (tree->type == yajl_t_object)
    {
        size_t i;
        size_t j = 0;
        size_t cnt = tree->u.object.len;
        yajl_val resi = NULL;

        if (ctx->options & OPT_PARSE_FULLKEY)
        {
            resi = calloc (1, sizeof(*tree));
            if (resi == NULL)
            {
                free_container_inspect(ret);
                return NULL;
            }
            resi->type = yajl_t_object;
            resi->u.object.keys = calloc (cnt, sizeof (const char *));
            if (resi->u.object.keys == NULL)
            {
               free_container_inspect(ret);
               yajl_tree_free(resi);
               return NULL;
            }
            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
            if (resi->u.object.values == NULL)
            {
               free_container_inspect(ret);
               yajl_tree_free(resi);
               return NULL;
            }
        }
        for (i = 0; i < tree->u.object.len; i++)
        {
           if (strcmp(tree->u.object.keys[i], "Id") &&
                strcmp(tree->u.object.keys[i], "Created") &&
                strcmp(tree->u.object.keys[i], "Path") &&
                strcmp(tree->u.object.keys[i], "Args") &&
                strcmp(tree->u.object.keys[i], "State") &&
                strcmp(tree->u.object.keys[i], "Image") &&
                strcmp(tree->u.object.keys[i], "ResolvConfPath") &&
                strcmp(tree->u.object.keys[i], "HostnamePath") &&
                strcmp(tree->u.object.keys[i], "HostsPath") &&
                strcmp(tree->u.object.keys[i], "LogPath") &&
                strcmp(tree->u.object.keys[i], "Name") &&
                strcmp(tree->u.object.keys[i], "RestartCount") &&
                strcmp(tree->u.object.keys[i], "MountLabel") &&
                strcmp(tree->u.object.keys[i], "ProcessLabel") &&
                strcmp(tree->u.object.keys[i], "SeccompProfile") &&
                strcmp(tree->u.object.keys[i], "NoNewPrivileges") &&
                strcmp(tree->u.object.keys[i], "HostConfig") &&
                strcmp(tree->u.object.keys[i], "GraphDriver") &&
                strcmp(tree->u.object.keys[i], "Mounts") &&
                strcmp(tree->u.object.keys[i], "Config") &&
                strcmp(tree->u.object.keys[i], "NetworkSettings"))
           {
              if (ctx->options & OPT_PARSE_FULLKEY)
              {
                 resi->u.object.keys[j] = tree->u.object.keys[i];
                 tree->u.object.keys[i] = NULL;
                 resi->u.object.values[j] = tree->u.object.values[i];
                 tree->u.object.values[i] = NULL;
                 resi->u.object.len++;
              }
              j++;
           }
        }
        if (ctx->options & OPT_PARSE_STRICT)
        {
            if (j > 0 && ctx->stderr > 0)
                fprintf (ctx->stderr, "WARNING: unknown key found\n");
        }
        if (ctx->options & OPT_PARSE_FULLKEY)
            ret->_residual = resi;
        }
    return ret;
}

void free_container_inspect(container_inspect *ptr) {
    if (ptr == NULL)
        return;
    free(ptr->id);
    ptr->id = NULL;
    free(ptr->created);
    ptr->created = NULL;
    free(ptr->path);
    ptr->path = NULL;
    if (ptr->args != NULL) {
        size_t i;
        for (i = 0; i < ptr->args_len; i++) {
            if (ptr->args[i] != NULL) {
                free(ptr->args[i]);
                ptr->args[i] = NULL;
            }
        }
        free(ptr->args);
        ptr->args = NULL;
    }
    if (ptr->state != NULL) {
        free_container_inspect_state(ptr->state);
        ptr->state = NULL;
    }
    free(ptr->image);
    ptr->image = NULL;
    free(ptr->resolv_conf_path);
    ptr->resolv_conf_path = NULL;
    free(ptr->hostname_path);
    ptr->hostname_path = NULL;
    free(ptr->hosts_path);
    ptr->hosts_path = NULL;
    free(ptr->log_path);
    ptr->log_path = NULL;
    free(ptr->name);
    ptr->name = NULL;
    free(ptr->mount_label);
    ptr->mount_label = NULL;
    free(ptr->process_label);
    ptr->process_label = NULL;
    free(ptr->seccomp_profile);
    ptr->seccomp_profile = NULL;
    if (ptr->host_config != NULL) {
        free_host_config(ptr->host_config);
        ptr->host_config = NULL;
    }
    if (ptr->graph_driver != NULL) {
        free_container_inspect_graph_driver(ptr->graph_driver);
        ptr->graph_driver = NULL;
    }
    if (ptr->mounts != NULL) {
        size_t i;
        for (i = 0; i < ptr->mounts_len; i++)
            if (ptr->mounts[i] != NULL) {
                free_docker_types_mount_point(ptr->mounts[i]);
                ptr->mounts[i] = NULL;
            }
        free(ptr->mounts);
        ptr->mounts = NULL;
    }
    if (ptr->config != NULL) {
        free_container_inspect_config(ptr->config);
        ptr->config = NULL;
    }
    if (ptr->network_settings != NULL) {
        free_container_inspect_network_settings(ptr->network_settings);
        ptr->network_settings = NULL;
    }
    yajl_tree_free (ptr->_residual);
    ptr->_residual = NULL;
    free(ptr);
}

yajl_gen_status gen_container_inspect(yajl_gen g, const container_inspect *ptr, const struct parser_context *ctx, parser_error *err) {
    yajl_gen_status stat = yajl_gen_status_ok;
    *err = 0;
    stat = yajl_gen_map_open((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->id != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("Id"), strlen("Id"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->id != NULL) {
            str = ptr->id;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->created != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("Created"), strlen("Created"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->created != NULL) {
            str = ptr->created;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->path != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("Path"), strlen("Path"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->path != NULL) {
            str = ptr->path;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->args != NULL)) {
        size_t len = 0, i;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("Args"), strlen("Args"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->args != NULL) {
            len = ptr->args_len;
        }
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 0);
        stat = yajl_gen_array_open((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        for (i = 0; i < len; i++) {
            stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(ptr->args[i]), strlen(ptr->args[i]));
            if (yajl_gen_status_ok != stat)
                GEN_SET_ERROR_AND_RETURN(stat, err);
        }
        stat = yajl_gen_array_close((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 1);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->state != NULL)) {
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("State"), strlen("State"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        stat = gen_container_inspect_state(g, ptr != NULL ? ptr->state : NULL, ctx, err);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->image != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("Image"), strlen("Image"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->image != NULL) {
            str = ptr->image;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->resolv_conf_path != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("ResolvConfPath"), strlen("ResolvConfPath"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->resolv_conf_path != NULL) {
            str = ptr->resolv_conf_path;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->hostname_path != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("HostnamePath"), strlen("HostnamePath"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->hostname_path != NULL) {
            str = ptr->hostname_path;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->hosts_path != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("HostsPath"), strlen("HostsPath"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->hosts_path != NULL) {
            str = ptr->hosts_path;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->log_path != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("LogPath"), strlen("LogPath"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->log_path != NULL) {
            str = ptr->log_path;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->name != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("Name"), strlen("Name"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->name != NULL) {
            str = ptr->name;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->restart_count)) {
        long long int num = 0;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("RestartCount"), strlen("RestartCount"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->restart_count) {
            num = (long long int)ptr->restart_count;
        }
        stat = map_int(g, num);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->mount_label != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("MountLabel"), strlen("MountLabel"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->mount_label != NULL) {
            str = ptr->mount_label;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->process_label != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("ProcessLabel"), strlen("ProcessLabel"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->process_label != NULL) {
            str = ptr->process_label;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->seccomp_profile != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("SeccompProfile"), strlen("SeccompProfile"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->seccomp_profile != NULL) {
            str = ptr->seccomp_profile;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->no_new_privileges)) {
        bool b = false;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("NoNewPrivileges"), strlen("NoNewPrivileges"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->no_new_privileges) {
            b = ptr->no_new_privileges;
        }
        stat = yajl_gen_bool((yajl_gen)g, (int)(b));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->host_config != NULL)) {
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("HostConfig"), strlen("HostConfig"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        stat = gen_host_config(g, ptr != NULL ? ptr->host_config : NULL, ctx, err);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->graph_driver != NULL)) {
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("GraphDriver"), strlen("GraphDriver"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        stat = gen_container_inspect_graph_driver(g, ptr != NULL ? ptr->graph_driver : NULL, ctx, err);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->mounts != NULL)) {
        size_t len = 0, i;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("Mounts"), strlen("Mounts"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->mounts != NULL) {
            len = ptr->mounts_len;
        }
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 0);
        stat = yajl_gen_array_open((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        for (i = 0; i < len; i++) {
            stat = gen_docker_types_mount_point(g, ptr->mounts[i], ctx, err);
            if (yajl_gen_status_ok != stat)
                GEN_SET_ERROR_AND_RETURN(stat, err);
        }
        stat = yajl_gen_array_close((yajl_gen)g);
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 1);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->config != NULL)) {
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("Config"), strlen("Config"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        stat = gen_container_inspect_config(g, ptr != NULL ? ptr->config : NULL, ctx, err);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->network_settings != NULL)) {
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("NetworkSettings"), strlen("NetworkSettings"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        stat = gen_container_inspect_network_settings(g, ptr != NULL ? ptr->network_settings : NULL, ctx, err);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if (ptr != NULL && ptr->_residual != NULL)
    {
        stat = gen_yajl_object_residual (ptr->_residual, g, err);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN (stat, err);
    }
    stat = yajl_gen_map_close((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    return yajl_gen_status_ok;
}


container_inspect *container_inspect_parse_file(const char *filename, const struct parser_context *ctx, parser_error *err) {
    container_inspect *ptr = NULL;
    size_t filesize;
    char *content = NULL;

    if (filename == NULL || err == NULL)
        return NULL;

    *err = NULL;
    content = read_file(filename, &filesize);
    if (content == NULL) {
        if (asprintf(err, "cannot read the file: %s", filename) < 0)
            *err = safe_strdup("error allocating memory");
        return NULL;
    }
    ptr = container_inspect_parse_data(content, ctx, err);
    free(content);
    return ptr;
}

container_inspect *container_inspect_parse_file_stream(FILE *stream, const struct parser_context *ctx, parser_error *err) {
    container_inspect *ptr = NULL;
    size_t filesize;
    char *content = NULL ;

    if (stream == NULL || err == NULL)
        return NULL;

    *err = NULL;
    content = fread_file(stream, &filesize);
    if (content == NULL) {
        *err = safe_strdup("cannot read the file");
        return NULL;
    }
    ptr = container_inspect_parse_data(content, ctx, err);
    free(content);
    return ptr;
}

container_inspect *container_inspect_parse_data(const char *jsondata, const struct parser_context *ctx, parser_error *err) {
    container_inspect *ptr = NULL;
    yajl_val tree;
    char errbuf[1024];
    struct parser_context tmp_ctx = { 0 };

    if (jsondata == NULL || err == NULL)
        return NULL;

    *err = NULL;
    if (ctx == NULL) {
       ctx = (const struct parser_context *)(&tmp_ctx);
    }
    tree = yajl_tree_parse(jsondata, errbuf, sizeof(errbuf));
    if (tree == NULL) {
        if (asprintf(err, "cannot parse the data: %s", errbuf) < 0)
            *err = safe_strdup("error allocating memory");
        return NULL;
    }
    ptr = make_container_inspect(tree, ctx, err);
    yajl_tree_free(tree);
    return ptr;
}
char *container_inspect_generate_json(const container_inspect *ptr, const struct parser_context *ctx, parser_error *err) {
    yajl_gen g = NULL;
    struct parser_context tmp_ctx = { 0 };
    const unsigned char *gen_buf = NULL;
    char *json_buf = NULL;
    size_t gen_len = 0;

    if (ptr == NULL || err == NULL)
        return NULL;

    *err = NULL;
    if (ctx == NULL) {
        ctx = (const struct parser_context *)(&tmp_ctx);
    }

    if (!json_gen_init(&g, ctx)) {
        *err = safe_strdup("Json_gen init failed");
        goto out;
    }
    if (yajl_gen_status_ok != gen_container_inspect(g, ptr, ctx, err)) {
        if (*err == NULL)
            *err = safe_strdup("Failed to generate json");
        goto free_out;
    }
    yajl_gen_get_buf(g, &gen_buf, &gen_len);
    if (gen_buf == NULL) {
        *err = safe_strdup("Error to get generated json");
        goto free_out;
    }

    json_buf = safe_malloc(gen_len + 1);
    (void)memcpy(json_buf, gen_buf, gen_len);
    json_buf[gen_len] = '\0';

free_out:
    yajl_gen_clear(g);
    yajl_gen_free(g);
out:
    return json_buf;
}

