// Generated from state.json. Do not edit!
#ifndef _GNU_SOURCE
#define _GNU_SOURCE
#endif
#include <string.h>
#include <read_file.h>
#include "container_state.h"

container_state *make_container_state(yajl_val tree, const struct parser_context *ctx, parser_error *err) {
    container_state *ret = NULL;
    *err = 0;
    if (tree == NULL)
        return ret;
    ret = safe_malloc(sizeof(*ret));
    {
        yajl_val val = get_val(tree, "Dead", yajl_t_true);
        if (val != NULL)
            ret->dead = YAJL_IS_TRUE(val);
    }
    {
        yajl_val val = get_val(tree, "Error", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->error = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val val = get_val(tree, "ExitCode", yajl_t_number);
        if (val != NULL) {
            int invalid = common_safe_int(YAJL_GET_NUMBER(val), (int *)&ret->exit_code);
            if (invalid) {
                if (asprintf(err, "Invalid value '%s' with type 'integer' for key 'ExitCode': %s", YAJL_GET_NUMBER(val), strerror(-invalid)) < 0)
                    *err = safe_strdup("error allocating memory");
                free_container_state(ret);
                return NULL;
            }
        }
    }
    {
        yajl_val val = get_val(tree, "FinishedAt", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->finished_at = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val val = get_val(tree, "OOMKilled", yajl_t_true);
        if (val != NULL)
            ret->oom_killed = YAJL_IS_TRUE(val);
    }
    {
        yajl_val val = get_val(tree, "Paused", yajl_t_true);
        if (val != NULL)
            ret->paused = YAJL_IS_TRUE(val);
    }
    {
        yajl_val val = get_val(tree, "Pid", yajl_t_number);
        if (val != NULL) {
            int invalid = common_safe_int(YAJL_GET_NUMBER(val), (int *)&ret->pid);
            if (invalid) {
                if (asprintf(err, "Invalid value '%s' with type 'integer' for key 'Pid': %s", YAJL_GET_NUMBER(val), strerror(-invalid)) < 0)
                    *err = safe_strdup("error allocating memory");
                free_container_state(ret);
                return NULL;
            }
        }
    }
    {
        yajl_val val = get_val(tree, "PPid", yajl_t_number);
        if (val != NULL) {
            int invalid = common_safe_int(YAJL_GET_NUMBER(val), (int *)&ret->p_pid);
            if (invalid) {
                if (asprintf(err, "Invalid value '%s' with type 'integer' for key 'PPid': %s", YAJL_GET_NUMBER(val), strerror(-invalid)) < 0)
                    *err = safe_strdup("error allocating memory");
                free_container_state(ret);
                return NULL;
            }
        }
    }
    {
        yajl_val val = get_val(tree, "StartTime", yajl_t_number);
        if (val != NULL) {
            int invalid = common_safe_uint64(YAJL_GET_NUMBER(val), &ret->start_time);
            if (invalid) {
                if (asprintf(err, "Invalid value '%s' with type 'uint64' for key 'StartTime': %s", YAJL_GET_NUMBER(val), strerror(-invalid)) < 0)
                    *err = safe_strdup("error allocating memory");
                free_container_state(ret);
                return NULL;
            }
        }
    }
    {
        yajl_val val = get_val(tree, "PStartTime", yajl_t_number);
        if (val != NULL) {
            int invalid = common_safe_uint64(YAJL_GET_NUMBER(val), &ret->p_start_time);
            if (invalid) {
                if (asprintf(err, "Invalid value '%s' with type 'uint64' for key 'PStartTime': %s", YAJL_GET_NUMBER(val), strerror(-invalid)) < 0)
                    *err = safe_strdup("error allocating memory");
                free_container_state(ret);
                return NULL;
            }
        }
    }
    {
        yajl_val val = get_val(tree, "RemovalInprogress", yajl_t_true);
        if (val != NULL)
            ret->removal_inprogress = YAJL_IS_TRUE(val);
    }
    {
        yajl_val val = get_val(tree, "Restarting", yajl_t_true);
        if (val != NULL)
            ret->restarting = YAJL_IS_TRUE(val);
    }
    {
        yajl_val val = get_val(tree, "Running", yajl_t_true);
        if (val != NULL)
            ret->running = YAJL_IS_TRUE(val);
    }
    {
        yajl_val val = get_val(tree, "StartedAt", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->started_at = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val val = get_val(tree, "Starting", yajl_t_true);
        if (val != NULL)
            ret->starting = YAJL_IS_TRUE(val);
    }
    {
        yajl_val val = get_val(tree, "RestartCount", yajl_t_number);
        if (val != NULL) {
            int invalid = common_safe_int(YAJL_GET_NUMBER(val), (int *)&ret->restart_count);
            if (invalid) {
                if (asprintf(err, "Invalid value '%s' with type 'integer' for key 'RestartCount': %s", YAJL_GET_NUMBER(val), strerror(-invalid)) < 0)
                    *err = safe_strdup("error allocating memory");
                free_container_state(ret);
                return NULL;
            }
        }
    }
    {
        yajl_val val = get_val(tree, "HasBeenManuallyStopped", yajl_t_true);
        if (val != NULL)
            ret->has_been_manually_stopped = YAJL_IS_TRUE(val);
    }
    ret->health = make_defs_health(get_val(tree, "Health", yajl_t_object), ctx, err);
    if (ret->health == NULL && *err != 0) {
        free_container_state(ret);
        return NULL;
    }

    if (tree->type == yajl_t_object)
    {
        size_t i;
        size_t j = 0;
        size_t cnt = tree->u.object.len;
        yajl_val resi = NULL;

        if (ctx->options & OPT_PARSE_FULLKEY)
        {
            resi = calloc (1, sizeof(*tree));
            if (resi == NULL)
            {
                free_container_state(ret);
                return NULL;
            }
            resi->type = yajl_t_object;
            resi->u.object.keys = calloc (cnt, sizeof (const char *));
            if (resi->u.object.keys == NULL)
            {
               free_container_state(ret);
               yajl_tree_free(resi);
               return NULL;
            }
            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
            if (resi->u.object.values == NULL)
            {
               free_container_state(ret);
               yajl_tree_free(resi);
               return NULL;
            }
        }
        for (i = 0; i < tree->u.object.len; i++)
        {
           if (strcmp(tree->u.object.keys[i], "Dead") &&
                strcmp(tree->u.object.keys[i], "Error") &&
                strcmp(tree->u.object.keys[i], "ExitCode") &&
                strcmp(tree->u.object.keys[i], "FinishedAt") &&
                strcmp(tree->u.object.keys[i], "OOMKilled") &&
                strcmp(tree->u.object.keys[i], "Paused") &&
                strcmp(tree->u.object.keys[i], "Pid") &&
                strcmp(tree->u.object.keys[i], "PPid") &&
                strcmp(tree->u.object.keys[i], "StartTime") &&
                strcmp(tree->u.object.keys[i], "PStartTime") &&
                strcmp(tree->u.object.keys[i], "RemovalInprogress") &&
                strcmp(tree->u.object.keys[i], "Restarting") &&
                strcmp(tree->u.object.keys[i], "Running") &&
                strcmp(tree->u.object.keys[i], "StartedAt") &&
                strcmp(tree->u.object.keys[i], "Starting") &&
                strcmp(tree->u.object.keys[i], "RestartCount") &&
                strcmp(tree->u.object.keys[i], "HasBeenManuallyStopped") &&
                strcmp(tree->u.object.keys[i], "Health"))
           {
              if (ctx->options & OPT_PARSE_FULLKEY)
              {
                 resi->u.object.keys[j] = tree->u.object.keys[i];
                 tree->u.object.keys[i] = NULL;
                 resi->u.object.values[j] = tree->u.object.values[i];
                 tree->u.object.values[i] = NULL;
                 resi->u.object.len++;
              }
              j++;
           }
        }
        if (ctx->options & OPT_PARSE_STRICT)
        {
            if (j > 0 && ctx->stderr > 0)
                fprintf (ctx->stderr, "WARNING: unknown key found\n");
        }
        if (ctx->options & OPT_PARSE_FULLKEY)
            ret->_residual = resi;
        }
    return ret;
}

void free_container_state(container_state *ptr) {
    if (ptr == NULL)
        return;
    free(ptr->error);
    ptr->error = NULL;
    free(ptr->finished_at);
    ptr->finished_at = NULL;
    free(ptr->started_at);
    ptr->started_at = NULL;
    if (ptr->health != NULL) {
        free_defs_health(ptr->health);
        ptr->health = NULL;
    }
    yajl_tree_free (ptr->_residual);
    ptr->_residual = NULL;
    free(ptr);
}

yajl_gen_status gen_container_state(yajl_gen g, const container_state *ptr, const struct parser_context *ctx, parser_error *err) {
    yajl_gen_status stat = yajl_gen_status_ok;
    *err = 0;
    stat = yajl_gen_map_open((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->dead)) {
        bool b = false;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("Dead"), strlen("Dead"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->dead) {
            b = ptr->dead;
        }
        stat = yajl_gen_bool((yajl_gen)g, (int)(b));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->error != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("Error"), strlen("Error"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->error != NULL) {
            str = ptr->error;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->exit_code)) {
        long long int num = 0;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("ExitCode"), strlen("ExitCode"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->exit_code) {
            num = (long long int)ptr->exit_code;
        }
        stat = map_int(g, num);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->finished_at != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("FinishedAt"), strlen("FinishedAt"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->finished_at != NULL) {
            str = ptr->finished_at;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->oom_killed)) {
        bool b = false;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("OOMKilled"), strlen("OOMKilled"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->oom_killed) {
            b = ptr->oom_killed;
        }
        stat = yajl_gen_bool((yajl_gen)g, (int)(b));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->paused)) {
        bool b = false;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("Paused"), strlen("Paused"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->paused) {
            b = ptr->paused;
        }
        stat = yajl_gen_bool((yajl_gen)g, (int)(b));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->pid)) {
        long long int num = 0;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("Pid"), strlen("Pid"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->pid) {
            num = (long long int)ptr->pid;
        }
        stat = map_int(g, num);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->p_pid)) {
        long long int num = 0;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("PPid"), strlen("PPid"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->p_pid) {
            num = (long long int)ptr->p_pid;
        }
        stat = map_int(g, num);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->start_time)) {
        long long unsigned int num = 0;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("StartTime"), strlen("StartTime"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->start_time) {
            num = (long long unsigned int)ptr->start_time;
        }
        stat = map_uint(g, num);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->p_start_time)) {
        long long unsigned int num = 0;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("PStartTime"), strlen("PStartTime"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->p_start_time) {
            num = (long long unsigned int)ptr->p_start_time;
        }
        stat = map_uint(g, num);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->removal_inprogress)) {
        bool b = false;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("RemovalInprogress"), strlen("RemovalInprogress"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->removal_inprogress) {
            b = ptr->removal_inprogress;
        }
        stat = yajl_gen_bool((yajl_gen)g, (int)(b));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->restarting)) {
        bool b = false;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("Restarting"), strlen("Restarting"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->restarting) {
            b = ptr->restarting;
        }
        stat = yajl_gen_bool((yajl_gen)g, (int)(b));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->running)) {
        bool b = false;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("Running"), strlen("Running"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->running) {
            b = ptr->running;
        }
        stat = yajl_gen_bool((yajl_gen)g, (int)(b));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->started_at != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("StartedAt"), strlen("StartedAt"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->started_at != NULL) {
            str = ptr->started_at;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->starting)) {
        bool b = false;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("Starting"), strlen("Starting"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->starting) {
            b = ptr->starting;
        }
        stat = yajl_gen_bool((yajl_gen)g, (int)(b));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->restart_count)) {
        long long int num = 0;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("RestartCount"), strlen("RestartCount"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->restart_count) {
            num = (long long int)ptr->restart_count;
        }
        stat = map_int(g, num);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->has_been_manually_stopped)) {
        bool b = false;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("HasBeenManuallyStopped"), strlen("HasBeenManuallyStopped"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->has_been_manually_stopped) {
            b = ptr->has_been_manually_stopped;
        }
        stat = yajl_gen_bool((yajl_gen)g, (int)(b));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->health != NULL)) {
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("Health"), strlen("Health"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        stat = gen_defs_health(g, ptr != NULL ? ptr->health : NULL, ctx, err);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if (ptr != NULL && ptr->_residual != NULL)
    {
        stat = gen_yajl_object_residual (ptr->_residual, g, err);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN (stat, err);
    }
    stat = yajl_gen_map_close((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    return yajl_gen_status_ok;
}


container_state *container_state_parse_file(const char *filename, const struct parser_context *ctx, parser_error *err) {
    container_state *ptr = NULL;
    size_t filesize;
    char *content = NULL;

    if (filename == NULL || err == NULL)
        return NULL;

    *err = NULL;
    content = read_file(filename, &filesize);
    if (content == NULL) {
        if (asprintf(err, "cannot read the file: %s", filename) < 0)
            *err = safe_strdup("error allocating memory");
        return NULL;
    }
    ptr = container_state_parse_data(content, ctx, err);
    free(content);
    return ptr;
}

container_state *container_state_parse_file_stream(FILE *stream, const struct parser_context *ctx, parser_error *err) {
    container_state *ptr = NULL;
    size_t filesize;
    char *content = NULL ;

    if (stream == NULL || err == NULL)
        return NULL;

    *err = NULL;
    content = fread_file(stream, &filesize);
    if (content == NULL) {
        *err = safe_strdup("cannot read the file");
        return NULL;
    }
    ptr = container_state_parse_data(content, ctx, err);
    free(content);
    return ptr;
}

container_state *container_state_parse_data(const char *jsondata, const struct parser_context *ctx, parser_error *err) {
    container_state *ptr = NULL;
    yajl_val tree;
    char errbuf[1024];
    struct parser_context tmp_ctx = { 0 };

    if (jsondata == NULL || err == NULL)
        return NULL;

    *err = NULL;
    if (ctx == NULL) {
       ctx = (const struct parser_context *)(&tmp_ctx);
    }
    tree = yajl_tree_parse(jsondata, errbuf, sizeof(errbuf));
    if (tree == NULL) {
        if (asprintf(err, "cannot parse the data: %s", errbuf) < 0)
            *err = safe_strdup("error allocating memory");
        return NULL;
    }
    ptr = make_container_state(tree, ctx, err);
    yajl_tree_free(tree);
    return ptr;
}
char *container_state_generate_json(const container_state *ptr, const struct parser_context *ctx, parser_error *err) {
    yajl_gen g = NULL;
    struct parser_context tmp_ctx = { 0 };
    const unsigned char *gen_buf = NULL;
    char *json_buf = NULL;
    size_t gen_len = 0;

    if (ptr == NULL || err == NULL)
        return NULL;

    *err = NULL;
    if (ctx == NULL) {
        ctx = (const struct parser_context *)(&tmp_ctx);
    }

    if (!json_gen_init(&g, ctx)) {
        *err = safe_strdup("Json_gen init failed");
        goto out;
    }
    if (yajl_gen_status_ok != gen_container_state(g, ptr, ctx, err)) {
        if (*err == NULL)
            *err = safe_strdup("Failed to generate json");
        goto free_out;
    }
    yajl_gen_get_buf(g, &gen_buf, &gen_len);
    if (gen_buf == NULL) {
        *err = safe_strdup("Error to get generated json");
        goto free_out;
    }

    json_buf = safe_malloc(gen_len + 1);
    (void)memcpy(json_buf, gen_buf, gen_len);
    json_buf[gen_len] = '\0';

free_out:
    yajl_gen_clear(g);
    yajl_gen_free(g);
out:
    return json_buf;
}

