// Generated from pod_network.json. Do not edit!
#ifndef _GNU_SOURCE
#define _GNU_SOURCE
#endif
#include <string.h>
#include <read_file.h>
#include "cri_pod_network.h"

cri_pod_network_element *make_cri_pod_network_element(yajl_val tree, const struct parser_context *ctx, parser_error *err) {
    cri_pod_network_element *ret = NULL;
    *err = 0;
    if (tree == NULL)
        return ret;
    ret = safe_malloc(sizeof(*ret));
    {
        yajl_val val = get_val(tree, "name", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->name = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val val = get_val(tree, "interface", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->interface = safe_strdup(str ? str : "");
        }
    }
    return ret;
}

void free_cri_pod_network_element(cri_pod_network_element *ptr) {
    if (ptr == NULL)
        return;
    free(ptr->name);
    ptr->name = NULL;
    free(ptr->interface);
    ptr->interface = NULL;
    free(ptr);
}

yajl_gen_status gen_cri_pod_network_element(yajl_gen g, const cri_pod_network_element *ptr, const struct parser_context *ctx, parser_error *err) {
    yajl_gen_status stat = yajl_gen_status_ok;
    *err = 0;
    stat = yajl_gen_map_open((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->name != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("name"), strlen("name"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->name != NULL) {
            str = ptr->name;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->interface != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("interface"), strlen("interface"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->interface != NULL) {
            str = ptr->interface;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    stat = yajl_gen_map_close((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    return yajl_gen_status_ok;
}



cri_pod_network_element **make_cri_pod_network(yajl_val tree, const struct parser_context *ctx, parser_error *err, size_t *len) {
    cri_pod_network_element **ptr = NULL;
    size_t i, alen;
    if (tree == NULL || err == NULL || !len || YAJL_GET_ARRAY(tree) == NULL)
        return NULL;
    *err = 0;
    alen = YAJL_GET_ARRAY(tree)->len;
    if (alen == 0)
        return NULL;
    ptr = safe_malloc((alen + 1) * sizeof(cri_pod_network_element *));
    for (i = 0; i < alen; i++) {
        yajl_val val = YAJL_GET_ARRAY(tree)->values[i];
        ptr[i] = make_cri_pod_network_element(val, ctx, err);
        if (ptr[i] == NULL) {
            free_cri_pod_network(ptr, alen);
            return NULL;
        }
    }
    *len = alen;
    return ptr;
}


void free_cri_pod_network(cri_pod_network_element **ptr, size_t len) {
    size_t i;

    if (ptr == NULL || len == 0)
        return;

    for (i = 0; i < len; i++) {
        if (ptr[i] != NULL) {
            free_cri_pod_network_element(ptr[i]);
            ptr[i] = NULL;
        }
    }
    free(ptr);
}


yajl_gen_status gen_cri_pod_network(yajl_gen g, const cri_pod_network_element **ptr, size_t len, const struct parser_context *ctx,
                       parser_error *err) {
    yajl_gen_status stat;
    size_t i;
    *err = 0;
    stat = yajl_gen_array_open((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    for (i = 0; i < len; i++) {
        stat = gen_cri_pod_network_element(g, ptr[i], ctx, err);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    stat = yajl_gen_array_close((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    return yajl_gen_status_ok;
}

cri_pod_network_element **cri_pod_network_parse_file(const char *filename, const struct parser_context *ctx, parser_error *err, size_t *len) {
    cri_pod_network_element **ptr = NULL;
    size_t filesize;
    char *content = NULL;

    if (filename == NULL || err == NULL)
        return NULL;

    *err = NULL;
    content = read_file(filename, &filesize);
    if (content == NULL) {
        if (asprintf(err, "cannot read the file: %s", filename) < 0)
            *err = safe_strdup("error allocating memory");
        return NULL;
    }
    ptr = cri_pod_network_parse_data(content, ctx, err, len);
    free(content);
    return ptr;
}

cri_pod_network_element **cri_pod_network_parse_file_stream(FILE *stream, const struct parser_context *ctx, parser_error *err, size_t *len) {
    cri_pod_network_element **ptr = NULL;
    size_t filesize;
    char *content = NULL ;

    if (stream == NULL || err == NULL)
        return NULL;

    *err = NULL;
    content = fread_file(stream, &filesize);
    if (content == NULL) {
        *err = safe_strdup("cannot read the file");
        return NULL;
    }
    ptr = cri_pod_network_parse_data(content, ctx, err, len);
    free(content);
    return ptr;
}

cri_pod_network_element **cri_pod_network_parse_data(const char *jsondata, const struct parser_context *ctx, parser_error *err, size_t *len) {
    cri_pod_network_element **ptr = NULL;
    yajl_val tree;
    char errbuf[1024];
    struct parser_context tmp_ctx = { 0 };

    if (jsondata == NULL || err == NULL)
        return NULL;

    *err = NULL;
    if (ctx == NULL) {
       ctx = (const struct parser_context *)(&tmp_ctx);
    }
    tree = yajl_tree_parse(jsondata, errbuf, sizeof(errbuf));
    if (tree == NULL) {
        if (asprintf(err, "cannot parse the data: %s", errbuf) < 0)
            *err = safe_strdup("error allocating memory");
        return NULL;
    }
    ptr = make_cri_pod_network(tree, ctx, err, len);
    yajl_tree_free(tree);
    return ptr;
}
char *cri_pod_network_generate_json(const cri_pod_network_element **ptr, size_t len, const struct parser_context *ctx, parser_error *err) {
    yajl_gen g = NULL;
    struct parser_context tmp_ctx = { 0 };
    const unsigned char *gen_buf = NULL;
    char *json_buf = NULL;
    size_t gen_len = 0;

    if (ptr == NULL || err == NULL)
        return NULL;

    *err = NULL;
    if (ctx == NULL) {
        ctx = (const struct parser_context *)(&tmp_ctx);
    }

    if (!json_gen_init(&g, ctx)) {
        *err = safe_strdup("Json_gen init failed");
        goto out;
    }
    if (yajl_gen_status_ok != gen_cri_pod_network(g, ptr, len, ctx, err)) {
        if (*err == NULL)
            *err = safe_strdup("Failed to generate json");
        goto free_out;
    }
    yajl_gen_get_buf(g, &gen_buf, &gen_len);
    if (gen_buf == NULL) {
        *err = safe_strdup("Error to get generated json");
        goto free_out;
    }

    json_buf = safe_malloc(gen_len + 1);
    (void)memcpy(json_buf, gen_buf, gen_len);
    json_buf[gen_len] = '\0';

free_out:
    yajl_gen_clear(g);
    yajl_gen_free(g);
out:
    return json_buf;
}

