// Generated from layers.json. Do not edit!
#ifndef _GNU_SOURCE
#define _GNU_SOURCE
#endif
#include <string.h>
#include <read_file.h>
#include "embedded_layers.h"

embedded_layers *make_embedded_layers(yajl_val tree, const struct parser_context *ctx, parser_error *err) {
    embedded_layers *ret = NULL;
    *err = 0;
    if (tree == NULL)
        return ret;
    ret = safe_malloc(sizeof(*ret));
    {
        yajl_val val = get_val(tree, "mediaType", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->media_type = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val val = get_val(tree, "size", yajl_t_number);
        if (val != NULL) {
            int invalid = common_safe_int64(YAJL_GET_NUMBER(val), &ret->size);
            if (invalid) {
                if (asprintf(err, "Invalid value '%s' with type 'int64' for key 'size': %s", YAJL_GET_NUMBER(val), strerror(-invalid)) < 0)
                    *err = safe_strdup("error allocating memory");
                free_embedded_layers(ret);
                return NULL;
            }
        }
    }
    {
        yajl_val val = get_val(tree, "digest", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->digest = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val val = get_val(tree, "pathInHost", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->path_in_host = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val val = get_val(tree, "pathInContainer", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->path_in_container = safe_strdup(str ? str : "");
        }
    }

    if (tree->type == yajl_t_object)
    {
        size_t i;
        size_t j = 0;
        size_t cnt = tree->u.object.len;
        yajl_val resi = NULL;

        if (ctx->options & OPT_PARSE_FULLKEY)
        {
            resi = calloc (1, sizeof(*tree));
            if (resi == NULL)
            {
                free_embedded_layers(ret);
                return NULL;
            }
            resi->type = yajl_t_object;
            resi->u.object.keys = calloc (cnt, sizeof (const char *));
            if (resi->u.object.keys == NULL)
            {
               free_embedded_layers(ret);
               yajl_tree_free(resi);
               return NULL;
            }
            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
            if (resi->u.object.values == NULL)
            {
               free_embedded_layers(ret);
               yajl_tree_free(resi);
               return NULL;
            }
        }
        for (i = 0; i < tree->u.object.len; i++)
        {
           if (strcmp(tree->u.object.keys[i], "mediaType") &&
                strcmp(tree->u.object.keys[i], "size") &&
                strcmp(tree->u.object.keys[i], "digest") &&
                strcmp(tree->u.object.keys[i], "pathInHost") &&
                strcmp(tree->u.object.keys[i], "pathInContainer"))
           {
              if (ctx->options & OPT_PARSE_FULLKEY)
              {
                 resi->u.object.keys[j] = tree->u.object.keys[i];
                 tree->u.object.keys[i] = NULL;
                 resi->u.object.values[j] = tree->u.object.values[i];
                 tree->u.object.values[i] = NULL;
                 resi->u.object.len++;
              }
              j++;
           }
        }
        if (ctx->options & OPT_PARSE_STRICT)
        {
            if (j > 0 && ctx->stderr > 0)
                fprintf (ctx->stderr, "WARNING: unknown key found\n");
        }
        if (ctx->options & OPT_PARSE_FULLKEY)
            ret->_residual = resi;
        }
    return ret;
}

void free_embedded_layers(embedded_layers *ptr) {
    if (ptr == NULL)
        return;
    free(ptr->media_type);
    ptr->media_type = NULL;
    free(ptr->digest);
    ptr->digest = NULL;
    free(ptr->path_in_host);
    ptr->path_in_host = NULL;
    free(ptr->path_in_container);
    ptr->path_in_container = NULL;
    yajl_tree_free (ptr->_residual);
    ptr->_residual = NULL;
    free(ptr);
}

yajl_gen_status gen_embedded_layers(yajl_gen g, const embedded_layers *ptr, const struct parser_context *ctx, parser_error *err) {
    yajl_gen_status stat = yajl_gen_status_ok;
    *err = 0;
    stat = yajl_gen_map_open((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->media_type != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("mediaType"), strlen("mediaType"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->media_type != NULL) {
            str = ptr->media_type;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->size)) {
        long long int num = 0;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("size"), strlen("size"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->size) {
            num = (long long int)ptr->size;
        }
        stat = map_int(g, num);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->digest != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("digest"), strlen("digest"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->digest != NULL) {
            str = ptr->digest;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->path_in_host != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("pathInHost"), strlen("pathInHost"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->path_in_host != NULL) {
            str = ptr->path_in_host;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->path_in_container != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("pathInContainer"), strlen("pathInContainer"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->path_in_container != NULL) {
            str = ptr->path_in_container;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if (ptr != NULL && ptr->_residual != NULL)
    {
        stat = gen_yajl_object_residual (ptr->_residual, g, err);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN (stat, err);
    }
    stat = yajl_gen_map_close((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    return yajl_gen_status_ok;
}


embedded_layers *embedded_layers_parse_file(const char *filename, const struct parser_context *ctx, parser_error *err) {
    embedded_layers *ptr = NULL;
    size_t filesize;
    char *content = NULL;

    if (filename == NULL || err == NULL)
        return NULL;

    *err = NULL;
    content = read_file(filename, &filesize);
    if (content == NULL) {
        if (asprintf(err, "cannot read the file: %s", filename) < 0)
            *err = safe_strdup("error allocating memory");
        return NULL;
    }
    ptr = embedded_layers_parse_data(content, ctx, err);
    free(content);
    return ptr;
}

embedded_layers *embedded_layers_parse_file_stream(FILE *stream, const struct parser_context *ctx, parser_error *err) {
    embedded_layers *ptr = NULL;
    size_t filesize;
    char *content = NULL ;

    if (stream == NULL || err == NULL)
        return NULL;

    *err = NULL;
    content = fread_file(stream, &filesize);
    if (content == NULL) {
        *err = safe_strdup("cannot read the file");
        return NULL;
    }
    ptr = embedded_layers_parse_data(content, ctx, err);
    free(content);
    return ptr;
}

embedded_layers *embedded_layers_parse_data(const char *jsondata, const struct parser_context *ctx, parser_error *err) {
    embedded_layers *ptr = NULL;
    yajl_val tree;
    char errbuf[1024];
    struct parser_context tmp_ctx = { 0 };

    if (jsondata == NULL || err == NULL)
        return NULL;

    *err = NULL;
    if (ctx == NULL) {
       ctx = (const struct parser_context *)(&tmp_ctx);
    }
    tree = yajl_tree_parse(jsondata, errbuf, sizeof(errbuf));
    if (tree == NULL) {
        if (asprintf(err, "cannot parse the data: %s", errbuf) < 0)
            *err = safe_strdup("error allocating memory");
        return NULL;
    }
    ptr = make_embedded_layers(tree, ctx, err);
    yajl_tree_free(tree);
    return ptr;
}
char *embedded_layers_generate_json(const embedded_layers *ptr, const struct parser_context *ctx, parser_error *err) {
    yajl_gen g = NULL;
    struct parser_context tmp_ctx = { 0 };
    const unsigned char *gen_buf = NULL;
    char *json_buf = NULL;
    size_t gen_len = 0;

    if (ptr == NULL || err == NULL)
        return NULL;

    *err = NULL;
    if (ctx == NULL) {
        ctx = (const struct parser_context *)(&tmp_ctx);
    }

    if (!json_gen_init(&g, ctx)) {
        *err = safe_strdup("Json_gen init failed");
        goto out;
    }
    if (yajl_gen_status_ok != gen_embedded_layers(g, ptr, ctx, err)) {
        if (*err == NULL)
            *err = safe_strdup("Failed to generate json");
        goto free_out;
    }
    yajl_gen_get_buf(g, &gen_buf, &gen_len);
    if (gen_buf == NULL) {
        *err = safe_strdup("Error to get generated json");
        goto free_out;
    }

    json_buf = safe_malloc(gen_len + 1);
    (void)memcpy(json_buf, gen_buf, gen_len);
    json_buf[gen_len] = '\0';

free_out:
    yajl_gen_clear(g);
    yajl_gen_free(g);
out:
    return json_buf;
}

