// Generated from host-config.json. Do not edit!
#ifndef _GNU_SOURCE
#define _GNU_SOURCE
#endif
#include <string.h>
#include <read_file.h>
#include "host_config.h"

host_config_restart_policy *make_host_config_restart_policy(yajl_val tree, const struct parser_context *ctx, parser_error *err) {
    host_config_restart_policy *ret = NULL;
    *err = 0;
    if (tree == NULL)
        return ret;
    ret = safe_malloc(sizeof(*ret));
    {
        yajl_val val = get_val(tree, "Name", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->name = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val val = get_val(tree, "MaximumRetryCount", yajl_t_number);
        if (val != NULL) {
            int invalid = common_safe_int(YAJL_GET_NUMBER(val), (int *)&ret->maximum_retry_count);
            if (invalid) {
                if (asprintf(err, "Invalid value '%s' with type 'integer' for key 'MaximumRetryCount': %s", YAJL_GET_NUMBER(val), strerror(-invalid)) < 0)
                    *err = safe_strdup("error allocating memory");
                free_host_config_restart_policy(ret);
                return NULL;
            }
        }
    }

    if (tree->type == yajl_t_object)
    {
        size_t i;
        size_t j = 0;
        size_t cnt = tree->u.object.len;
        yajl_val resi = NULL;

        if (ctx->options & OPT_PARSE_FULLKEY)
        {
            resi = calloc (1, sizeof(*tree));
            if (resi == NULL)
            {
                free_host_config_restart_policy(ret);
                return NULL;
            }
            resi->type = yajl_t_object;
            resi->u.object.keys = calloc (cnt, sizeof (const char *));
            if (resi->u.object.keys == NULL)
            {
               free_host_config_restart_policy(ret);
               yajl_tree_free(resi);
               return NULL;
            }
            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
            if (resi->u.object.values == NULL)
            {
               free_host_config_restart_policy(ret);
               yajl_tree_free(resi);
               return NULL;
            }
        }
        for (i = 0; i < tree->u.object.len; i++)
        {
           if (strcmp(tree->u.object.keys[i], "Name") &&
                strcmp(tree->u.object.keys[i], "MaximumRetryCount"))
           {
              if (ctx->options & OPT_PARSE_FULLKEY)
              {
                 resi->u.object.keys[j] = tree->u.object.keys[i];
                 tree->u.object.keys[i] = NULL;
                 resi->u.object.values[j] = tree->u.object.values[i];
                 tree->u.object.values[i] = NULL;
                 resi->u.object.len++;
              }
              j++;
           }
        }
        if (ctx->options & OPT_PARSE_STRICT)
        {
            if (j > 0 && ctx->stderr > 0)
                fprintf (ctx->stderr, "WARNING: unknown key found\n");
        }
        if (ctx->options & OPT_PARSE_FULLKEY)
            ret->_residual = resi;
        }
    return ret;
}

void free_host_config_restart_policy(host_config_restart_policy *ptr) {
    if (ptr == NULL)
        return;
    free(ptr->name);
    ptr->name = NULL;
    yajl_tree_free (ptr->_residual);
    ptr->_residual = NULL;
    free(ptr);
}

yajl_gen_status gen_host_config_restart_policy(yajl_gen g, const host_config_restart_policy *ptr, const struct parser_context *ctx, parser_error *err) {
    yajl_gen_status stat = yajl_gen_status_ok;
    *err = 0;
    stat = yajl_gen_map_open((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->name != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("Name"), strlen("Name"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->name != NULL) {
            str = ptr->name;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->maximum_retry_count)) {
        long long int num = 0;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("MaximumRetryCount"), strlen("MaximumRetryCount"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->maximum_retry_count) {
            num = (long long int)ptr->maximum_retry_count;
        }
        stat = map_int(g, num);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if (ptr != NULL && ptr->_residual != NULL)
    {
        stat = gen_yajl_object_residual (ptr->_residual, g, err);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN (stat, err);
    }
    stat = yajl_gen_map_close((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    return yajl_gen_status_ok;
}

host_config_devices_element *make_host_config_devices_element(yajl_val tree, const struct parser_context *ctx, parser_error *err) {
    host_config_devices_element *ret = NULL;
    *err = 0;
    if (tree == NULL)
        return ret;
    ret = safe_malloc(sizeof(*ret));
    {
        yajl_val val = get_val(tree, "CgroupPermissions", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->cgroup_permissions = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val val = get_val(tree, "PathInContainer", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->path_in_container = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val val = get_val(tree, "PathOnHost", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->path_on_host = safe_strdup(str ? str : "");
        }
    }
    return ret;
}

void free_host_config_devices_element(host_config_devices_element *ptr) {
    if (ptr == NULL)
        return;
    free(ptr->cgroup_permissions);
    ptr->cgroup_permissions = NULL;
    free(ptr->path_in_container);
    ptr->path_in_container = NULL;
    free(ptr->path_on_host);
    ptr->path_on_host = NULL;
    free(ptr);
}

yajl_gen_status gen_host_config_devices_element(yajl_gen g, const host_config_devices_element *ptr, const struct parser_context *ctx, parser_error *err) {
    yajl_gen_status stat = yajl_gen_status_ok;
    *err = 0;
    stat = yajl_gen_map_open((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->cgroup_permissions != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("CgroupPermissions"), strlen("CgroupPermissions"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->cgroup_permissions != NULL) {
            str = ptr->cgroup_permissions;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->path_in_container != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("PathInContainer"), strlen("PathInContainer"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->path_in_container != NULL) {
            str = ptr->path_in_container;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->path_on_host != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("PathOnHost"), strlen("PathOnHost"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->path_on_host != NULL) {
            str = ptr->path_on_host;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    stat = yajl_gen_map_close((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    return yajl_gen_status_ok;
}

host_config_ulimits_element *make_host_config_ulimits_element(yajl_val tree, const struct parser_context *ctx, parser_error *err) {
    host_config_ulimits_element *ret = NULL;
    *err = 0;
    if (tree == NULL)
        return ret;
    ret = safe_malloc(sizeof(*ret));
    {
        yajl_val val = get_val(tree, "Name", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->name = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val val = get_val(tree, "Hard", yajl_t_number);
        if (val != NULL) {
            int invalid = common_safe_int64(YAJL_GET_NUMBER(val), &ret->hard);
            if (invalid) {
                if (asprintf(err, "Invalid value '%s' with type 'int64' for key 'Hard': %s", YAJL_GET_NUMBER(val), strerror(-invalid)) < 0)
                    *err = safe_strdup("error allocating memory");
                free_host_config_ulimits_element(ret);
                return NULL;
            }
        }
    }
    {
        yajl_val val = get_val(tree, "Soft", yajl_t_number);
        if (val != NULL) {
            int invalid = common_safe_int64(YAJL_GET_NUMBER(val), &ret->soft);
            if (invalid) {
                if (asprintf(err, "Invalid value '%s' with type 'int64' for key 'Soft': %s", YAJL_GET_NUMBER(val), strerror(-invalid)) < 0)
                    *err = safe_strdup("error allocating memory");
                free_host_config_ulimits_element(ret);
                return NULL;
            }
        }
    }
    return ret;
}

void free_host_config_ulimits_element(host_config_ulimits_element *ptr) {
    if (ptr == NULL)
        return;
    free(ptr->name);
    ptr->name = NULL;
    free(ptr);
}

yajl_gen_status gen_host_config_ulimits_element(yajl_gen g, const host_config_ulimits_element *ptr, const struct parser_context *ctx, parser_error *err) {
    yajl_gen_status stat = yajl_gen_status_ok;
    *err = 0;
    stat = yajl_gen_map_open((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->name != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("Name"), strlen("Name"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->name != NULL) {
            str = ptr->name;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->hard)) {
        long long int num = 0;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("Hard"), strlen("Hard"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->hard) {
            num = (long long int)ptr->hard;
        }
        stat = map_int(g, num);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->soft)) {
        long long int num = 0;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("Soft"), strlen("Soft"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->soft) {
            num = (long long int)ptr->soft;
        }
        stat = map_int(g, num);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    stat = yajl_gen_map_close((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    return yajl_gen_status_ok;
}

host_config_hugetlbs_element *make_host_config_hugetlbs_element(yajl_val tree, const struct parser_context *ctx, parser_error *err) {
    host_config_hugetlbs_element *ret = NULL;
    *err = 0;
    if (tree == NULL)
        return ret;
    ret = safe_malloc(sizeof(*ret));
    {
        yajl_val val = get_val(tree, "PageSize", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->page_size = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val val = get_val(tree, "Limit", yajl_t_number);
        if (val != NULL) {
            int invalid = common_safe_uint64(YAJL_GET_NUMBER(val), &ret->limit);
            if (invalid) {
                if (asprintf(err, "Invalid value '%s' with type 'uint64' for key 'Limit': %s", YAJL_GET_NUMBER(val), strerror(-invalid)) < 0)
                    *err = safe_strdup("error allocating memory");
                free_host_config_hugetlbs_element(ret);
                return NULL;
            }
        }
    }
    return ret;
}

void free_host_config_hugetlbs_element(host_config_hugetlbs_element *ptr) {
    if (ptr == NULL)
        return;
    free(ptr->page_size);
    ptr->page_size = NULL;
    free(ptr);
}

yajl_gen_status gen_host_config_hugetlbs_element(yajl_gen g, const host_config_hugetlbs_element *ptr, const struct parser_context *ctx, parser_error *err) {
    yajl_gen_status stat = yajl_gen_status_ok;
    *err = 0;
    stat = yajl_gen_map_open((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->page_size != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("PageSize"), strlen("PageSize"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->page_size != NULL) {
            str = ptr->page_size;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->limit)) {
        long long unsigned int num = 0;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("Limit"), strlen("Limit"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->limit) {
            num = (long long unsigned int)ptr->limit;
        }
        stat = map_uint(g, num);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    stat = yajl_gen_map_close((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    return yajl_gen_status_ok;
}

host_config_host_channel *make_host_config_host_channel(yajl_val tree, const struct parser_context *ctx, parser_error *err) {
    host_config_host_channel *ret = NULL;
    *err = 0;
    if (tree == NULL)
        return ret;
    ret = safe_malloc(sizeof(*ret));
    {
        yajl_val val = get_val(tree, "PathOnHost", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->path_on_host = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val val = get_val(tree, "PathInContainer", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->path_in_container = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val val = get_val(tree, "Permissions", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->permissions = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val val = get_val(tree, "Size", yajl_t_number);
        if (val != NULL) {
            int invalid = common_safe_uint64(YAJL_GET_NUMBER(val), &ret->size);
            if (invalid) {
                if (asprintf(err, "Invalid value '%s' with type 'uint64' for key 'Size': %s", YAJL_GET_NUMBER(val), strerror(-invalid)) < 0)
                    *err = safe_strdup("error allocating memory");
                free_host_config_host_channel(ret);
                return NULL;
            }
        }
    }

    if (tree->type == yajl_t_object)
    {
        size_t i;
        size_t j = 0;
        size_t cnt = tree->u.object.len;
        yajl_val resi = NULL;

        if (ctx->options & OPT_PARSE_FULLKEY)
        {
            resi = calloc (1, sizeof(*tree));
            if (resi == NULL)
            {
                free_host_config_host_channel(ret);
                return NULL;
            }
            resi->type = yajl_t_object;
            resi->u.object.keys = calloc (cnt, sizeof (const char *));
            if (resi->u.object.keys == NULL)
            {
               free_host_config_host_channel(ret);
               yajl_tree_free(resi);
               return NULL;
            }
            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
            if (resi->u.object.values == NULL)
            {
               free_host_config_host_channel(ret);
               yajl_tree_free(resi);
               return NULL;
            }
        }
        for (i = 0; i < tree->u.object.len; i++)
        {
           if (strcmp(tree->u.object.keys[i], "PathOnHost") &&
                strcmp(tree->u.object.keys[i], "PathInContainer") &&
                strcmp(tree->u.object.keys[i], "Permissions") &&
                strcmp(tree->u.object.keys[i], "Size"))
           {
              if (ctx->options & OPT_PARSE_FULLKEY)
              {
                 resi->u.object.keys[j] = tree->u.object.keys[i];
                 tree->u.object.keys[i] = NULL;
                 resi->u.object.values[j] = tree->u.object.values[i];
                 tree->u.object.values[i] = NULL;
                 resi->u.object.len++;
              }
              j++;
           }
        }
        if (ctx->options & OPT_PARSE_STRICT)
        {
            if (j > 0 && ctx->stderr > 0)
                fprintf (ctx->stderr, "WARNING: unknown key found\n");
        }
        if (ctx->options & OPT_PARSE_FULLKEY)
            ret->_residual = resi;
        }
    return ret;
}

void free_host_config_host_channel(host_config_host_channel *ptr) {
    if (ptr == NULL)
        return;
    free(ptr->path_on_host);
    ptr->path_on_host = NULL;
    free(ptr->path_in_container);
    ptr->path_in_container = NULL;
    free(ptr->permissions);
    ptr->permissions = NULL;
    yajl_tree_free (ptr->_residual);
    ptr->_residual = NULL;
    free(ptr);
}

yajl_gen_status gen_host_config_host_channel(yajl_gen g, const host_config_host_channel *ptr, const struct parser_context *ctx, parser_error *err) {
    yajl_gen_status stat = yajl_gen_status_ok;
    *err = 0;
    stat = yajl_gen_map_open((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->path_on_host != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("PathOnHost"), strlen("PathOnHost"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->path_on_host != NULL) {
            str = ptr->path_on_host;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->path_in_container != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("PathInContainer"), strlen("PathInContainer"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->path_in_container != NULL) {
            str = ptr->path_in_container;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->permissions != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("Permissions"), strlen("Permissions"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->permissions != NULL) {
            str = ptr->permissions;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->size)) {
        long long unsigned int num = 0;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("Size"), strlen("Size"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->size) {
            num = (long long unsigned int)ptr->size;
        }
        stat = map_uint(g, num);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if (ptr != NULL && ptr->_residual != NULL)
    {
        stat = gen_yajl_object_residual (ptr->_residual, g, err);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN (stat, err);
    }
    stat = yajl_gen_map_close((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    return yajl_gen_status_ok;
}

host_config *make_host_config(yajl_val tree, const struct parser_context *ctx, parser_error *err) {
    host_config *ret = NULL;
    *err = 0;
    if (tree == NULL)
        return ret;
    ret = safe_malloc(sizeof(*ret));
    {
        yajl_val tmp = get_val(tree, "VolumesFrom", yajl_t_array);
        if (tmp != NULL && YAJL_GET_ARRAY(tmp) != NULL && YAJL_GET_ARRAY(tmp)->len > 0) {
            size_t i;
            ret->volumes_from_len = YAJL_GET_ARRAY(tmp)->len;
            ret->volumes_from = safe_malloc((YAJL_GET_ARRAY(tmp)->len + 1) * sizeof(*ret->volumes_from));
            for (i = 0; i < YAJL_GET_ARRAY(tmp)->len; i++) {
                yajl_val val = YAJL_GET_ARRAY(tmp)->values[i];
                if (val != NULL) {
                    char *str = YAJL_GET_STRING(val);
                    ret->volumes_from[i] = safe_strdup(str ? str : "");
                }
            }
        }
    }
    {
        yajl_val tmp = get_val(tree, "Binds", yajl_t_array);
        if (tmp != NULL && YAJL_GET_ARRAY(tmp) != NULL && YAJL_GET_ARRAY(tmp)->len > 0) {
            size_t i;
            ret->binds_len = YAJL_GET_ARRAY(tmp)->len;
            ret->binds = safe_malloc((YAJL_GET_ARRAY(tmp)->len + 1) * sizeof(*ret->binds));
            for (i = 0; i < YAJL_GET_ARRAY(tmp)->len; i++) {
                yajl_val val = YAJL_GET_ARRAY(tmp)->values[i];
                if (val != NULL) {
                    char *str = YAJL_GET_STRING(val);
                    ret->binds[i] = safe_strdup(str ? str : "");
                }
            }
        }
    }
    {
        yajl_val tmp = get_val(tree, "Mounts", yajl_t_array);
        if (tmp != NULL && YAJL_GET_ARRAY(tmp) != NULL && YAJL_GET_ARRAY(tmp)->len > 0) {
            size_t i;
            ret->mounts_len = YAJL_GET_ARRAY(tmp)->len;
            ret->mounts = safe_malloc((YAJL_GET_ARRAY(tmp)->len + 1) * sizeof(*ret->mounts));
            for (i = 0; i < YAJL_GET_ARRAY(tmp)->len; i++) {
                yajl_val val = YAJL_GET_ARRAY(tmp)->values[i];
                ret->mounts[i] = make_mount_spec(val, ctx, err);
                if (ret->mounts[i] == NULL) {
                    free_host_config(ret);
                    return NULL;
                }
            }
        }
    }
    {
        yajl_val val = get_val(tree, "NetworkMode", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->network_mode = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val tmp = get_val(tree, "GroupAdd", yajl_t_array);
        if (tmp != NULL && YAJL_GET_ARRAY(tmp) != NULL && YAJL_GET_ARRAY(tmp)->len > 0) {
            size_t i;
            ret->group_add_len = YAJL_GET_ARRAY(tmp)->len;
            ret->group_add = safe_malloc((YAJL_GET_ARRAY(tmp)->len + 1) * sizeof(*ret->group_add));
            for (i = 0; i < YAJL_GET_ARRAY(tmp)->len; i++) {
                yajl_val val = YAJL_GET_ARRAY(tmp)->values[i];
                if (val != NULL) {
                    char *str = YAJL_GET_STRING(val);
                    ret->group_add[i] = safe_strdup(str ? str : "");
                }
            }
        }
    }
    {
        yajl_val val = get_val(tree, "IpcMode", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->ipc_mode = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val val = get_val(tree, "PidMode", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->pid_mode = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val val = get_val(tree, "Privileged", yajl_t_true);
        if (val != NULL)
            ret->privileged = YAJL_IS_TRUE(val);
    }
    {
        yajl_val val = get_val(tree, "SystemContainer", yajl_t_true);
        if (val != NULL)
            ret->system_container = YAJL_IS_TRUE(val);
    }
    {
        yajl_val tmp = get_val(tree, "NsChangeFiles", yajl_t_array);
        if (tmp != NULL && YAJL_GET_ARRAY(tmp) != NULL && YAJL_GET_ARRAY(tmp)->len > 0) {
            size_t i;
            ret->ns_change_files_len = YAJL_GET_ARRAY(tmp)->len;
            ret->ns_change_files = safe_malloc((YAJL_GET_ARRAY(tmp)->len + 1) * sizeof(*ret->ns_change_files));
            for (i = 0; i < YAJL_GET_ARRAY(tmp)->len; i++) {
                yajl_val val = YAJL_GET_ARRAY(tmp)->values[i];
                if (val != NULL) {
                    char *str = YAJL_GET_STRING(val);
                    ret->ns_change_files[i] = safe_strdup(str ? str : "");
                }
            }
        }
    }
    {
        yajl_val val = get_val(tree, "UserRemap", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->user_remap = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val val = get_val(tree, "ShmSize", yajl_t_number);
        if (val != NULL) {
            int invalid = common_safe_int64(YAJL_GET_NUMBER(val), &ret->shm_size);
            if (invalid) {
                if (asprintf(err, "Invalid value '%s' with type 'int64' for key 'ShmSize': %s", YAJL_GET_NUMBER(val), strerror(-invalid)) < 0)
                    *err = safe_strdup("error allocating memory");
                free_host_config(ret);
                return NULL;
            }
        }
    }
    {
        yajl_val val = get_val(tree, "AutoRemove", yajl_t_true);
        if (val != NULL)
            ret->auto_remove = YAJL_IS_TRUE(val);
    }
    {
        yajl_val val = get_val(tree, "AutoRemoveBak", yajl_t_true);
        if (val != NULL)
            ret->auto_remove_bak = YAJL_IS_TRUE(val);
    }
    {
        yajl_val val = get_val(tree, "ReadonlyRootfs", yajl_t_true);
        if (val != NULL)
            ret->readonly_rootfs = YAJL_IS_TRUE(val);
    }
    {
        yajl_val tmp = get_val(tree, "Tmpfs", yajl_t_object);
        if (tmp != NULL) {
            ret->tmpfs = make_json_map_string_string(tmp, ctx, err);
            if (ret->tmpfs == NULL) {
                char *new_error = NULL;
                if (asprintf(&new_error, "Value error for key 'Tmpfs': %s", *err ? *err : "null") < 0) {
                    new_error = safe_strdup("error allocating memory");
                }
                free(*err);
                *err = new_error;
                free_host_config(ret);
                return NULL;
            }
        }
    }
    {
        yajl_val val = get_val(tree, "UTSMode", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->uts_mode = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val val = get_val(tree, "UsernsMode", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->userns_mode = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val tmp = get_val(tree, "Sysctls", yajl_t_object);
        if (tmp != NULL) {
            ret->sysctls = make_json_map_string_string(tmp, ctx, err);
            if (ret->sysctls == NULL) {
                char *new_error = NULL;
                if (asprintf(&new_error, "Value error for key 'Sysctls': %s", *err ? *err : "null") < 0) {
                    new_error = safe_strdup("error allocating memory");
                }
                free(*err);
                *err = new_error;
                free_host_config(ret);
                return NULL;
            }
        }
    }
    {
        yajl_val val = get_val(tree, "Runtime", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->runtime = safe_strdup(str ? str : "");
        }
    }
    ret->restart_policy = make_host_config_restart_policy(get_val(tree, "RestartPolicy", yajl_t_object), ctx, err);
    if (ret->restart_policy == NULL && *err != 0) {
        free_host_config(ret);
        return NULL;
    }
    {
        yajl_val tmp = get_val(tree, "CapAdd", yajl_t_array);
        if (tmp != NULL && YAJL_GET_ARRAY(tmp) != NULL && YAJL_GET_ARRAY(tmp)->len > 0) {
            size_t i;
            ret->cap_add_len = YAJL_GET_ARRAY(tmp)->len;
            ret->cap_add = safe_malloc((YAJL_GET_ARRAY(tmp)->len + 1) * sizeof(*ret->cap_add));
            for (i = 0; i < YAJL_GET_ARRAY(tmp)->len; i++) {
                yajl_val val = YAJL_GET_ARRAY(tmp)->values[i];
                if (val != NULL) {
                    char *str = YAJL_GET_STRING(val);
                    ret->cap_add[i] = safe_strdup(str ? str : "");
                }
            }
        }
    }
    {
        yajl_val tmp = get_val(tree, "CapDrop", yajl_t_array);
        if (tmp != NULL && YAJL_GET_ARRAY(tmp) != NULL && YAJL_GET_ARRAY(tmp)->len > 0) {
            size_t i;
            ret->cap_drop_len = YAJL_GET_ARRAY(tmp)->len;
            ret->cap_drop = safe_malloc((YAJL_GET_ARRAY(tmp)->len + 1) * sizeof(*ret->cap_drop));
            for (i = 0; i < YAJL_GET_ARRAY(tmp)->len; i++) {
                yajl_val val = YAJL_GET_ARRAY(tmp)->values[i];
                if (val != NULL) {
                    char *str = YAJL_GET_STRING(val);
                    ret->cap_drop[i] = safe_strdup(str ? str : "");
                }
            }
        }
    }
    {
        yajl_val tmp = get_val(tree, "Dns", yajl_t_array);
        if (tmp != NULL && YAJL_GET_ARRAY(tmp) != NULL && YAJL_GET_ARRAY(tmp)->len > 0) {
            size_t i;
            ret->dns_len = YAJL_GET_ARRAY(tmp)->len;
            ret->dns = safe_malloc((YAJL_GET_ARRAY(tmp)->len + 1) * sizeof(*ret->dns));
            for (i = 0; i < YAJL_GET_ARRAY(tmp)->len; i++) {
                yajl_val val = YAJL_GET_ARRAY(tmp)->values[i];
                if (val != NULL) {
                    char *str = YAJL_GET_STRING(val);
                    ret->dns[i] = safe_strdup(str ? str : "");
                }
            }
        }
    }
    {
        yajl_val tmp = get_val(tree, "DnsOptions", yajl_t_array);
        if (tmp != NULL && YAJL_GET_ARRAY(tmp) != NULL && YAJL_GET_ARRAY(tmp)->len > 0) {
            size_t i;
            ret->dns_options_len = YAJL_GET_ARRAY(tmp)->len;
            ret->dns_options = safe_malloc((YAJL_GET_ARRAY(tmp)->len + 1) * sizeof(*ret->dns_options));
            for (i = 0; i < YAJL_GET_ARRAY(tmp)->len; i++) {
                yajl_val val = YAJL_GET_ARRAY(tmp)->values[i];
                if (val != NULL) {
                    char *str = YAJL_GET_STRING(val);
                    ret->dns_options[i] = safe_strdup(str ? str : "");
                }
            }
        }
    }
    {
        yajl_val tmp = get_val(tree, "DnsSearch", yajl_t_array);
        if (tmp != NULL && YAJL_GET_ARRAY(tmp) != NULL && YAJL_GET_ARRAY(tmp)->len > 0) {
            size_t i;
            ret->dns_search_len = YAJL_GET_ARRAY(tmp)->len;
            ret->dns_search = safe_malloc((YAJL_GET_ARRAY(tmp)->len + 1) * sizeof(*ret->dns_search));
            for (i = 0; i < YAJL_GET_ARRAY(tmp)->len; i++) {
                yajl_val val = YAJL_GET_ARRAY(tmp)->values[i];
                if (val != NULL) {
                    char *str = YAJL_GET_STRING(val);
                    ret->dns_search[i] = safe_strdup(str ? str : "");
                }
            }
        }
    }
    {
        yajl_val tmp = get_val(tree, "ExtraHosts", yajl_t_array);
        if (tmp != NULL && YAJL_GET_ARRAY(tmp) != NULL && YAJL_GET_ARRAY(tmp)->len > 0) {
            size_t i;
            ret->extra_hosts_len = YAJL_GET_ARRAY(tmp)->len;
            ret->extra_hosts = safe_malloc((YAJL_GET_ARRAY(tmp)->len + 1) * sizeof(*ret->extra_hosts));
            for (i = 0; i < YAJL_GET_ARRAY(tmp)->len; i++) {
                yajl_val val = YAJL_GET_ARRAY(tmp)->values[i];
                if (val != NULL) {
                    char *str = YAJL_GET_STRING(val);
                    ret->extra_hosts[i] = safe_strdup(str ? str : "");
                }
            }
        }
    }
    {
        yajl_val val = get_val(tree, "HookSpec", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->hook_spec = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val val = get_val(tree, "CPUShares", yajl_t_number);
        if (val != NULL) {
            int invalid = common_safe_int64(YAJL_GET_NUMBER(val), &ret->cpu_shares);
            if (invalid) {
                if (asprintf(err, "Invalid value '%s' with type 'int64' for key 'CPUShares': %s", YAJL_GET_NUMBER(val), strerror(-invalid)) < 0)
                    *err = safe_strdup("error allocating memory");
                free_host_config(ret);
                return NULL;
            }
        }
    }
    {
        yajl_val val = get_val(tree, "Memory", yajl_t_number);
        if (val != NULL) {
            int invalid = common_safe_int64(YAJL_GET_NUMBER(val), &ret->memory);
            if (invalid) {
                if (asprintf(err, "Invalid value '%s' with type 'int64' for key 'Memory': %s", YAJL_GET_NUMBER(val), strerror(-invalid)) < 0)
                    *err = safe_strdup("error allocating memory");
                free_host_config(ret);
                return NULL;
            }
        }
    }
    {
        yajl_val val = get_val(tree, "OomScoreAdj", yajl_t_number);
        if (val != NULL) {
            int invalid = common_safe_int(YAJL_GET_NUMBER(val), (int *)&ret->oom_score_adj);
            if (invalid) {
                if (asprintf(err, "Invalid value '%s' with type 'integer' for key 'OomScoreAdj': %s", YAJL_GET_NUMBER(val), strerror(-invalid)) < 0)
                    *err = safe_strdup("error allocating memory");
                free_host_config(ret);
                return NULL;
            }
        }
    }
    {
        yajl_val val = get_val(tree, "BlkioWeight", yajl_t_number);
        if (val != NULL) {
            int invalid = common_safe_uint16(YAJL_GET_NUMBER(val), &ret->blkio_weight);
            if (invalid) {
                if (asprintf(err, "Invalid value '%s' with type 'uint16' for key 'BlkioWeight': %s", YAJL_GET_NUMBER(val), strerror(-invalid)) < 0)
                    *err = safe_strdup("error allocating memory");
                free_host_config(ret);
                return NULL;
            }
        }
    }
    {
        yajl_val tmp = get_val(tree, "BlkioWeightDevice", yajl_t_array);
        if (tmp != NULL && YAJL_GET_ARRAY(tmp) != NULL && YAJL_GET_ARRAY(tmp)->len > 0) {
            size_t i;
            ret->blkio_weight_device_len = YAJL_GET_ARRAY(tmp)->len;
            ret->blkio_weight_device = safe_malloc((YAJL_GET_ARRAY(tmp)->len + 1) * sizeof(*ret->blkio_weight_device));
            for (i = 0; i < YAJL_GET_ARRAY(tmp)->len; i++) {
                yajl_val val = YAJL_GET_ARRAY(tmp)->values[i];
                ret->blkio_weight_device[i] = make_defs_blkio_weight_device(val, ctx, err);
                if (ret->blkio_weight_device[i] == NULL) {
                    free_host_config(ret);
                    return NULL;
                }
            }
        }
    }
    {
        yajl_val tmp = get_val(tree, "BlkioDeviceReadBps", yajl_t_array);
        if (tmp != NULL && YAJL_GET_ARRAY(tmp) != NULL && YAJL_GET_ARRAY(tmp)->len > 0) {
            size_t i;
            ret->blkio_device_read_bps_len = YAJL_GET_ARRAY(tmp)->len;
            ret->blkio_device_read_bps = safe_malloc((YAJL_GET_ARRAY(tmp)->len + 1) * sizeof(*ret->blkio_device_read_bps));
            for (i = 0; i < YAJL_GET_ARRAY(tmp)->len; i++) {
                yajl_val val = YAJL_GET_ARRAY(tmp)->values[i];
                ret->blkio_device_read_bps[i] = make_defs_blkio_device(val, ctx, err);
                if (ret->blkio_device_read_bps[i] == NULL) {
                    free_host_config(ret);
                    return NULL;
                }
            }
        }
    }
    {
        yajl_val tmp = get_val(tree, "BlkioDeviceWriteBps", yajl_t_array);
        if (tmp != NULL && YAJL_GET_ARRAY(tmp) != NULL && YAJL_GET_ARRAY(tmp)->len > 0) {
            size_t i;
            ret->blkio_device_write_bps_len = YAJL_GET_ARRAY(tmp)->len;
            ret->blkio_device_write_bps = safe_malloc((YAJL_GET_ARRAY(tmp)->len + 1) * sizeof(*ret->blkio_device_write_bps));
            for (i = 0; i < YAJL_GET_ARRAY(tmp)->len; i++) {
                yajl_val val = YAJL_GET_ARRAY(tmp)->values[i];
                ret->blkio_device_write_bps[i] = make_defs_blkio_device(val, ctx, err);
                if (ret->blkio_device_write_bps[i] == NULL) {
                    free_host_config(ret);
                    return NULL;
                }
            }
        }
    }
    {
        yajl_val tmp = get_val(tree, "BlkioDeviceReadIops", yajl_t_array);
        if (tmp != NULL && YAJL_GET_ARRAY(tmp) != NULL && YAJL_GET_ARRAY(tmp)->len > 0) {
            size_t i;
            ret->blkio_device_read_iops_len = YAJL_GET_ARRAY(tmp)->len;
            ret->blkio_device_read_iops = safe_malloc((YAJL_GET_ARRAY(tmp)->len + 1) * sizeof(*ret->blkio_device_read_iops));
            for (i = 0; i < YAJL_GET_ARRAY(tmp)->len; i++) {
                yajl_val val = YAJL_GET_ARRAY(tmp)->values[i];
                ret->blkio_device_read_iops[i] = make_defs_blkio_device(val, ctx, err);
                if (ret->blkio_device_read_iops[i] == NULL) {
                    free_host_config(ret);
                    return NULL;
                }
            }
        }
    }
    {
        yajl_val tmp = get_val(tree, "BlkioDeviceWriteIops", yajl_t_array);
        if (tmp != NULL && YAJL_GET_ARRAY(tmp) != NULL && YAJL_GET_ARRAY(tmp)->len > 0) {
            size_t i;
            ret->blkio_device_write_iops_len = YAJL_GET_ARRAY(tmp)->len;
            ret->blkio_device_write_iops = safe_malloc((YAJL_GET_ARRAY(tmp)->len + 1) * sizeof(*ret->blkio_device_write_iops));
            for (i = 0; i < YAJL_GET_ARRAY(tmp)->len; i++) {
                yajl_val val = YAJL_GET_ARRAY(tmp)->values[i];
                ret->blkio_device_write_iops[i] = make_defs_blkio_device(val, ctx, err);
                if (ret->blkio_device_write_iops[i] == NULL) {
                    free_host_config(ret);
                    return NULL;
                }
            }
        }
    }
    {
        yajl_val val = get_val(tree, "NanoCpus", yajl_t_number);
        if (val != NULL) {
            int invalid = common_safe_int64(YAJL_GET_NUMBER(val), &ret->nano_cpus);
            if (invalid) {
                if (asprintf(err, "Invalid value '%s' with type 'int64' for key 'NanoCpus': %s", YAJL_GET_NUMBER(val), strerror(-invalid)) < 0)
                    *err = safe_strdup("error allocating memory");
                free_host_config(ret);
                return NULL;
            }
        }
    }
    {
        yajl_val val = get_val(tree, "CPUPeriod", yajl_t_number);
        if (val != NULL) {
            int invalid = common_safe_int64(YAJL_GET_NUMBER(val), &ret->cpu_period);
            if (invalid) {
                if (asprintf(err, "Invalid value '%s' with type 'int64' for key 'CPUPeriod': %s", YAJL_GET_NUMBER(val), strerror(-invalid)) < 0)
                    *err = safe_strdup("error allocating memory");
                free_host_config(ret);
                return NULL;
            }
        }
    }
    {
        yajl_val val = get_val(tree, "CPUQuota", yajl_t_number);
        if (val != NULL) {
            int invalid = common_safe_int64(YAJL_GET_NUMBER(val), &ret->cpu_quota);
            if (invalid) {
                if (asprintf(err, "Invalid value '%s' with type 'int64' for key 'CPUQuota': %s", YAJL_GET_NUMBER(val), strerror(-invalid)) < 0)
                    *err = safe_strdup("error allocating memory");
                free_host_config(ret);
                return NULL;
            }
        }
    }
    {
        yajl_val val = get_val(tree, "CPURealtimePeriod", yajl_t_number);
        if (val != NULL) {
            int invalid = common_safe_int64(YAJL_GET_NUMBER(val), &ret->cpu_realtime_period);
            if (invalid) {
                if (asprintf(err, "Invalid value '%s' with type 'int64' for key 'CPURealtimePeriod': %s", YAJL_GET_NUMBER(val), strerror(-invalid)) < 0)
                    *err = safe_strdup("error allocating memory");
                free_host_config(ret);
                return NULL;
            }
        }
    }
    {
        yajl_val val = get_val(tree, "CPURealtimeRuntime", yajl_t_number);
        if (val != NULL) {
            int invalid = common_safe_int64(YAJL_GET_NUMBER(val), &ret->cpu_realtime_runtime);
            if (invalid) {
                if (asprintf(err, "Invalid value '%s' with type 'int64' for key 'CPURealtimeRuntime': %s", YAJL_GET_NUMBER(val), strerror(-invalid)) < 0)
                    *err = safe_strdup("error allocating memory");
                free_host_config(ret);
                return NULL;
            }
        }
    }
    {
        yajl_val val = get_val(tree, "CpusetCpus", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->cpuset_cpus = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val val = get_val(tree, "CpusetMems", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->cpuset_mems = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val tmp = get_val(tree, "Devices", yajl_t_array);
        if (tmp != NULL && YAJL_GET_ARRAY(tmp) != NULL && YAJL_GET_ARRAY(tmp)->len > 0) {
            size_t i;
            ret->devices_len = YAJL_GET_ARRAY(tmp)->len;
            ret->devices = safe_malloc((YAJL_GET_ARRAY(tmp)->len + 1) * sizeof(*ret->devices));
            for (i = 0; i < YAJL_GET_ARRAY(tmp)->len; i++) {
                yajl_val val = YAJL_GET_ARRAY(tmp)->values[i];
                ret->devices[i] = make_host_config_devices_element(val, ctx, err);
                if (ret->devices[i] == NULL) {
                    free_host_config(ret);
                    return NULL;
                }
            }
        }
    }
    {
        yajl_val tmp = get_val(tree, "DeviceCgroupRules", yajl_t_array);
        if (tmp != NULL && YAJL_GET_ARRAY(tmp) != NULL && YAJL_GET_ARRAY(tmp)->len > 0) {
            size_t i;
            ret->device_cgroup_rules_len = YAJL_GET_ARRAY(tmp)->len;
            ret->device_cgroup_rules = safe_malloc((YAJL_GET_ARRAY(tmp)->len + 1) * sizeof(*ret->device_cgroup_rules));
            for (i = 0; i < YAJL_GET_ARRAY(tmp)->len; i++) {
                yajl_val val = YAJL_GET_ARRAY(tmp)->values[i];
                if (val != NULL) {
                    char *str = YAJL_GET_STRING(val);
                    ret->device_cgroup_rules[i] = safe_strdup(str ? str : "");
                }
            }
        }
    }
    {
        yajl_val tmp = get_val(tree, "SecurityOpt", yajl_t_array);
        if (tmp != NULL && YAJL_GET_ARRAY(tmp) != NULL && YAJL_GET_ARRAY(tmp)->len > 0) {
            size_t i;
            ret->security_opt_len = YAJL_GET_ARRAY(tmp)->len;
            ret->security_opt = safe_malloc((YAJL_GET_ARRAY(tmp)->len + 1) * sizeof(*ret->security_opt));
            for (i = 0; i < YAJL_GET_ARRAY(tmp)->len; i++) {
                yajl_val val = YAJL_GET_ARRAY(tmp)->values[i];
                if (val != NULL) {
                    char *str = YAJL_GET_STRING(val);
                    ret->security_opt[i] = safe_strdup(str ? str : "");
                }
            }
        }
    }
    {
        yajl_val tmp = get_val(tree, "StorageOpt", yajl_t_object);
        if (tmp != NULL) {
            ret->storage_opt = make_json_map_string_string(tmp, ctx, err);
            if (ret->storage_opt == NULL) {
                char *new_error = NULL;
                if (asprintf(&new_error, "Value error for key 'StorageOpt': %s", *err ? *err : "null") < 0) {
                    new_error = safe_strdup("error allocating memory");
                }
                free(*err);
                *err = new_error;
                free_host_config(ret);
                return NULL;
            }
        }
    }
    {
        yajl_val val = get_val(tree, "KernelMemory", yajl_t_number);
        if (val != NULL) {
            int invalid = common_safe_int64(YAJL_GET_NUMBER(val), &ret->kernel_memory);
            if (invalid) {
                if (asprintf(err, "Invalid value '%s' with type 'int64' for key 'KernelMemory': %s", YAJL_GET_NUMBER(val), strerror(-invalid)) < 0)
                    *err = safe_strdup("error allocating memory");
                free_host_config(ret);
                return NULL;
            }
        }
    }
    {
        yajl_val val = get_val(tree, "MemoryReservation", yajl_t_number);
        if (val != NULL) {
            int invalid = common_safe_int64(YAJL_GET_NUMBER(val), &ret->memory_reservation);
            if (invalid) {
                if (asprintf(err, "Invalid value '%s' with type 'int64' for key 'MemoryReservation': %s", YAJL_GET_NUMBER(val), strerror(-invalid)) < 0)
                    *err = safe_strdup("error allocating memory");
                free_host_config(ret);
                return NULL;
            }
        }
    }
    {
        yajl_val val = get_val(tree, "MemorySwap", yajl_t_number);
        if (val != NULL) {
            int invalid = common_safe_int64(YAJL_GET_NUMBER(val), &ret->memory_swap);
            if (invalid) {
                if (asprintf(err, "Invalid value '%s' with type 'int64' for key 'MemorySwap': %s", YAJL_GET_NUMBER(val), strerror(-invalid)) < 0)
                    *err = safe_strdup("error allocating memory");
                free_host_config(ret);
                return NULL;
            }
        }
    }
    {
        yajl_val val = get_val(tree, "MemorySwappiness", yajl_t_number);
        if (val != NULL) {
            ret->memory_swappiness = safe_malloc(sizeof(uint64_t));
            int invalid = common_safe_uint64(YAJL_GET_NUMBER(val), ret->memory_swappiness);
            if (invalid) {
                if (asprintf(err, "Invalid value '%s' with type 'uint64Pointer' for key 'MemorySwappiness': %s", YAJL_GET_NUMBER(val), strerror(-invalid)) < 0)
                    *err = safe_strdup("error allocating memory");
                free_host_config(ret);
                return NULL;
            }
        }
    }
    {
        yajl_val val = get_val(tree, "OomKillDisable", yajl_t_true);
        if (val != NULL)
            ret->oom_kill_disable = YAJL_IS_TRUE(val);
    }
    {
        yajl_val val = get_val(tree, "PidsLimit", yajl_t_number);
        if (val != NULL) {
            int invalid = common_safe_int64(YAJL_GET_NUMBER(val), &ret->pids_limit);
            if (invalid) {
                if (asprintf(err, "Invalid value '%s' with type 'int64' for key 'PidsLimit': %s", YAJL_GET_NUMBER(val), strerror(-invalid)) < 0)
                    *err = safe_strdup("error allocating memory");
                free_host_config(ret);
                return NULL;
            }
        }
    }
    {
        yajl_val val = get_val(tree, "FilesLimit", yajl_t_number);
        if (val != NULL) {
            int invalid = common_safe_int64(YAJL_GET_NUMBER(val), &ret->files_limit);
            if (invalid) {
                if (asprintf(err, "Invalid value '%s' with type 'int64' for key 'FilesLimit': %s", YAJL_GET_NUMBER(val), strerror(-invalid)) < 0)
                    *err = safe_strdup("error allocating memory");
                free_host_config(ret);
                return NULL;
            }
        }
    }
    {
        yajl_val tmp = get_val(tree, "Ulimits", yajl_t_array);
        if (tmp != NULL && YAJL_GET_ARRAY(tmp) != NULL && YAJL_GET_ARRAY(tmp)->len > 0) {
            size_t i;
            ret->ulimits_len = YAJL_GET_ARRAY(tmp)->len;
            ret->ulimits = safe_malloc((YAJL_GET_ARRAY(tmp)->len + 1) * sizeof(*ret->ulimits));
            for (i = 0; i < YAJL_GET_ARRAY(tmp)->len; i++) {
                yajl_val val = YAJL_GET_ARRAY(tmp)->values[i];
                ret->ulimits[i] = make_host_config_ulimits_element(val, ctx, err);
                if (ret->ulimits[i] == NULL) {
                    free_host_config(ret);
                    return NULL;
                }
            }
        }
    }
    {
        yajl_val tmp = get_val(tree, "Hugetlbs", yajl_t_array);
        if (tmp != NULL && YAJL_GET_ARRAY(tmp) != NULL && YAJL_GET_ARRAY(tmp)->len > 0) {
            size_t i;
            ret->hugetlbs_len = YAJL_GET_ARRAY(tmp)->len;
            ret->hugetlbs = safe_malloc((YAJL_GET_ARRAY(tmp)->len + 1) * sizeof(*ret->hugetlbs));
            for (i = 0; i < YAJL_GET_ARRAY(tmp)->len; i++) {
                yajl_val val = YAJL_GET_ARRAY(tmp)->values[i];
                ret->hugetlbs[i] = make_host_config_hugetlbs_element(val, ctx, err);
                if (ret->hugetlbs[i] == NULL) {
                    free_host_config(ret);
                    return NULL;
                }
            }
        }
    }
    ret->host_channel = make_host_config_host_channel(get_val(tree, "HostChannel", yajl_t_object), ctx, err);
    if (ret->host_channel == NULL && *err != 0) {
        free_host_config(ret);
        return NULL;
    }
    {
        yajl_val val = get_val(tree, "EnvTargetFile", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->env_target_file = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val val = get_val(tree, "ExternalRootfs", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->external_rootfs = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val val = get_val(tree, "CgroupParent", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->cgroup_parent = safe_strdup(str ? str : "");
        }
    }

    if (tree->type == yajl_t_object)
    {
        size_t i;
        size_t j = 0;
        size_t cnt = tree->u.object.len;
        yajl_val resi = NULL;

        if (ctx->options & OPT_PARSE_FULLKEY)
        {
            resi = calloc (1, sizeof(*tree));
            if (resi == NULL)
            {
                free_host_config(ret);
                return NULL;
            }
            resi->type = yajl_t_object;
            resi->u.object.keys = calloc (cnt, sizeof (const char *));
            if (resi->u.object.keys == NULL)
            {
               free_host_config(ret);
               yajl_tree_free(resi);
               return NULL;
            }
            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
            if (resi->u.object.values == NULL)
            {
               free_host_config(ret);
               yajl_tree_free(resi);
               return NULL;
            }
        }
        for (i = 0; i < tree->u.object.len; i++)
        {
           if (strcmp(tree->u.object.keys[i], "VolumesFrom") &&
                strcmp(tree->u.object.keys[i], "Binds") &&
                strcmp(tree->u.object.keys[i], "Mounts") &&
                strcmp(tree->u.object.keys[i], "NetworkMode") &&
                strcmp(tree->u.object.keys[i], "GroupAdd") &&
                strcmp(tree->u.object.keys[i], "IpcMode") &&
                strcmp(tree->u.object.keys[i], "PidMode") &&
                strcmp(tree->u.object.keys[i], "Privileged") &&
                strcmp(tree->u.object.keys[i], "SystemContainer") &&
                strcmp(tree->u.object.keys[i], "NsChangeFiles") &&
                strcmp(tree->u.object.keys[i], "UserRemap") &&
                strcmp(tree->u.object.keys[i], "ShmSize") &&
                strcmp(tree->u.object.keys[i], "AutoRemove") &&
                strcmp(tree->u.object.keys[i], "AutoRemoveBak") &&
                strcmp(tree->u.object.keys[i], "ReadonlyRootfs") &&
                strcmp(tree->u.object.keys[i], "Tmpfs") &&
                strcmp(tree->u.object.keys[i], "UTSMode") &&
                strcmp(tree->u.object.keys[i], "UsernsMode") &&
                strcmp(tree->u.object.keys[i], "Sysctls") &&
                strcmp(tree->u.object.keys[i], "Runtime") &&
                strcmp(tree->u.object.keys[i], "RestartPolicy") &&
                strcmp(tree->u.object.keys[i], "CapAdd") &&
                strcmp(tree->u.object.keys[i], "CapDrop") &&
                strcmp(tree->u.object.keys[i], "Dns") &&
                strcmp(tree->u.object.keys[i], "DnsOptions") &&
                strcmp(tree->u.object.keys[i], "DnsSearch") &&
                strcmp(tree->u.object.keys[i], "ExtraHosts") &&
                strcmp(tree->u.object.keys[i], "HookSpec") &&
                strcmp(tree->u.object.keys[i], "CPUShares") &&
                strcmp(tree->u.object.keys[i], "Memory") &&
                strcmp(tree->u.object.keys[i], "OomScoreAdj") &&
                strcmp(tree->u.object.keys[i], "BlkioWeight") &&
                strcmp(tree->u.object.keys[i], "BlkioWeightDevice") &&
                strcmp(tree->u.object.keys[i], "BlkioDeviceReadBps") &&
                strcmp(tree->u.object.keys[i], "BlkioDeviceWriteBps") &&
                strcmp(tree->u.object.keys[i], "BlkioDeviceReadIops") &&
                strcmp(tree->u.object.keys[i], "BlkioDeviceWriteIops") &&
                strcmp(tree->u.object.keys[i], "NanoCpus") &&
                strcmp(tree->u.object.keys[i], "CPUPeriod") &&
                strcmp(tree->u.object.keys[i], "CPUQuota") &&
                strcmp(tree->u.object.keys[i], "CPURealtimePeriod") &&
                strcmp(tree->u.object.keys[i], "CPURealtimeRuntime") &&
                strcmp(tree->u.object.keys[i], "CpusetCpus") &&
                strcmp(tree->u.object.keys[i], "CpusetMems") &&
                strcmp(tree->u.object.keys[i], "Devices") &&
                strcmp(tree->u.object.keys[i], "DeviceCgroupRules") &&
                strcmp(tree->u.object.keys[i], "SecurityOpt") &&
                strcmp(tree->u.object.keys[i], "StorageOpt") &&
                strcmp(tree->u.object.keys[i], "KernelMemory") &&
                strcmp(tree->u.object.keys[i], "MemoryReservation") &&
                strcmp(tree->u.object.keys[i], "MemorySwap") &&
                strcmp(tree->u.object.keys[i], "MemorySwappiness") &&
                strcmp(tree->u.object.keys[i], "OomKillDisable") &&
                strcmp(tree->u.object.keys[i], "PidsLimit") &&
                strcmp(tree->u.object.keys[i], "FilesLimit") &&
                strcmp(tree->u.object.keys[i], "Ulimits") &&
                strcmp(tree->u.object.keys[i], "Hugetlbs") &&
                strcmp(tree->u.object.keys[i], "HostChannel") &&
                strcmp(tree->u.object.keys[i], "EnvTargetFile") &&
                strcmp(tree->u.object.keys[i], "ExternalRootfs") &&
                strcmp(tree->u.object.keys[i], "CgroupParent"))
           {
              if (ctx->options & OPT_PARSE_FULLKEY)
              {
                 resi->u.object.keys[j] = tree->u.object.keys[i];
                 tree->u.object.keys[i] = NULL;
                 resi->u.object.values[j] = tree->u.object.values[i];
                 tree->u.object.values[i] = NULL;
                 resi->u.object.len++;
              }
              j++;
           }
        }
        if (ctx->options & OPT_PARSE_STRICT)
        {
            if (j > 0 && ctx->stderr > 0)
                fprintf (ctx->stderr, "WARNING: unknown key found\n");
        }
        if (ctx->options & OPT_PARSE_FULLKEY)
            ret->_residual = resi;
        }
    return ret;
}

void free_host_config(host_config *ptr) {
    if (ptr == NULL)
        return;
    if (ptr->volumes_from != NULL) {
        size_t i;
        for (i = 0; i < ptr->volumes_from_len; i++) {
            if (ptr->volumes_from[i] != NULL) {
                free(ptr->volumes_from[i]);
                ptr->volumes_from[i] = NULL;
            }
        }
        free(ptr->volumes_from);
        ptr->volumes_from = NULL;
    }
    if (ptr->binds != NULL) {
        size_t i;
        for (i = 0; i < ptr->binds_len; i++) {
            if (ptr->binds[i] != NULL) {
                free(ptr->binds[i]);
                ptr->binds[i] = NULL;
            }
        }
        free(ptr->binds);
        ptr->binds = NULL;
    }
    if (ptr->mounts != NULL) {
        size_t i;
        for (i = 0; i < ptr->mounts_len; i++)
            if (ptr->mounts[i] != NULL) {
                free_mount_spec(ptr->mounts[i]);
                ptr->mounts[i] = NULL;
            }
        free(ptr->mounts);
        ptr->mounts = NULL;
    }
    free(ptr->network_mode);
    ptr->network_mode = NULL;
    if (ptr->group_add != NULL) {
        size_t i;
        for (i = 0; i < ptr->group_add_len; i++) {
            if (ptr->group_add[i] != NULL) {
                free(ptr->group_add[i]);
                ptr->group_add[i] = NULL;
            }
        }
        free(ptr->group_add);
        ptr->group_add = NULL;
    }
    free(ptr->ipc_mode);
    ptr->ipc_mode = NULL;
    free(ptr->pid_mode);
    ptr->pid_mode = NULL;
    if (ptr->ns_change_files != NULL) {
        size_t i;
        for (i = 0; i < ptr->ns_change_files_len; i++) {
            if (ptr->ns_change_files[i] != NULL) {
                free(ptr->ns_change_files[i]);
                ptr->ns_change_files[i] = NULL;
            }
        }
        free(ptr->ns_change_files);
        ptr->ns_change_files = NULL;
    }
    free(ptr->user_remap);
    ptr->user_remap = NULL;
    free_json_map_string_string(ptr->tmpfs);
    ptr->tmpfs = NULL;
    free(ptr->uts_mode);
    ptr->uts_mode = NULL;
    free(ptr->userns_mode);
    ptr->userns_mode = NULL;
    free_json_map_string_string(ptr->sysctls);
    ptr->sysctls = NULL;
    free(ptr->runtime);
    ptr->runtime = NULL;
    if (ptr->restart_policy != NULL) {
        free_host_config_restart_policy(ptr->restart_policy);
        ptr->restart_policy = NULL;
    }
    if (ptr->cap_add != NULL) {
        size_t i;
        for (i = 0; i < ptr->cap_add_len; i++) {
            if (ptr->cap_add[i] != NULL) {
                free(ptr->cap_add[i]);
                ptr->cap_add[i] = NULL;
            }
        }
        free(ptr->cap_add);
        ptr->cap_add = NULL;
    }
    if (ptr->cap_drop != NULL) {
        size_t i;
        for (i = 0; i < ptr->cap_drop_len; i++) {
            if (ptr->cap_drop[i] != NULL) {
                free(ptr->cap_drop[i]);
                ptr->cap_drop[i] = NULL;
            }
        }
        free(ptr->cap_drop);
        ptr->cap_drop = NULL;
    }
    if (ptr->dns != NULL) {
        size_t i;
        for (i = 0; i < ptr->dns_len; i++) {
            if (ptr->dns[i] != NULL) {
                free(ptr->dns[i]);
                ptr->dns[i] = NULL;
            }
        }
        free(ptr->dns);
        ptr->dns = NULL;
    }
    if (ptr->dns_options != NULL) {
        size_t i;
        for (i = 0; i < ptr->dns_options_len; i++) {
            if (ptr->dns_options[i] != NULL) {
                free(ptr->dns_options[i]);
                ptr->dns_options[i] = NULL;
            }
        }
        free(ptr->dns_options);
        ptr->dns_options = NULL;
    }
    if (ptr->dns_search != NULL) {
        size_t i;
        for (i = 0; i < ptr->dns_search_len; i++) {
            if (ptr->dns_search[i] != NULL) {
                free(ptr->dns_search[i]);
                ptr->dns_search[i] = NULL;
            }
        }
        free(ptr->dns_search);
        ptr->dns_search = NULL;
    }
    if (ptr->extra_hosts != NULL) {
        size_t i;
        for (i = 0; i < ptr->extra_hosts_len; i++) {
            if (ptr->extra_hosts[i] != NULL) {
                free(ptr->extra_hosts[i]);
                ptr->extra_hosts[i] = NULL;
            }
        }
        free(ptr->extra_hosts);
        ptr->extra_hosts = NULL;
    }
    free(ptr->hook_spec);
    ptr->hook_spec = NULL;
    if (ptr->blkio_weight_device != NULL) {
        size_t i;
        for (i = 0; i < ptr->blkio_weight_device_len; i++)
            if (ptr->blkio_weight_device[i] != NULL) {
                free_defs_blkio_weight_device(ptr->blkio_weight_device[i]);
                ptr->blkio_weight_device[i] = NULL;
            }
        free(ptr->blkio_weight_device);
        ptr->blkio_weight_device = NULL;
    }
    if (ptr->blkio_device_read_bps != NULL) {
        size_t i;
        for (i = 0; i < ptr->blkio_device_read_bps_len; i++)
            if (ptr->blkio_device_read_bps[i] != NULL) {
                free_defs_blkio_device(ptr->blkio_device_read_bps[i]);
                ptr->blkio_device_read_bps[i] = NULL;
            }
        free(ptr->blkio_device_read_bps);
        ptr->blkio_device_read_bps = NULL;
    }
    if (ptr->blkio_device_write_bps != NULL) {
        size_t i;
        for (i = 0; i < ptr->blkio_device_write_bps_len; i++)
            if (ptr->blkio_device_write_bps[i] != NULL) {
                free_defs_blkio_device(ptr->blkio_device_write_bps[i]);
                ptr->blkio_device_write_bps[i] = NULL;
            }
        free(ptr->blkio_device_write_bps);
        ptr->blkio_device_write_bps = NULL;
    }
    if (ptr->blkio_device_read_iops != NULL) {
        size_t i;
        for (i = 0; i < ptr->blkio_device_read_iops_len; i++)
            if (ptr->blkio_device_read_iops[i] != NULL) {
                free_defs_blkio_device(ptr->blkio_device_read_iops[i]);
                ptr->blkio_device_read_iops[i] = NULL;
            }
        free(ptr->blkio_device_read_iops);
        ptr->blkio_device_read_iops = NULL;
    }
    if (ptr->blkio_device_write_iops != NULL) {
        size_t i;
        for (i = 0; i < ptr->blkio_device_write_iops_len; i++)
            if (ptr->blkio_device_write_iops[i] != NULL) {
                free_defs_blkio_device(ptr->blkio_device_write_iops[i]);
                ptr->blkio_device_write_iops[i] = NULL;
            }
        free(ptr->blkio_device_write_iops);
        ptr->blkio_device_write_iops = NULL;
    }
    free(ptr->cpuset_cpus);
    ptr->cpuset_cpus = NULL;
    free(ptr->cpuset_mems);
    ptr->cpuset_mems = NULL;
    if (ptr->devices != NULL) {
        size_t i;
        for (i = 0; i < ptr->devices_len; i++)
            if (ptr->devices[i] != NULL) {
                free_host_config_devices_element(ptr->devices[i]);
                ptr->devices[i] = NULL;
            }
        free(ptr->devices);
        ptr->devices = NULL;
    }
    if (ptr->device_cgroup_rules != NULL) {
        size_t i;
        for (i = 0; i < ptr->device_cgroup_rules_len; i++) {
            if (ptr->device_cgroup_rules[i] != NULL) {
                free(ptr->device_cgroup_rules[i]);
                ptr->device_cgroup_rules[i] = NULL;
            }
        }
        free(ptr->device_cgroup_rules);
        ptr->device_cgroup_rules = NULL;
    }
    if (ptr->security_opt != NULL) {
        size_t i;
        for (i = 0; i < ptr->security_opt_len; i++) {
            if (ptr->security_opt[i] != NULL) {
                free(ptr->security_opt[i]);
                ptr->security_opt[i] = NULL;
            }
        }
        free(ptr->security_opt);
        ptr->security_opt = NULL;
    }
    free_json_map_string_string(ptr->storage_opt);
    ptr->storage_opt = NULL;
    free(ptr->memory_swappiness);
    ptr->memory_swappiness = NULL;
    if (ptr->ulimits != NULL) {
        size_t i;
        for (i = 0; i < ptr->ulimits_len; i++)
            if (ptr->ulimits[i] != NULL) {
                free_host_config_ulimits_element(ptr->ulimits[i]);
                ptr->ulimits[i] = NULL;
            }
        free(ptr->ulimits);
        ptr->ulimits = NULL;
    }
    if (ptr->hugetlbs != NULL) {
        size_t i;
        for (i = 0; i < ptr->hugetlbs_len; i++)
            if (ptr->hugetlbs[i] != NULL) {
                free_host_config_hugetlbs_element(ptr->hugetlbs[i]);
                ptr->hugetlbs[i] = NULL;
            }
        free(ptr->hugetlbs);
        ptr->hugetlbs = NULL;
    }
    if (ptr->host_channel != NULL) {
        free_host_config_host_channel(ptr->host_channel);
        ptr->host_channel = NULL;
    }
    free(ptr->env_target_file);
    ptr->env_target_file = NULL;
    free(ptr->external_rootfs);
    ptr->external_rootfs = NULL;
    free(ptr->cgroup_parent);
    ptr->cgroup_parent = NULL;
    yajl_tree_free (ptr->_residual);
    ptr->_residual = NULL;
    free(ptr);
}

yajl_gen_status gen_host_config(yajl_gen g, const host_config *ptr, const struct parser_context *ctx, parser_error *err) {
    yajl_gen_status stat = yajl_gen_status_ok;
    *err = 0;
    stat = yajl_gen_map_open((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->volumes_from != NULL)) {
        size_t len = 0, i;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("VolumesFrom"), strlen("VolumesFrom"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->volumes_from != NULL) {
            len = ptr->volumes_from_len;
        }
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 0);
        stat = yajl_gen_array_open((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        for (i = 0; i < len; i++) {
            stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(ptr->volumes_from[i]), strlen(ptr->volumes_from[i]));
            if (yajl_gen_status_ok != stat)
                GEN_SET_ERROR_AND_RETURN(stat, err);
        }
        stat = yajl_gen_array_close((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 1);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->binds != NULL)) {
        size_t len = 0, i;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("Binds"), strlen("Binds"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->binds != NULL) {
            len = ptr->binds_len;
        }
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 0);
        stat = yajl_gen_array_open((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        for (i = 0; i < len; i++) {
            stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(ptr->binds[i]), strlen(ptr->binds[i]));
            if (yajl_gen_status_ok != stat)
                GEN_SET_ERROR_AND_RETURN(stat, err);
        }
        stat = yajl_gen_array_close((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 1);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->mounts != NULL)) {
        size_t len = 0, i;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("Mounts"), strlen("Mounts"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->mounts != NULL) {
            len = ptr->mounts_len;
        }
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 0);
        stat = yajl_gen_array_open((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        for (i = 0; i < len; i++) {
            stat = gen_mount_spec(g, ptr->mounts[i], ctx, err);
            if (yajl_gen_status_ok != stat)
                GEN_SET_ERROR_AND_RETURN(stat, err);
        }
        stat = yajl_gen_array_close((yajl_gen)g);
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 1);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->network_mode != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("NetworkMode"), strlen("NetworkMode"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->network_mode != NULL) {
            str = ptr->network_mode;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->group_add != NULL)) {
        size_t len = 0, i;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("GroupAdd"), strlen("GroupAdd"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->group_add != NULL) {
            len = ptr->group_add_len;
        }
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 0);
        stat = yajl_gen_array_open((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        for (i = 0; i < len; i++) {
            stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(ptr->group_add[i]), strlen(ptr->group_add[i]));
            if (yajl_gen_status_ok != stat)
                GEN_SET_ERROR_AND_RETURN(stat, err);
        }
        stat = yajl_gen_array_close((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 1);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->ipc_mode != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("IpcMode"), strlen("IpcMode"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->ipc_mode != NULL) {
            str = ptr->ipc_mode;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->pid_mode != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("PidMode"), strlen("PidMode"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->pid_mode != NULL) {
            str = ptr->pid_mode;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->privileged)) {
        bool b = false;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("Privileged"), strlen("Privileged"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->privileged) {
            b = ptr->privileged;
        }
        stat = yajl_gen_bool((yajl_gen)g, (int)(b));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->system_container)) {
        bool b = false;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("SystemContainer"), strlen("SystemContainer"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->system_container) {
            b = ptr->system_container;
        }
        stat = yajl_gen_bool((yajl_gen)g, (int)(b));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->ns_change_files != NULL)) {
        size_t len = 0, i;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("NsChangeFiles"), strlen("NsChangeFiles"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->ns_change_files != NULL) {
            len = ptr->ns_change_files_len;
        }
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 0);
        stat = yajl_gen_array_open((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        for (i = 0; i < len; i++) {
            stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(ptr->ns_change_files[i]), strlen(ptr->ns_change_files[i]));
            if (yajl_gen_status_ok != stat)
                GEN_SET_ERROR_AND_RETURN(stat, err);
        }
        stat = yajl_gen_array_close((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 1);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->user_remap != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("UserRemap"), strlen("UserRemap"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->user_remap != NULL) {
            str = ptr->user_remap;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->shm_size)) {
        long long int num = 0;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("ShmSize"), strlen("ShmSize"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->shm_size) {
            num = (long long int)ptr->shm_size;
        }
        stat = map_int(g, num);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->auto_remove)) {
        bool b = false;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("AutoRemove"), strlen("AutoRemove"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->auto_remove) {
            b = ptr->auto_remove;
        }
        stat = yajl_gen_bool((yajl_gen)g, (int)(b));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->auto_remove_bak)) {
        bool b = false;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("AutoRemoveBak"), strlen("AutoRemoveBak"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->auto_remove_bak) {
            b = ptr->auto_remove_bak;
        }
        stat = yajl_gen_bool((yajl_gen)g, (int)(b));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->readonly_rootfs)) {
        bool b = false;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("ReadonlyRootfs"), strlen("ReadonlyRootfs"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->readonly_rootfs) {
            b = ptr->readonly_rootfs;
        }
        stat = yajl_gen_bool((yajl_gen)g, (int)(b));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->tmpfs != NULL)) {
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)("Tmpfs"), strlen("Tmpfs"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        stat = gen_json_map_string_string(g, ptr ? ptr->tmpfs : NULL, ctx, err);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->uts_mode != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("UTSMode"), strlen("UTSMode"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->uts_mode != NULL) {
            str = ptr->uts_mode;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->userns_mode != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("UsernsMode"), strlen("UsernsMode"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->userns_mode != NULL) {
            str = ptr->userns_mode;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->sysctls != NULL)) {
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)("Sysctls"), strlen("Sysctls"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        stat = gen_json_map_string_string(g, ptr ? ptr->sysctls : NULL, ctx, err);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->runtime != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("Runtime"), strlen("Runtime"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->runtime != NULL) {
            str = ptr->runtime;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->restart_policy != NULL)) {
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("RestartPolicy"), strlen("RestartPolicy"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        stat = gen_host_config_restart_policy(g, ptr != NULL ? ptr->restart_policy : NULL, ctx, err);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->cap_add != NULL)) {
        size_t len = 0, i;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("CapAdd"), strlen("CapAdd"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->cap_add != NULL) {
            len = ptr->cap_add_len;
        }
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 0);
        stat = yajl_gen_array_open((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        for (i = 0; i < len; i++) {
            stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(ptr->cap_add[i]), strlen(ptr->cap_add[i]));
            if (yajl_gen_status_ok != stat)
                GEN_SET_ERROR_AND_RETURN(stat, err);
        }
        stat = yajl_gen_array_close((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 1);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->cap_drop != NULL)) {
        size_t len = 0, i;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("CapDrop"), strlen("CapDrop"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->cap_drop != NULL) {
            len = ptr->cap_drop_len;
        }
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 0);
        stat = yajl_gen_array_open((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        for (i = 0; i < len; i++) {
            stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(ptr->cap_drop[i]), strlen(ptr->cap_drop[i]));
            if (yajl_gen_status_ok != stat)
                GEN_SET_ERROR_AND_RETURN(stat, err);
        }
        stat = yajl_gen_array_close((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 1);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->dns != NULL)) {
        size_t len = 0, i;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("Dns"), strlen("Dns"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->dns != NULL) {
            len = ptr->dns_len;
        }
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 0);
        stat = yajl_gen_array_open((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        for (i = 0; i < len; i++) {
            stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(ptr->dns[i]), strlen(ptr->dns[i]));
            if (yajl_gen_status_ok != stat)
                GEN_SET_ERROR_AND_RETURN(stat, err);
        }
        stat = yajl_gen_array_close((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 1);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->dns_options != NULL)) {
        size_t len = 0, i;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("DnsOptions"), strlen("DnsOptions"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->dns_options != NULL) {
            len = ptr->dns_options_len;
        }
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 0);
        stat = yajl_gen_array_open((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        for (i = 0; i < len; i++) {
            stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(ptr->dns_options[i]), strlen(ptr->dns_options[i]));
            if (yajl_gen_status_ok != stat)
                GEN_SET_ERROR_AND_RETURN(stat, err);
        }
        stat = yajl_gen_array_close((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 1);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->dns_search != NULL)) {
        size_t len = 0, i;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("DnsSearch"), strlen("DnsSearch"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->dns_search != NULL) {
            len = ptr->dns_search_len;
        }
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 0);
        stat = yajl_gen_array_open((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        for (i = 0; i < len; i++) {
            stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(ptr->dns_search[i]), strlen(ptr->dns_search[i]));
            if (yajl_gen_status_ok != stat)
                GEN_SET_ERROR_AND_RETURN(stat, err);
        }
        stat = yajl_gen_array_close((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 1);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->extra_hosts != NULL)) {
        size_t len = 0, i;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("ExtraHosts"), strlen("ExtraHosts"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->extra_hosts != NULL) {
            len = ptr->extra_hosts_len;
        }
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 0);
        stat = yajl_gen_array_open((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        for (i = 0; i < len; i++) {
            stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(ptr->extra_hosts[i]), strlen(ptr->extra_hosts[i]));
            if (yajl_gen_status_ok != stat)
                GEN_SET_ERROR_AND_RETURN(stat, err);
        }
        stat = yajl_gen_array_close((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 1);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->hook_spec != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("HookSpec"), strlen("HookSpec"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->hook_spec != NULL) {
            str = ptr->hook_spec;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->cpu_shares)) {
        long long int num = 0;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("CPUShares"), strlen("CPUShares"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->cpu_shares) {
            num = (long long int)ptr->cpu_shares;
        }
        stat = map_int(g, num);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->memory)) {
        long long int num = 0;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("Memory"), strlen("Memory"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->memory) {
            num = (long long int)ptr->memory;
        }
        stat = map_int(g, num);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->oom_score_adj)) {
        long long int num = 0;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("OomScoreAdj"), strlen("OomScoreAdj"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->oom_score_adj) {
            num = (long long int)ptr->oom_score_adj;
        }
        stat = map_int(g, num);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->blkio_weight)) {
        long long unsigned int num = 0;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("BlkioWeight"), strlen("BlkioWeight"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->blkio_weight) {
            num = (long long unsigned int)ptr->blkio_weight;
        }
        stat = map_uint(g, num);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->blkio_weight_device != NULL)) {
        size_t len = 0, i;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("BlkioWeightDevice"), strlen("BlkioWeightDevice"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->blkio_weight_device != NULL) {
            len = ptr->blkio_weight_device_len;
        }
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 0);
        stat = yajl_gen_array_open((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        for (i = 0; i < len; i++) {
            stat = gen_defs_blkio_weight_device(g, ptr->blkio_weight_device[i], ctx, err);
            if (yajl_gen_status_ok != stat)
                GEN_SET_ERROR_AND_RETURN(stat, err);
        }
        stat = yajl_gen_array_close((yajl_gen)g);
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 1);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->blkio_device_read_bps != NULL)) {
        size_t len = 0, i;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("BlkioDeviceReadBps"), strlen("BlkioDeviceReadBps"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->blkio_device_read_bps != NULL) {
            len = ptr->blkio_device_read_bps_len;
        }
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 0);
        stat = yajl_gen_array_open((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        for (i = 0; i < len; i++) {
            stat = gen_defs_blkio_device(g, ptr->blkio_device_read_bps[i], ctx, err);
            if (yajl_gen_status_ok != stat)
                GEN_SET_ERROR_AND_RETURN(stat, err);
        }
        stat = yajl_gen_array_close((yajl_gen)g);
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 1);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->blkio_device_write_bps != NULL)) {
        size_t len = 0, i;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("BlkioDeviceWriteBps"), strlen("BlkioDeviceWriteBps"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->blkio_device_write_bps != NULL) {
            len = ptr->blkio_device_write_bps_len;
        }
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 0);
        stat = yajl_gen_array_open((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        for (i = 0; i < len; i++) {
            stat = gen_defs_blkio_device(g, ptr->blkio_device_write_bps[i], ctx, err);
            if (yajl_gen_status_ok != stat)
                GEN_SET_ERROR_AND_RETURN(stat, err);
        }
        stat = yajl_gen_array_close((yajl_gen)g);
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 1);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->blkio_device_read_iops != NULL)) {
        size_t len = 0, i;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("BlkioDeviceReadIops"), strlen("BlkioDeviceReadIops"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->blkio_device_read_iops != NULL) {
            len = ptr->blkio_device_read_iops_len;
        }
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 0);
        stat = yajl_gen_array_open((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        for (i = 0; i < len; i++) {
            stat = gen_defs_blkio_device(g, ptr->blkio_device_read_iops[i], ctx, err);
            if (yajl_gen_status_ok != stat)
                GEN_SET_ERROR_AND_RETURN(stat, err);
        }
        stat = yajl_gen_array_close((yajl_gen)g);
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 1);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->blkio_device_write_iops != NULL)) {
        size_t len = 0, i;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("BlkioDeviceWriteIops"), strlen("BlkioDeviceWriteIops"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->blkio_device_write_iops != NULL) {
            len = ptr->blkio_device_write_iops_len;
        }
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 0);
        stat = yajl_gen_array_open((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        for (i = 0; i < len; i++) {
            stat = gen_defs_blkio_device(g, ptr->blkio_device_write_iops[i], ctx, err);
            if (yajl_gen_status_ok != stat)
                GEN_SET_ERROR_AND_RETURN(stat, err);
        }
        stat = yajl_gen_array_close((yajl_gen)g);
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 1);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->nano_cpus)) {
        long long int num = 0;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("NanoCpus"), strlen("NanoCpus"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->nano_cpus) {
            num = (long long int)ptr->nano_cpus;
        }
        stat = map_int(g, num);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->cpu_period)) {
        long long int num = 0;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("CPUPeriod"), strlen("CPUPeriod"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->cpu_period) {
            num = (long long int)ptr->cpu_period;
        }
        stat = map_int(g, num);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->cpu_quota)) {
        long long int num = 0;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("CPUQuota"), strlen("CPUQuota"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->cpu_quota) {
            num = (long long int)ptr->cpu_quota;
        }
        stat = map_int(g, num);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->cpu_realtime_period)) {
        long long int num = 0;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("CPURealtimePeriod"), strlen("CPURealtimePeriod"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->cpu_realtime_period) {
            num = (long long int)ptr->cpu_realtime_period;
        }
        stat = map_int(g, num);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->cpu_realtime_runtime)) {
        long long int num = 0;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("CPURealtimeRuntime"), strlen("CPURealtimeRuntime"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->cpu_realtime_runtime) {
            num = (long long int)ptr->cpu_realtime_runtime;
        }
        stat = map_int(g, num);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->cpuset_cpus != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("CpusetCpus"), strlen("CpusetCpus"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->cpuset_cpus != NULL) {
            str = ptr->cpuset_cpus;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->cpuset_mems != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("CpusetMems"), strlen("CpusetMems"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->cpuset_mems != NULL) {
            str = ptr->cpuset_mems;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->devices != NULL)) {
        size_t len = 0, i;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("Devices"), strlen("Devices"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->devices != NULL) {
            len = ptr->devices_len;
        }
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 0);
        stat = yajl_gen_array_open((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        for (i = 0; i < len; i++) {
            stat = gen_host_config_devices_element(g, ptr->devices[i], ctx, err);
            if (yajl_gen_status_ok != stat)
                GEN_SET_ERROR_AND_RETURN(stat, err);
        }
        stat = yajl_gen_array_close((yajl_gen)g);
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 1);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->device_cgroup_rules != NULL)) {
        size_t len = 0, i;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("DeviceCgroupRules"), strlen("DeviceCgroupRules"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->device_cgroup_rules != NULL) {
            len = ptr->device_cgroup_rules_len;
        }
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 0);
        stat = yajl_gen_array_open((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        for (i = 0; i < len; i++) {
            stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(ptr->device_cgroup_rules[i]), strlen(ptr->device_cgroup_rules[i]));
            if (yajl_gen_status_ok != stat)
                GEN_SET_ERROR_AND_RETURN(stat, err);
        }
        stat = yajl_gen_array_close((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 1);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->security_opt != NULL)) {
        size_t len = 0, i;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("SecurityOpt"), strlen("SecurityOpt"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->security_opt != NULL) {
            len = ptr->security_opt_len;
        }
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 0);
        stat = yajl_gen_array_open((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        for (i = 0; i < len; i++) {
            stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(ptr->security_opt[i]), strlen(ptr->security_opt[i]));
            if (yajl_gen_status_ok != stat)
                GEN_SET_ERROR_AND_RETURN(stat, err);
        }
        stat = yajl_gen_array_close((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 1);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->storage_opt != NULL)) {
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)("StorageOpt"), strlen("StorageOpt"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        stat = gen_json_map_string_string(g, ptr ? ptr->storage_opt : NULL, ctx, err);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->kernel_memory)) {
        long long int num = 0;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("KernelMemory"), strlen("KernelMemory"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->kernel_memory) {
            num = (long long int)ptr->kernel_memory;
        }
        stat = map_int(g, num);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->memory_reservation)) {
        long long int num = 0;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("MemoryReservation"), strlen("MemoryReservation"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->memory_reservation) {
            num = (long long int)ptr->memory_reservation;
        }
        stat = map_int(g, num);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->memory_swap)) {
        long long int num = 0;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("MemorySwap"), strlen("MemorySwap"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->memory_swap) {
            num = (long long int)ptr->memory_swap;
        }
        stat = map_int(g, num);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ptr != NULL && ptr->memory_swappiness != NULL)) {
        uint64_t num = 0;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("MemorySwappiness"), strlen("MemorySwappiness"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->memory_swappiness != NULL) {
            num = (uint64_t)*(ptr->memory_swappiness);
        }
        stat = map_uint(g, num);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->oom_kill_disable)) {
        bool b = false;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("OomKillDisable"), strlen("OomKillDisable"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->oom_kill_disable) {
            b = ptr->oom_kill_disable;
        }
        stat = yajl_gen_bool((yajl_gen)g, (int)(b));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->pids_limit)) {
        long long int num = 0;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("PidsLimit"), strlen("PidsLimit"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->pids_limit) {
            num = (long long int)ptr->pids_limit;
        }
        stat = map_int(g, num);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->files_limit)) {
        long long int num = 0;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("FilesLimit"), strlen("FilesLimit"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->files_limit) {
            num = (long long int)ptr->files_limit;
        }
        stat = map_int(g, num);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->ulimits != NULL)) {
        size_t len = 0, i;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("Ulimits"), strlen("Ulimits"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->ulimits != NULL) {
            len = ptr->ulimits_len;
        }
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 0);
        stat = yajl_gen_array_open((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        for (i = 0; i < len; i++) {
            stat = gen_host_config_ulimits_element(g, ptr->ulimits[i], ctx, err);
            if (yajl_gen_status_ok != stat)
                GEN_SET_ERROR_AND_RETURN(stat, err);
        }
        stat = yajl_gen_array_close((yajl_gen)g);
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 1);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->hugetlbs != NULL)) {
        size_t len = 0, i;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("Hugetlbs"), strlen("Hugetlbs"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->hugetlbs != NULL) {
            len = ptr->hugetlbs_len;
        }
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 0);
        stat = yajl_gen_array_open((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        for (i = 0; i < len; i++) {
            stat = gen_host_config_hugetlbs_element(g, ptr->hugetlbs[i], ctx, err);
            if (yajl_gen_status_ok != stat)
                GEN_SET_ERROR_AND_RETURN(stat, err);
        }
        stat = yajl_gen_array_close((yajl_gen)g);
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 1);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->host_channel != NULL)) {
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("HostChannel"), strlen("HostChannel"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        stat = gen_host_config_host_channel(g, ptr != NULL ? ptr->host_channel : NULL, ctx, err);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->env_target_file != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("EnvTargetFile"), strlen("EnvTargetFile"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->env_target_file != NULL) {
            str = ptr->env_target_file;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->external_rootfs != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("ExternalRootfs"), strlen("ExternalRootfs"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->external_rootfs != NULL) {
            str = ptr->external_rootfs;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->cgroup_parent != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("CgroupParent"), strlen("CgroupParent"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->cgroup_parent != NULL) {
            str = ptr->cgroup_parent;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if (ptr != NULL && ptr->_residual != NULL)
    {
        stat = gen_yajl_object_residual (ptr->_residual, g, err);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN (stat, err);
    }
    stat = yajl_gen_map_close((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    return yajl_gen_status_ok;
}


host_config *host_config_parse_file(const char *filename, const struct parser_context *ctx, parser_error *err) {
    host_config *ptr = NULL;
    size_t filesize;
    char *content = NULL;

    if (filename == NULL || err == NULL)
        return NULL;

    *err = NULL;
    content = read_file(filename, &filesize);
    if (content == NULL) {
        if (asprintf(err, "cannot read the file: %s", filename) < 0)
            *err = safe_strdup("error allocating memory");
        return NULL;
    }
    ptr = host_config_parse_data(content, ctx, err);
    free(content);
    return ptr;
}

host_config *host_config_parse_file_stream(FILE *stream, const struct parser_context *ctx, parser_error *err) {
    host_config *ptr = NULL;
    size_t filesize;
    char *content = NULL ;

    if (stream == NULL || err == NULL)
        return NULL;

    *err = NULL;
    content = fread_file(stream, &filesize);
    if (content == NULL) {
        *err = safe_strdup("cannot read the file");
        return NULL;
    }
    ptr = host_config_parse_data(content, ctx, err);
    free(content);
    return ptr;
}

host_config *host_config_parse_data(const char *jsondata, const struct parser_context *ctx, parser_error *err) {
    host_config *ptr = NULL;
    yajl_val tree;
    char errbuf[1024];
    struct parser_context tmp_ctx = { 0 };

    if (jsondata == NULL || err == NULL)
        return NULL;

    *err = NULL;
    if (ctx == NULL) {
       ctx = (const struct parser_context *)(&tmp_ctx);
    }
    tree = yajl_tree_parse(jsondata, errbuf, sizeof(errbuf));
    if (tree == NULL) {
        if (asprintf(err, "cannot parse the data: %s", errbuf) < 0)
            *err = safe_strdup("error allocating memory");
        return NULL;
    }
    ptr = make_host_config(tree, ctx, err);
    yajl_tree_free(tree);
    return ptr;
}
char *host_config_generate_json(const host_config *ptr, const struct parser_context *ctx, parser_error *err) {
    yajl_gen g = NULL;
    struct parser_context tmp_ctx = { 0 };
    const unsigned char *gen_buf = NULL;
    char *json_buf = NULL;
    size_t gen_len = 0;

    if (ptr == NULL || err == NULL)
        return NULL;

    *err = NULL;
    if (ctx == NULL) {
        ctx = (const struct parser_context *)(&tmp_ctx);
    }

    if (!json_gen_init(&g, ctx)) {
        *err = safe_strdup("Json_gen init failed");
        goto out;
    }
    if (yajl_gen_status_ok != gen_host_config(g, ptr, ctx, err)) {
        if (*err == NULL)
            *err = safe_strdup("Failed to generate json");
        goto free_out;
    }
    yajl_gen_get_buf(g, &gen_buf, &gen_len);
    if (gen_buf == NULL) {
        *err = safe_strdup("Error to get generated json");
        goto free_out;
    }

    json_buf = safe_malloc(gen_len + 1);
    (void)memcpy(json_buf, gen_buf, gen_len);
    json_buf[gen_len] = '\0';

free_out:
    yajl_gen_clear(g);
    yajl_gen_free(g);
out:
    return json_buf;
}

