// Generated from manifest-items.json. Do not edit!
#ifndef _GNU_SOURCE
#define _GNU_SOURCE
#endif
#include <string.h>
#include <read_file.h>
#include "image_manifest_items.h"

image_manifest_items_element *make_image_manifest_items_element(yajl_val tree, const struct parser_context *ctx, parser_error *err) {
    image_manifest_items_element *ret = NULL;
    *err = 0;
    if (tree == NULL)
        return ret;
    ret = safe_malloc(sizeof(*ret));
    {
        yajl_val val = get_val(tree, "Config", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->config = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val tmp = get_val(tree, "Layers", yajl_t_array);
        if (tmp != NULL && YAJL_GET_ARRAY(tmp) != NULL && YAJL_GET_ARRAY(tmp)->len > 0) {
            size_t i;
            ret->layers_len = YAJL_GET_ARRAY(tmp)->len;
            ret->layers = safe_malloc((YAJL_GET_ARRAY(tmp)->len + 1) * sizeof(*ret->layers));
            for (i = 0; i < YAJL_GET_ARRAY(tmp)->len; i++) {
                yajl_val val = YAJL_GET_ARRAY(tmp)->values[i];
                if (val != NULL) {
                    char *str = YAJL_GET_STRING(val);
                    ret->layers[i] = safe_strdup(str ? str : "");
                }
            }
        }
    }
    {
        yajl_val tmp = get_val(tree, "RepoTags", yajl_t_array);
        if (tmp != NULL && YAJL_GET_ARRAY(tmp) != NULL && YAJL_GET_ARRAY(tmp)->len > 0) {
            size_t i;
            ret->repo_tags_len = YAJL_GET_ARRAY(tmp)->len;
            ret->repo_tags = safe_malloc((YAJL_GET_ARRAY(tmp)->len + 1) * sizeof(*ret->repo_tags));
            for (i = 0; i < YAJL_GET_ARRAY(tmp)->len; i++) {
                yajl_val val = YAJL_GET_ARRAY(tmp)->values[i];
                if (val != NULL) {
                    char *str = YAJL_GET_STRING(val);
                    ret->repo_tags[i] = safe_strdup(str ? str : "");
                }
            }
        }
    }
    {
        yajl_val val = get_val(tree, "Parent", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->parent = safe_strdup(str ? str : "");
        }
    }
    if (ret->config == NULL) {
        if (asprintf(err, "Required field '%s' not present",  "Config") < 0)
            *err = safe_strdup("error allocating memory");
        free_image_manifest_items_element(ret);
        return NULL;
    }
    if (ret->layers == NULL) {
        if (asprintf(err, "Required field '%s' not present",  "Layers") < 0)
            *err = safe_strdup("error allocating memory");
        free_image_manifest_items_element(ret);
        return NULL;
    }
    return ret;
}

void free_image_manifest_items_element(image_manifest_items_element *ptr) {
    if (ptr == NULL)
        return;
    free(ptr->config);
    ptr->config = NULL;
    if (ptr->layers != NULL) {
        size_t i;
        for (i = 0; i < ptr->layers_len; i++) {
            if (ptr->layers[i] != NULL) {
                free(ptr->layers[i]);
                ptr->layers[i] = NULL;
            }
        }
        free(ptr->layers);
        ptr->layers = NULL;
    }
    if (ptr->repo_tags != NULL) {
        size_t i;
        for (i = 0; i < ptr->repo_tags_len; i++) {
            if (ptr->repo_tags[i] != NULL) {
                free(ptr->repo_tags[i]);
                ptr->repo_tags[i] = NULL;
            }
        }
        free(ptr->repo_tags);
        ptr->repo_tags = NULL;
    }
    free(ptr->parent);
    ptr->parent = NULL;
    free(ptr);
}

yajl_gen_status gen_image_manifest_items_element(yajl_gen g, const image_manifest_items_element *ptr, const struct parser_context *ctx, parser_error *err) {
    yajl_gen_status stat = yajl_gen_status_ok;
    *err = 0;
    stat = yajl_gen_map_open((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->config != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("Config"), strlen("Config"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->config != NULL) {
            str = ptr->config;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->layers != NULL)) {
        size_t len = 0, i;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("Layers"), strlen("Layers"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->layers != NULL) {
            len = ptr->layers_len;
        }
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 0);
        stat = yajl_gen_array_open((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        for (i = 0; i < len; i++) {
            stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(ptr->layers[i]), strlen(ptr->layers[i]));
            if (yajl_gen_status_ok != stat)
                GEN_SET_ERROR_AND_RETURN(stat, err);
        }
        stat = yajl_gen_array_close((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 1);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->repo_tags != NULL)) {
        size_t len = 0, i;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("RepoTags"), strlen("RepoTags"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->repo_tags != NULL) {
            len = ptr->repo_tags_len;
        }
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 0);
        stat = yajl_gen_array_open((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        for (i = 0; i < len; i++) {
            stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(ptr->repo_tags[i]), strlen(ptr->repo_tags[i]));
            if (yajl_gen_status_ok != stat)
                GEN_SET_ERROR_AND_RETURN(stat, err);
        }
        stat = yajl_gen_array_close((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 1);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->parent != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("Parent"), strlen("Parent"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->parent != NULL) {
            str = ptr->parent;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    stat = yajl_gen_map_close((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    return yajl_gen_status_ok;
}



image_manifest_items_element **make_image_manifest_items(yajl_val tree, const struct parser_context *ctx, parser_error *err, size_t *len) {
    image_manifest_items_element **ptr = NULL;
    size_t i, alen;
    if (tree == NULL || err == NULL || !len || YAJL_GET_ARRAY(tree) == NULL)
        return NULL;
    *err = 0;
    alen = YAJL_GET_ARRAY(tree)->len;
    if (alen == 0)
        return NULL;
    ptr = safe_malloc((alen + 1) * sizeof(image_manifest_items_element *));
    for (i = 0; i < alen; i++) {
        yajl_val val = YAJL_GET_ARRAY(tree)->values[i];
        ptr[i] = make_image_manifest_items_element(val, ctx, err);
        if (ptr[i] == NULL) {
            free_image_manifest_items(ptr, alen);
            return NULL;
        }
    }
    *len = alen;
    return ptr;
}


void free_image_manifest_items(image_manifest_items_element **ptr, size_t len) {
    size_t i;

    if (ptr == NULL || len == 0)
        return;

    for (i = 0; i < len; i++) {
        if (ptr[i] != NULL) {
            free_image_manifest_items_element(ptr[i]);
            ptr[i] = NULL;
        }
    }
    free(ptr);
}


yajl_gen_status gen_image_manifest_items(yajl_gen g, const image_manifest_items_element **ptr, size_t len, const struct parser_context *ctx,
                       parser_error *err) {
    yajl_gen_status stat;
    size_t i;
    *err = 0;
    stat = yajl_gen_array_open((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    for (i = 0; i < len; i++) {
        stat = gen_image_manifest_items_element(g, ptr[i], ctx, err);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    stat = yajl_gen_array_close((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    return yajl_gen_status_ok;
}

image_manifest_items_element **image_manifest_items_parse_file(const char *filename, const struct parser_context *ctx, parser_error *err, size_t *len) {
    image_manifest_items_element **ptr = NULL;
    size_t filesize;
    char *content = NULL;

    if (filename == NULL || err == NULL)
        return NULL;

    *err = NULL;
    content = read_file(filename, &filesize);
    if (content == NULL) {
        if (asprintf(err, "cannot read the file: %s", filename) < 0)
            *err = safe_strdup("error allocating memory");
        return NULL;
    }
    ptr = image_manifest_items_parse_data(content, ctx, err, len);
    free(content);
    return ptr;
}

image_manifest_items_element **image_manifest_items_parse_file_stream(FILE *stream, const struct parser_context *ctx, parser_error *err, size_t *len) {
    image_manifest_items_element **ptr = NULL;
    size_t filesize;
    char *content = NULL ;

    if (stream == NULL || err == NULL)
        return NULL;

    *err = NULL;
    content = fread_file(stream, &filesize);
    if (content == NULL) {
        *err = safe_strdup("cannot read the file");
        return NULL;
    }
    ptr = image_manifest_items_parse_data(content, ctx, err, len);
    free(content);
    return ptr;
}

image_manifest_items_element **image_manifest_items_parse_data(const char *jsondata, const struct parser_context *ctx, parser_error *err, size_t *len) {
    image_manifest_items_element **ptr = NULL;
    yajl_val tree;
    char errbuf[1024];
    struct parser_context tmp_ctx = { 0 };

    if (jsondata == NULL || err == NULL)
        return NULL;

    *err = NULL;
    if (ctx == NULL) {
       ctx = (const struct parser_context *)(&tmp_ctx);
    }
    tree = yajl_tree_parse(jsondata, errbuf, sizeof(errbuf));
    if (tree == NULL) {
        if (asprintf(err, "cannot parse the data: %s", errbuf) < 0)
            *err = safe_strdup("error allocating memory");
        return NULL;
    }
    ptr = make_image_manifest_items(tree, ctx, err, len);
    yajl_tree_free(tree);
    return ptr;
}
char *image_manifest_items_generate_json(const image_manifest_items_element **ptr, size_t len, const struct parser_context *ctx, parser_error *err) {
    yajl_gen g = NULL;
    struct parser_context tmp_ctx = { 0 };
    const unsigned char *gen_buf = NULL;
    char *json_buf = NULL;
    size_t gen_len = 0;

    if (ptr == NULL || err == NULL)
        return NULL;

    *err = NULL;
    if (ctx == NULL) {
        ctx = (const struct parser_context *)(&tmp_ctx);
    }

    if (!json_gen_init(&g, ctx)) {
        *err = safe_strdup("Json_gen init failed");
        goto out;
    }
    if (yajl_gen_status_ok != gen_image_manifest_items(g, ptr, len, ctx, err)) {
        if (*err == NULL)
            *err = safe_strdup("Failed to generate json");
        goto free_out;
    }
    yajl_gen_get_buf(g, &gen_buf, &gen_len);
    if (gen_buf == NULL) {
        *err = safe_strdup("Error to get generated json");
        goto free_out;
    }

    json_buf = safe_malloc(gen_len + 1);
    (void)memcpy(json_buf, gen_buf, gen_len);
    json_buf[gen_len] = '\0';

free_out:
    yajl_gen_clear(g);
    yajl_gen_free(g);
out:
    return json_buf;
}

