// Generated from config-linux.json. Do not edit!
#ifndef _GNU_SOURCE
#define _GNU_SOURCE
#endif
#include <string.h>
#include <read_file.h>
#include "oci_runtime_config_linux.h"

oci_runtime_config_linux_seccomp *make_oci_runtime_config_linux_seccomp(yajl_val tree, const struct parser_context *ctx, parser_error *err) {
    oci_runtime_config_linux_seccomp *ret = NULL;
    *err = 0;
    if (tree == NULL)
        return ret;
    ret = safe_malloc(sizeof(*ret));
    {
        yajl_val val = get_val(tree, "defaultAction", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->default_action = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val tmp = get_val(tree, "architectures", yajl_t_array);
        if (tmp != NULL && YAJL_GET_ARRAY(tmp) != NULL && YAJL_GET_ARRAY(tmp)->len > 0) {
            size_t i;
            ret->architectures_len = YAJL_GET_ARRAY(tmp)->len;
            ret->architectures = safe_malloc((YAJL_GET_ARRAY(tmp)->len + 1) * sizeof(*ret->architectures));
            for (i = 0; i < YAJL_GET_ARRAY(tmp)->len; i++) {
                yajl_val val = YAJL_GET_ARRAY(tmp)->values[i];
                if (val != NULL) {
                    char *str = YAJL_GET_STRING(val);
                    ret->architectures[i] = safe_strdup(str ? str : "");
                }
            }
        }
    }
    {
        yajl_val tmp = get_val(tree, "syscalls", yajl_t_array);
        if (tmp != NULL && YAJL_GET_ARRAY(tmp) != NULL && YAJL_GET_ARRAY(tmp)->len > 0) {
            size_t i;
            ret->syscalls_len = YAJL_GET_ARRAY(tmp)->len;
            ret->syscalls = safe_malloc((YAJL_GET_ARRAY(tmp)->len + 1) * sizeof(*ret->syscalls));
            for (i = 0; i < YAJL_GET_ARRAY(tmp)->len; i++) {
                yajl_val val = YAJL_GET_ARRAY(tmp)->values[i];
                ret->syscalls[i] = make_defs_syscall(val, ctx, err);
                if (ret->syscalls[i] == NULL) {
                    free_oci_runtime_config_linux_seccomp(ret);
                    return NULL;
                }
            }
        }
    }
    if (ret->default_action == NULL) {
        if (asprintf(err, "Required field '%s' not present",  "defaultAction") < 0)
            *err = safe_strdup("error allocating memory");
        free_oci_runtime_config_linux_seccomp(ret);
        return NULL;
    }

    if (tree->type == yajl_t_object)
    {
        size_t i;
        size_t j = 0;
        size_t cnt = tree->u.object.len;
        yajl_val resi = NULL;

        if (ctx->options & OPT_PARSE_FULLKEY)
        {
            resi = calloc (1, sizeof(*tree));
            if (resi == NULL)
            {
                free_oci_runtime_config_linux_seccomp(ret);
                return NULL;
            }
            resi->type = yajl_t_object;
            resi->u.object.keys = calloc (cnt, sizeof (const char *));
            if (resi->u.object.keys == NULL)
            {
               free_oci_runtime_config_linux_seccomp(ret);
               yajl_tree_free(resi);
               return NULL;
            }
            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
            if (resi->u.object.values == NULL)
            {
               free_oci_runtime_config_linux_seccomp(ret);
               yajl_tree_free(resi);
               return NULL;
            }
        }
        for (i = 0; i < tree->u.object.len; i++)
        {
           if (strcmp(tree->u.object.keys[i], "defaultAction") &&
                strcmp(tree->u.object.keys[i], "architectures") &&
                strcmp(tree->u.object.keys[i], "syscalls"))
           {
              if (ctx->options & OPT_PARSE_FULLKEY)
              {
                 resi->u.object.keys[j] = tree->u.object.keys[i];
                 tree->u.object.keys[i] = NULL;
                 resi->u.object.values[j] = tree->u.object.values[i];
                 tree->u.object.values[i] = NULL;
                 resi->u.object.len++;
              }
              j++;
           }
        }
        if (ctx->options & OPT_PARSE_STRICT)
        {
            if (j > 0 && ctx->stderr > 0)
                fprintf (ctx->stderr, "WARNING: unknown key found\n");
        }
        if (ctx->options & OPT_PARSE_FULLKEY)
            ret->_residual = resi;
        }
    return ret;
}

void free_oci_runtime_config_linux_seccomp(oci_runtime_config_linux_seccomp *ptr) {
    if (ptr == NULL)
        return;
    free(ptr->default_action);
    ptr->default_action = NULL;
    if (ptr->architectures != NULL) {
        size_t i;
        for (i = 0; i < ptr->architectures_len; i++) {
            if (ptr->architectures[i] != NULL) {
                free(ptr->architectures[i]);
                ptr->architectures[i] = NULL;
            }
        }
        free(ptr->architectures);
        ptr->architectures = NULL;
    }
    if (ptr->syscalls != NULL) {
        size_t i;
        for (i = 0; i < ptr->syscalls_len; i++)
            if (ptr->syscalls[i] != NULL) {
                free_defs_syscall(ptr->syscalls[i]);
                ptr->syscalls[i] = NULL;
            }
        free(ptr->syscalls);
        ptr->syscalls = NULL;
    }
    yajl_tree_free (ptr->_residual);
    ptr->_residual = NULL;
    free(ptr);
}

yajl_gen_status gen_oci_runtime_config_linux_seccomp(yajl_gen g, const oci_runtime_config_linux_seccomp *ptr, const struct parser_context *ctx, parser_error *err) {
    yajl_gen_status stat = yajl_gen_status_ok;
    *err = 0;
    stat = yajl_gen_map_open((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->default_action != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("defaultAction"), strlen("defaultAction"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->default_action != NULL) {
            str = ptr->default_action;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->architectures != NULL)) {
        size_t len = 0, i;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("architectures"), strlen("architectures"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->architectures != NULL) {
            len = ptr->architectures_len;
        }
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 0);
        stat = yajl_gen_array_open((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        for (i = 0; i < len; i++) {
            stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(ptr->architectures[i]), strlen(ptr->architectures[i]));
            if (yajl_gen_status_ok != stat)
                GEN_SET_ERROR_AND_RETURN(stat, err);
        }
        stat = yajl_gen_array_close((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 1);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->syscalls != NULL)) {
        size_t len = 0, i;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("syscalls"), strlen("syscalls"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->syscalls != NULL) {
            len = ptr->syscalls_len;
        }
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 0);
        stat = yajl_gen_array_open((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        for (i = 0; i < len; i++) {
            stat = gen_defs_syscall(g, ptr->syscalls[i], ctx, err);
            if (yajl_gen_status_ok != stat)
                GEN_SET_ERROR_AND_RETURN(stat, err);
        }
        stat = yajl_gen_array_close((yajl_gen)g);
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 1);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if (ptr != NULL && ptr->_residual != NULL)
    {
        stat = gen_yajl_object_residual (ptr->_residual, g, err);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN (stat, err);
    }
    stat = yajl_gen_map_close((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    return yajl_gen_status_ok;
}

oci_runtime_config_linux *make_oci_runtime_config_linux(yajl_val tree, const struct parser_context *ctx, parser_error *err) {
    oci_runtime_config_linux *ret = NULL;
    *err = 0;
    if (tree == NULL)
        return ret;
    ret = safe_malloc(sizeof(*ret));
    {
        yajl_val tmp = get_val(tree, "devices", yajl_t_array);
        if (tmp != NULL && YAJL_GET_ARRAY(tmp) != NULL && YAJL_GET_ARRAY(tmp)->len > 0) {
            size_t i;
            ret->devices_len = YAJL_GET_ARRAY(tmp)->len;
            ret->devices = safe_malloc((YAJL_GET_ARRAY(tmp)->len + 1) * sizeof(*ret->devices));
            for (i = 0; i < YAJL_GET_ARRAY(tmp)->len; i++) {
                yajl_val val = YAJL_GET_ARRAY(tmp)->values[i];
                ret->devices[i] = make_defs_device(val, ctx, err);
                if (ret->devices[i] == NULL) {
                    free_oci_runtime_config_linux(ret);
                    return NULL;
                }
            }
        }
    }
    {
        yajl_val tmp = get_val(tree, "uidMappings", yajl_t_array);
        if (tmp != NULL && YAJL_GET_ARRAY(tmp) != NULL && YAJL_GET_ARRAY(tmp)->len > 0) {
            size_t i;
            ret->uid_mappings_len = YAJL_GET_ARRAY(tmp)->len;
            ret->uid_mappings = safe_malloc((YAJL_GET_ARRAY(tmp)->len + 1) * sizeof(*ret->uid_mappings));
            for (i = 0; i < YAJL_GET_ARRAY(tmp)->len; i++) {
                yajl_val val = YAJL_GET_ARRAY(tmp)->values[i];
                ret->uid_mappings[i] = make_defs_id_mapping(val, ctx, err);
                if (ret->uid_mappings[i] == NULL) {
                    free_oci_runtime_config_linux(ret);
                    return NULL;
                }
            }
        }
    }
    {
        yajl_val tmp = get_val(tree, "gidMappings", yajl_t_array);
        if (tmp != NULL && YAJL_GET_ARRAY(tmp) != NULL && YAJL_GET_ARRAY(tmp)->len > 0) {
            size_t i;
            ret->gid_mappings_len = YAJL_GET_ARRAY(tmp)->len;
            ret->gid_mappings = safe_malloc((YAJL_GET_ARRAY(tmp)->len + 1) * sizeof(*ret->gid_mappings));
            for (i = 0; i < YAJL_GET_ARRAY(tmp)->len; i++) {
                yajl_val val = YAJL_GET_ARRAY(tmp)->values[i];
                ret->gid_mappings[i] = make_defs_id_mapping(val, ctx, err);
                if (ret->gid_mappings[i] == NULL) {
                    free_oci_runtime_config_linux(ret);
                    return NULL;
                }
            }
        }
    }
    {
        yajl_val tmp = get_val(tree, "namespaces", yajl_t_array);
        if (tmp != NULL && YAJL_GET_ARRAY(tmp) != NULL && YAJL_GET_ARRAY(tmp)->len > 0) {
            size_t i;
            ret->namespaces_len = YAJL_GET_ARRAY(tmp)->len;
            ret->namespaces = safe_malloc((YAJL_GET_ARRAY(tmp)->len + 1) * sizeof(*ret->namespaces));
            for (i = 0; i < YAJL_GET_ARRAY(tmp)->len; i++) {
                yajl_val val = YAJL_GET_ARRAY(tmp)->values[i];
                ret->namespaces[i] = make_defs_namespace_reference(val, ctx, err);
                if (ret->namespaces[i] == NULL) {
                    free_oci_runtime_config_linux(ret);
                    return NULL;
                }
            }
        }
    }
    ret->resources = make_defs_resources(get_val(tree, "resources", yajl_t_object), ctx, err);
    if (ret->resources == NULL && *err != 0) {
        free_oci_runtime_config_linux(ret);
        return NULL;
    }
    {
        yajl_val val = get_val(tree, "cgroupsPath", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->cgroups_path = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val val = get_val(tree, "rootfsPropagation", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->rootfs_propagation = safe_strdup(str ? str : "");
        }
    }
    ret->seccomp = make_oci_runtime_config_linux_seccomp(get_val(tree, "seccomp", yajl_t_object), ctx, err);
    if (ret->seccomp == NULL && *err != 0) {
        free_oci_runtime_config_linux(ret);
        return NULL;
    }
    {
        yajl_val tmp = get_val(tree, "sysctl", yajl_t_object);
        if (tmp != NULL) {
            ret->sysctl = make_json_map_string_string(tmp, ctx, err);
            if (ret->sysctl == NULL) {
                char *new_error = NULL;
                if (asprintf(&new_error, "Value error for key 'sysctl': %s", *err ? *err : "null") < 0) {
                    new_error = safe_strdup("error allocating memory");
                }
                free(*err);
                *err = new_error;
                free_oci_runtime_config_linux(ret);
                return NULL;
            }
        }
    }
    {
        yajl_val tmp = get_val(tree, "maskedPaths", yajl_t_array);
        if (tmp != NULL && YAJL_GET_ARRAY(tmp) != NULL && YAJL_GET_ARRAY(tmp)->len > 0) {
            size_t i;
            ret->masked_paths_len = YAJL_GET_ARRAY(tmp)->len;
            ret->masked_paths = safe_malloc((YAJL_GET_ARRAY(tmp)->len + 1) * sizeof(*ret->masked_paths));
            for (i = 0; i < YAJL_GET_ARRAY(tmp)->len; i++) {
                yajl_val val = YAJL_GET_ARRAY(tmp)->values[i];
                if (val != NULL) {
                    char *str = YAJL_GET_STRING(val);
                    ret->masked_paths[i] = safe_strdup(str ? str : "");
                }
            }
        }
    }
    {
        yajl_val tmp = get_val(tree, "readonlyPaths", yajl_t_array);
        if (tmp != NULL && YAJL_GET_ARRAY(tmp) != NULL && YAJL_GET_ARRAY(tmp)->len > 0) {
            size_t i;
            ret->readonly_paths_len = YAJL_GET_ARRAY(tmp)->len;
            ret->readonly_paths = safe_malloc((YAJL_GET_ARRAY(tmp)->len + 1) * sizeof(*ret->readonly_paths));
            for (i = 0; i < YAJL_GET_ARRAY(tmp)->len; i++) {
                yajl_val val = YAJL_GET_ARRAY(tmp)->values[i];
                if (val != NULL) {
                    char *str = YAJL_GET_STRING(val);
                    ret->readonly_paths[i] = safe_strdup(str ? str : "");
                }
            }
        }
    }
    {
        yajl_val val = get_val(tree, "mountLabel", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->mount_label = safe_strdup(str ? str : "");
        }
    }

    if (tree->type == yajl_t_object)
    {
        size_t i;
        size_t j = 0;
        size_t cnt = tree->u.object.len;
        yajl_val resi = NULL;

        if (ctx->options & OPT_PARSE_FULLKEY)
        {
            resi = calloc (1, sizeof(*tree));
            if (resi == NULL)
            {
                free_oci_runtime_config_linux(ret);
                return NULL;
            }
            resi->type = yajl_t_object;
            resi->u.object.keys = calloc (cnt, sizeof (const char *));
            if (resi->u.object.keys == NULL)
            {
               free_oci_runtime_config_linux(ret);
               yajl_tree_free(resi);
               return NULL;
            }
            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
            if (resi->u.object.values == NULL)
            {
               free_oci_runtime_config_linux(ret);
               yajl_tree_free(resi);
               return NULL;
            }
        }
        for (i = 0; i < tree->u.object.len; i++)
        {
           if (strcmp(tree->u.object.keys[i], "devices") &&
                strcmp(tree->u.object.keys[i], "uidMappings") &&
                strcmp(tree->u.object.keys[i], "gidMappings") &&
                strcmp(tree->u.object.keys[i], "namespaces") &&
                strcmp(tree->u.object.keys[i], "resources") &&
                strcmp(tree->u.object.keys[i], "cgroupsPath") &&
                strcmp(tree->u.object.keys[i], "rootfsPropagation") &&
                strcmp(tree->u.object.keys[i], "seccomp") &&
                strcmp(tree->u.object.keys[i], "sysctl") &&
                strcmp(tree->u.object.keys[i], "maskedPaths") &&
                strcmp(tree->u.object.keys[i], "readonlyPaths") &&
                strcmp(tree->u.object.keys[i], "mountLabel"))
           {
              if (ctx->options & OPT_PARSE_FULLKEY)
              {
                 resi->u.object.keys[j] = tree->u.object.keys[i];
                 tree->u.object.keys[i] = NULL;
                 resi->u.object.values[j] = tree->u.object.values[i];
                 tree->u.object.values[i] = NULL;
                 resi->u.object.len++;
              }
              j++;
           }
        }
        if (ctx->options & OPT_PARSE_STRICT)
        {
            if (j > 0 && ctx->stderr > 0)
                fprintf (ctx->stderr, "WARNING: unknown key found\n");
        }
        if (ctx->options & OPT_PARSE_FULLKEY)
            ret->_residual = resi;
        }
    return ret;
}

void free_oci_runtime_config_linux(oci_runtime_config_linux *ptr) {
    if (ptr == NULL)
        return;
    if (ptr->devices != NULL) {
        size_t i;
        for (i = 0; i < ptr->devices_len; i++)
            if (ptr->devices[i] != NULL) {
                free_defs_device(ptr->devices[i]);
                ptr->devices[i] = NULL;
            }
        free(ptr->devices);
        ptr->devices = NULL;
    }
    if (ptr->uid_mappings != NULL) {
        size_t i;
        for (i = 0; i < ptr->uid_mappings_len; i++)
            if (ptr->uid_mappings[i] != NULL) {
                free_defs_id_mapping(ptr->uid_mappings[i]);
                ptr->uid_mappings[i] = NULL;
            }
        free(ptr->uid_mappings);
        ptr->uid_mappings = NULL;
    }
    if (ptr->gid_mappings != NULL) {
        size_t i;
        for (i = 0; i < ptr->gid_mappings_len; i++)
            if (ptr->gid_mappings[i] != NULL) {
                free_defs_id_mapping(ptr->gid_mappings[i]);
                ptr->gid_mappings[i] = NULL;
            }
        free(ptr->gid_mappings);
        ptr->gid_mappings = NULL;
    }
    if (ptr->namespaces != NULL) {
        size_t i;
        for (i = 0; i < ptr->namespaces_len; i++)
            if (ptr->namespaces[i] != NULL) {
                free_defs_namespace_reference(ptr->namespaces[i]);
                ptr->namespaces[i] = NULL;
            }
        free(ptr->namespaces);
        ptr->namespaces = NULL;
    }
    if (ptr->resources != NULL) {
        free_defs_resources(ptr->resources);
        ptr->resources = NULL;
    }
    free(ptr->cgroups_path);
    ptr->cgroups_path = NULL;
    free(ptr->rootfs_propagation);
    ptr->rootfs_propagation = NULL;
    if (ptr->seccomp != NULL) {
        free_oci_runtime_config_linux_seccomp(ptr->seccomp);
        ptr->seccomp = NULL;
    }
    free_json_map_string_string(ptr->sysctl);
    ptr->sysctl = NULL;
    if (ptr->masked_paths != NULL) {
        size_t i;
        for (i = 0; i < ptr->masked_paths_len; i++) {
            if (ptr->masked_paths[i] != NULL) {
                free(ptr->masked_paths[i]);
                ptr->masked_paths[i] = NULL;
            }
        }
        free(ptr->masked_paths);
        ptr->masked_paths = NULL;
    }
    if (ptr->readonly_paths != NULL) {
        size_t i;
        for (i = 0; i < ptr->readonly_paths_len; i++) {
            if (ptr->readonly_paths[i] != NULL) {
                free(ptr->readonly_paths[i]);
                ptr->readonly_paths[i] = NULL;
            }
        }
        free(ptr->readonly_paths);
        ptr->readonly_paths = NULL;
    }
    free(ptr->mount_label);
    ptr->mount_label = NULL;
    yajl_tree_free (ptr->_residual);
    ptr->_residual = NULL;
    free(ptr);
}

yajl_gen_status gen_oci_runtime_config_linux(yajl_gen g, const oci_runtime_config_linux *ptr, const struct parser_context *ctx, parser_error *err) {
    yajl_gen_status stat = yajl_gen_status_ok;
    *err = 0;
    stat = yajl_gen_map_open((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->devices != NULL)) {
        size_t len = 0, i;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("devices"), strlen("devices"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->devices != NULL) {
            len = ptr->devices_len;
        }
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 0);
        stat = yajl_gen_array_open((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        for (i = 0; i < len; i++) {
            stat = gen_defs_device(g, ptr->devices[i], ctx, err);
            if (yajl_gen_status_ok != stat)
                GEN_SET_ERROR_AND_RETURN(stat, err);
        }
        stat = yajl_gen_array_close((yajl_gen)g);
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 1);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->uid_mappings != NULL)) {
        size_t len = 0, i;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("uidMappings"), strlen("uidMappings"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->uid_mappings != NULL) {
            len = ptr->uid_mappings_len;
        }
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 0);
        stat = yajl_gen_array_open((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        for (i = 0; i < len; i++) {
            stat = gen_defs_id_mapping(g, ptr->uid_mappings[i], ctx, err);
            if (yajl_gen_status_ok != stat)
                GEN_SET_ERROR_AND_RETURN(stat, err);
        }
        stat = yajl_gen_array_close((yajl_gen)g);
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 1);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->gid_mappings != NULL)) {
        size_t len = 0, i;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("gidMappings"), strlen("gidMappings"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->gid_mappings != NULL) {
            len = ptr->gid_mappings_len;
        }
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 0);
        stat = yajl_gen_array_open((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        for (i = 0; i < len; i++) {
            stat = gen_defs_id_mapping(g, ptr->gid_mappings[i], ctx, err);
            if (yajl_gen_status_ok != stat)
                GEN_SET_ERROR_AND_RETURN(stat, err);
        }
        stat = yajl_gen_array_close((yajl_gen)g);
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 1);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->namespaces != NULL)) {
        size_t len = 0, i;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("namespaces"), strlen("namespaces"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->namespaces != NULL) {
            len = ptr->namespaces_len;
        }
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 0);
        stat = yajl_gen_array_open((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        for (i = 0; i < len; i++) {
            stat = gen_defs_namespace_reference(g, ptr->namespaces[i], ctx, err);
            if (yajl_gen_status_ok != stat)
                GEN_SET_ERROR_AND_RETURN(stat, err);
        }
        stat = yajl_gen_array_close((yajl_gen)g);
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 1);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->resources != NULL)) {
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("resources"), strlen("resources"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        stat = gen_defs_resources(g, ptr != NULL ? ptr->resources : NULL, ctx, err);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->cgroups_path != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("cgroupsPath"), strlen("cgroupsPath"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->cgroups_path != NULL) {
            str = ptr->cgroups_path;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->rootfs_propagation != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("rootfsPropagation"), strlen("rootfsPropagation"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->rootfs_propagation != NULL) {
            str = ptr->rootfs_propagation;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->seccomp != NULL)) {
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("seccomp"), strlen("seccomp"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        stat = gen_oci_runtime_config_linux_seccomp(g, ptr != NULL ? ptr->seccomp : NULL, ctx, err);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->sysctl != NULL)) {
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)("sysctl"), strlen("sysctl"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        stat = gen_json_map_string_string(g, ptr ? ptr->sysctl : NULL, ctx, err);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->masked_paths != NULL)) {
        size_t len = 0, i;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("maskedPaths"), strlen("maskedPaths"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->masked_paths != NULL) {
            len = ptr->masked_paths_len;
        }
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 0);
        stat = yajl_gen_array_open((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        for (i = 0; i < len; i++) {
            stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(ptr->masked_paths[i]), strlen(ptr->masked_paths[i]));
            if (yajl_gen_status_ok != stat)
                GEN_SET_ERROR_AND_RETURN(stat, err);
        }
        stat = yajl_gen_array_close((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 1);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->readonly_paths != NULL)) {
        size_t len = 0, i;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("readonlyPaths"), strlen("readonlyPaths"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->readonly_paths != NULL) {
            len = ptr->readonly_paths_len;
        }
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 0);
        stat = yajl_gen_array_open((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        for (i = 0; i < len; i++) {
            stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(ptr->readonly_paths[i]), strlen(ptr->readonly_paths[i]));
            if (yajl_gen_status_ok != stat)
                GEN_SET_ERROR_AND_RETURN(stat, err);
        }
        stat = yajl_gen_array_close((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 1);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->mount_label != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("mountLabel"), strlen("mountLabel"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->mount_label != NULL) {
            str = ptr->mount_label;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if (ptr != NULL && ptr->_residual != NULL)
    {
        stat = gen_yajl_object_residual (ptr->_residual, g, err);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN (stat, err);
    }
    stat = yajl_gen_map_close((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    return yajl_gen_status_ok;
}

