// Generated from spec.json. Do not edit!
#ifndef _GNU_SOURCE
#define _GNU_SOURCE
#endif
#include <string.h>
#include <read_file.h>
#include "oci_runtime_spec.h"

oci_runtime_spec_hooks *make_oci_runtime_spec_hooks(yajl_val tree, const struct parser_context *ctx, parser_error *err) {
    oci_runtime_spec_hooks *ret = NULL;
    *err = 0;
    if (tree == NULL)
        return ret;
    ret = safe_malloc(sizeof(*ret));
    {
        yajl_val tmp = get_val(tree, "prestart", yajl_t_array);
        if (tmp != NULL && YAJL_GET_ARRAY(tmp) != NULL && YAJL_GET_ARRAY(tmp)->len > 0) {
            size_t i;
            ret->prestart_len = YAJL_GET_ARRAY(tmp)->len;
            ret->prestart = safe_malloc((YAJL_GET_ARRAY(tmp)->len + 1) * sizeof(*ret->prestart));
            for (i = 0; i < YAJL_GET_ARRAY(tmp)->len; i++) {
                yajl_val val = YAJL_GET_ARRAY(tmp)->values[i];
                ret->prestart[i] = make_defs_hook(val, ctx, err);
                if (ret->prestart[i] == NULL) {
                    free_oci_runtime_spec_hooks(ret);
                    return NULL;
                }
            }
        }
    }
    {
        yajl_val tmp = get_val(tree, "poststart", yajl_t_array);
        if (tmp != NULL && YAJL_GET_ARRAY(tmp) != NULL && YAJL_GET_ARRAY(tmp)->len > 0) {
            size_t i;
            ret->poststart_len = YAJL_GET_ARRAY(tmp)->len;
            ret->poststart = safe_malloc((YAJL_GET_ARRAY(tmp)->len + 1) * sizeof(*ret->poststart));
            for (i = 0; i < YAJL_GET_ARRAY(tmp)->len; i++) {
                yajl_val val = YAJL_GET_ARRAY(tmp)->values[i];
                ret->poststart[i] = make_defs_hook(val, ctx, err);
                if (ret->poststart[i] == NULL) {
                    free_oci_runtime_spec_hooks(ret);
                    return NULL;
                }
            }
        }
    }
    {
        yajl_val tmp = get_val(tree, "poststop", yajl_t_array);
        if (tmp != NULL && YAJL_GET_ARRAY(tmp) != NULL && YAJL_GET_ARRAY(tmp)->len > 0) {
            size_t i;
            ret->poststop_len = YAJL_GET_ARRAY(tmp)->len;
            ret->poststop = safe_malloc((YAJL_GET_ARRAY(tmp)->len + 1) * sizeof(*ret->poststop));
            for (i = 0; i < YAJL_GET_ARRAY(tmp)->len; i++) {
                yajl_val val = YAJL_GET_ARRAY(tmp)->values[i];
                ret->poststop[i] = make_defs_hook(val, ctx, err);
                if (ret->poststop[i] == NULL) {
                    free_oci_runtime_spec_hooks(ret);
                    return NULL;
                }
            }
        }
    }

    if (tree->type == yajl_t_object)
    {
        size_t i;
        size_t j = 0;
        size_t cnt = tree->u.object.len;
        yajl_val resi = NULL;

        if (ctx->options & OPT_PARSE_FULLKEY)
        {
            resi = calloc (1, sizeof(*tree));
            if (resi == NULL)
            {
                free_oci_runtime_spec_hooks(ret);
                return NULL;
            }
            resi->type = yajl_t_object;
            resi->u.object.keys = calloc (cnt, sizeof (const char *));
            if (resi->u.object.keys == NULL)
            {
               free_oci_runtime_spec_hooks(ret);
               yajl_tree_free(resi);
               return NULL;
            }
            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
            if (resi->u.object.values == NULL)
            {
               free_oci_runtime_spec_hooks(ret);
               yajl_tree_free(resi);
               return NULL;
            }
        }
        for (i = 0; i < tree->u.object.len; i++)
        {
           if (strcmp(tree->u.object.keys[i], "prestart") &&
                strcmp(tree->u.object.keys[i], "poststart") &&
                strcmp(tree->u.object.keys[i], "poststop"))
           {
              if (ctx->options & OPT_PARSE_FULLKEY)
              {
                 resi->u.object.keys[j] = tree->u.object.keys[i];
                 tree->u.object.keys[i] = NULL;
                 resi->u.object.values[j] = tree->u.object.values[i];
                 tree->u.object.values[i] = NULL;
                 resi->u.object.len++;
              }
              j++;
           }
        }
        if (ctx->options & OPT_PARSE_STRICT)
        {
            if (j > 0 && ctx->stderr > 0)
                fprintf (ctx->stderr, "WARNING: unknown key found\n");
        }
        if (ctx->options & OPT_PARSE_FULLKEY)
            ret->_residual = resi;
        }
    return ret;
}

void free_oci_runtime_spec_hooks(oci_runtime_spec_hooks *ptr) {
    if (ptr == NULL)
        return;
    if (ptr->prestart != NULL) {
        size_t i;
        for (i = 0; i < ptr->prestart_len; i++)
            if (ptr->prestart[i] != NULL) {
                free_defs_hook(ptr->prestart[i]);
                ptr->prestart[i] = NULL;
            }
        free(ptr->prestart);
        ptr->prestart = NULL;
    }
    if (ptr->poststart != NULL) {
        size_t i;
        for (i = 0; i < ptr->poststart_len; i++)
            if (ptr->poststart[i] != NULL) {
                free_defs_hook(ptr->poststart[i]);
                ptr->poststart[i] = NULL;
            }
        free(ptr->poststart);
        ptr->poststart = NULL;
    }
    if (ptr->poststop != NULL) {
        size_t i;
        for (i = 0; i < ptr->poststop_len; i++)
            if (ptr->poststop[i] != NULL) {
                free_defs_hook(ptr->poststop[i]);
                ptr->poststop[i] = NULL;
            }
        free(ptr->poststop);
        ptr->poststop = NULL;
    }
    yajl_tree_free (ptr->_residual);
    ptr->_residual = NULL;
    free(ptr);
}

yajl_gen_status gen_oci_runtime_spec_hooks(yajl_gen g, const oci_runtime_spec_hooks *ptr, const struct parser_context *ctx, parser_error *err) {
    yajl_gen_status stat = yajl_gen_status_ok;
    *err = 0;
    stat = yajl_gen_map_open((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->prestart != NULL)) {
        size_t len = 0, i;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("prestart"), strlen("prestart"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->prestart != NULL) {
            len = ptr->prestart_len;
        }
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 0);
        stat = yajl_gen_array_open((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        for (i = 0; i < len; i++) {
            stat = gen_defs_hook(g, ptr->prestart[i], ctx, err);
            if (yajl_gen_status_ok != stat)
                GEN_SET_ERROR_AND_RETURN(stat, err);
        }
        stat = yajl_gen_array_close((yajl_gen)g);
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 1);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->poststart != NULL)) {
        size_t len = 0, i;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("poststart"), strlen("poststart"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->poststart != NULL) {
            len = ptr->poststart_len;
        }
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 0);
        stat = yajl_gen_array_open((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        for (i = 0; i < len; i++) {
            stat = gen_defs_hook(g, ptr->poststart[i], ctx, err);
            if (yajl_gen_status_ok != stat)
                GEN_SET_ERROR_AND_RETURN(stat, err);
        }
        stat = yajl_gen_array_close((yajl_gen)g);
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 1);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->poststop != NULL)) {
        size_t len = 0, i;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("poststop"), strlen("poststop"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->poststop != NULL) {
            len = ptr->poststop_len;
        }
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 0);
        stat = yajl_gen_array_open((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        for (i = 0; i < len; i++) {
            stat = gen_defs_hook(g, ptr->poststop[i], ctx, err);
            if (yajl_gen_status_ok != stat)
                GEN_SET_ERROR_AND_RETURN(stat, err);
        }
        stat = yajl_gen_array_close((yajl_gen)g);
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 1);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if (ptr != NULL && ptr->_residual != NULL)
    {
        stat = gen_yajl_object_residual (ptr->_residual, g, err);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN (stat, err);
    }
    stat = yajl_gen_map_close((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    return yajl_gen_status_ok;
}

oci_runtime_spec_root *make_oci_runtime_spec_root(yajl_val tree, const struct parser_context *ctx, parser_error *err) {
    oci_runtime_spec_root *ret = NULL;
    *err = 0;
    if (tree == NULL)
        return ret;
    ret = safe_malloc(sizeof(*ret));
    {
        yajl_val val = get_val(tree, "path", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->path = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val val = get_val(tree, "readonly", yajl_t_true);
        if (val != NULL)
            ret->readonly = YAJL_IS_TRUE(val);
    }
    if (ret->path == NULL) {
        if (asprintf(err, "Required field '%s' not present",  "path") < 0)
            *err = safe_strdup("error allocating memory");
        free_oci_runtime_spec_root(ret);
        return NULL;
    }

    if (tree->type == yajl_t_object)
    {
        size_t i;
        size_t j = 0;
        size_t cnt = tree->u.object.len;
        yajl_val resi = NULL;

        if (ctx->options & OPT_PARSE_FULLKEY)
        {
            resi = calloc (1, sizeof(*tree));
            if (resi == NULL)
            {
                free_oci_runtime_spec_root(ret);
                return NULL;
            }
            resi->type = yajl_t_object;
            resi->u.object.keys = calloc (cnt, sizeof (const char *));
            if (resi->u.object.keys == NULL)
            {
               free_oci_runtime_spec_root(ret);
               yajl_tree_free(resi);
               return NULL;
            }
            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
            if (resi->u.object.values == NULL)
            {
               free_oci_runtime_spec_root(ret);
               yajl_tree_free(resi);
               return NULL;
            }
        }
        for (i = 0; i < tree->u.object.len; i++)
        {
           if (strcmp(tree->u.object.keys[i], "path") &&
                strcmp(tree->u.object.keys[i], "readonly"))
           {
              if (ctx->options & OPT_PARSE_FULLKEY)
              {
                 resi->u.object.keys[j] = tree->u.object.keys[i];
                 tree->u.object.keys[i] = NULL;
                 resi->u.object.values[j] = tree->u.object.values[i];
                 tree->u.object.values[i] = NULL;
                 resi->u.object.len++;
              }
              j++;
           }
        }
        if (ctx->options & OPT_PARSE_STRICT)
        {
            if (j > 0 && ctx->stderr > 0)
                fprintf (ctx->stderr, "WARNING: unknown key found\n");
        }
        if (ctx->options & OPT_PARSE_FULLKEY)
            ret->_residual = resi;
        }
    return ret;
}

void free_oci_runtime_spec_root(oci_runtime_spec_root *ptr) {
    if (ptr == NULL)
        return;
    free(ptr->path);
    ptr->path = NULL;
    yajl_tree_free (ptr->_residual);
    ptr->_residual = NULL;
    free(ptr);
}

yajl_gen_status gen_oci_runtime_spec_root(yajl_gen g, const oci_runtime_spec_root *ptr, const struct parser_context *ctx, parser_error *err) {
    yajl_gen_status stat = yajl_gen_status_ok;
    *err = 0;
    stat = yajl_gen_map_open((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->path != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("path"), strlen("path"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->path != NULL) {
            str = ptr->path;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->readonly)) {
        bool b = false;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("readonly"), strlen("readonly"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->readonly) {
            b = ptr->readonly;
        }
        stat = yajl_gen_bool((yajl_gen)g, (int)(b));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if (ptr != NULL && ptr->_residual != NULL)
    {
        stat = gen_yajl_object_residual (ptr->_residual, g, err);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN (stat, err);
    }
    stat = yajl_gen_map_close((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    return yajl_gen_status_ok;
}

oci_runtime_spec *make_oci_runtime_spec(yajl_val tree, const struct parser_context *ctx, parser_error *err) {
    oci_runtime_spec *ret = NULL;
    *err = 0;
    if (tree == NULL)
        return ret;
    ret = safe_malloc(sizeof(*ret));
    {
        yajl_val val = get_val(tree, "ociVersion", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->oci_version = safe_strdup(str ? str : "");
        }
    }
    ret->hooks = make_oci_runtime_spec_hooks(get_val(tree, "hooks", yajl_t_object), ctx, err);
    if (ret->hooks == NULL && *err != 0) {
        free_oci_runtime_spec(ret);
        return NULL;
    }
    {
        yajl_val tmp = get_val(tree, "annotations", yajl_t_object);
        if (tmp != NULL) {
            ret->annotations = make_json_map_string_string(tmp, ctx, err);
            if (ret->annotations == NULL) {
                char *new_error = NULL;
                if (asprintf(&new_error, "Value error for key 'annotations': %s", *err ? *err : "null") < 0) {
                    new_error = safe_strdup("error allocating memory");
                }
                free(*err);
                *err = new_error;
                free_oci_runtime_spec(ret);
                return NULL;
            }
        }
    }
    {
        yajl_val val = get_val(tree, "hostname", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->hostname = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val tmp = get_val(tree, "mounts", yajl_t_array);
        if (tmp != NULL && YAJL_GET_ARRAY(tmp) != NULL && YAJL_GET_ARRAY(tmp)->len > 0) {
            size_t i;
            ret->mounts_len = YAJL_GET_ARRAY(tmp)->len;
            ret->mounts = safe_malloc((YAJL_GET_ARRAY(tmp)->len + 1) * sizeof(*ret->mounts));
            for (i = 0; i < YAJL_GET_ARRAY(tmp)->len; i++) {
                yajl_val val = YAJL_GET_ARRAY(tmp)->values[i];
                ret->mounts[i] = make_defs_mount(val, ctx, err);
                if (ret->mounts[i] == NULL) {
                    free_oci_runtime_spec(ret);
                    return NULL;
                }
            }
        }
    }
    ret->root = make_oci_runtime_spec_root(get_val(tree, "root", yajl_t_object), ctx, err);
    if (ret->root == NULL && *err != 0) {
        free_oci_runtime_spec(ret);
        return NULL;
    }
    ret->process = make_defs_process(get_val(tree, "process", yajl_t_object), ctx, err);
    if (ret->process == NULL && *err != 0) {
        free_oci_runtime_spec(ret);
        return NULL;
    }
    ret->linux = make_oci_runtime_config_linux(get_val(tree, "linux", yajl_t_object), ctx, err);
    if (ret->linux == NULL && *err != 0) {
        free_oci_runtime_spec(ret);
        return NULL;
    }
    if (ret->oci_version == NULL) {
        if (asprintf(err, "Required field '%s' not present",  "ociVersion") < 0)
            *err = safe_strdup("error allocating memory");
        free_oci_runtime_spec(ret);
        return NULL;
    }

    if (tree->type == yajl_t_object)
    {
        size_t i;
        size_t j = 0;
        size_t cnt = tree->u.object.len;
        yajl_val resi = NULL;

        if (ctx->options & OPT_PARSE_FULLKEY)
        {
            resi = calloc (1, sizeof(*tree));
            if (resi == NULL)
            {
                free_oci_runtime_spec(ret);
                return NULL;
            }
            resi->type = yajl_t_object;
            resi->u.object.keys = calloc (cnt, sizeof (const char *));
            if (resi->u.object.keys == NULL)
            {
               free_oci_runtime_spec(ret);
               yajl_tree_free(resi);
               return NULL;
            }
            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
            if (resi->u.object.values == NULL)
            {
               free_oci_runtime_spec(ret);
               yajl_tree_free(resi);
               return NULL;
            }
        }
        for (i = 0; i < tree->u.object.len; i++)
        {
           if (strcmp(tree->u.object.keys[i], "ociVersion") &&
                strcmp(tree->u.object.keys[i], "hooks") &&
                strcmp(tree->u.object.keys[i], "annotations") &&
                strcmp(tree->u.object.keys[i], "hostname") &&
                strcmp(tree->u.object.keys[i], "mounts") &&
                strcmp(tree->u.object.keys[i], "root") &&
                strcmp(tree->u.object.keys[i], "process") &&
                strcmp(tree->u.object.keys[i], "linux"))
           {
              if (ctx->options & OPT_PARSE_FULLKEY)
              {
                 resi->u.object.keys[j] = tree->u.object.keys[i];
                 tree->u.object.keys[i] = NULL;
                 resi->u.object.values[j] = tree->u.object.values[i];
                 tree->u.object.values[i] = NULL;
                 resi->u.object.len++;
              }
              j++;
           }
        }
        if (ctx->options & OPT_PARSE_STRICT)
        {
            if (j > 0 && ctx->stderr > 0)
                fprintf (ctx->stderr, "WARNING: unknown key found\n");
        }
        if (ctx->options & OPT_PARSE_FULLKEY)
            ret->_residual = resi;
        }
    return ret;
}

void free_oci_runtime_spec(oci_runtime_spec *ptr) {
    if (ptr == NULL)
        return;
    free(ptr->oci_version);
    ptr->oci_version = NULL;
    if (ptr->hooks != NULL) {
        free_oci_runtime_spec_hooks(ptr->hooks);
        ptr->hooks = NULL;
    }
    free_json_map_string_string(ptr->annotations);
    ptr->annotations = NULL;
    free(ptr->hostname);
    ptr->hostname = NULL;
    if (ptr->mounts != NULL) {
        size_t i;
        for (i = 0; i < ptr->mounts_len; i++)
            if (ptr->mounts[i] != NULL) {
                free_defs_mount(ptr->mounts[i]);
                ptr->mounts[i] = NULL;
            }
        free(ptr->mounts);
        ptr->mounts = NULL;
    }
    if (ptr->root != NULL) {
        free_oci_runtime_spec_root(ptr->root);
        ptr->root = NULL;
    }
    if (ptr->process != NULL) {
        free_defs_process(ptr->process);
        ptr->process = NULL;
    }
    if (ptr->linux != NULL) {
        free_oci_runtime_config_linux(ptr->linux);
        ptr->linux = NULL;
    }
    yajl_tree_free (ptr->_residual);
    ptr->_residual = NULL;
    free(ptr);
}

yajl_gen_status gen_oci_runtime_spec(yajl_gen g, const oci_runtime_spec *ptr, const struct parser_context *ctx, parser_error *err) {
    yajl_gen_status stat = yajl_gen_status_ok;
    *err = 0;
    stat = yajl_gen_map_open((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->oci_version != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("ociVersion"), strlen("ociVersion"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->oci_version != NULL) {
            str = ptr->oci_version;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->hooks != NULL)) {
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("hooks"), strlen("hooks"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        stat = gen_oci_runtime_spec_hooks(g, ptr != NULL ? ptr->hooks : NULL, ctx, err);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->annotations != NULL)) {
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)("annotations"), strlen("annotations"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        stat = gen_json_map_string_string(g, ptr ? ptr->annotations : NULL, ctx, err);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->hostname != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("hostname"), strlen("hostname"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->hostname != NULL) {
            str = ptr->hostname;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->mounts != NULL)) {
        size_t len = 0, i;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("mounts"), strlen("mounts"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->mounts != NULL) {
            len = ptr->mounts_len;
        }
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 0);
        stat = yajl_gen_array_open((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        for (i = 0; i < len; i++) {
            stat = gen_defs_mount(g, ptr->mounts[i], ctx, err);
            if (yajl_gen_status_ok != stat)
                GEN_SET_ERROR_AND_RETURN(stat, err);
        }
        stat = yajl_gen_array_close((yajl_gen)g);
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 1);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->root != NULL)) {
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("root"), strlen("root"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        stat = gen_oci_runtime_spec_root(g, ptr != NULL ? ptr->root : NULL, ctx, err);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->process != NULL)) {
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("process"), strlen("process"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        stat = gen_defs_process(g, ptr != NULL ? ptr->process : NULL, ctx, err);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->linux != NULL)) {
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("linux"), strlen("linux"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        stat = gen_oci_runtime_config_linux(g, ptr != NULL ? ptr->linux : NULL, ctx, err);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if (ptr != NULL && ptr->_residual != NULL)
    {
        stat = gen_yajl_object_residual (ptr->_residual, g, err);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN (stat, err);
    }
    stat = yajl_gen_map_close((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    return yajl_gen_status_ok;
}


oci_runtime_spec *oci_runtime_spec_parse_file(const char *filename, const struct parser_context *ctx, parser_error *err) {
    oci_runtime_spec *ptr = NULL;
    size_t filesize;
    char *content = NULL;

    if (filename == NULL || err == NULL)
        return NULL;

    *err = NULL;
    content = read_file(filename, &filesize);
    if (content == NULL) {
        if (asprintf(err, "cannot read the file: %s", filename) < 0)
            *err = safe_strdup("error allocating memory");
        return NULL;
    }
    ptr = oci_runtime_spec_parse_data(content, ctx, err);
    free(content);
    return ptr;
}

oci_runtime_spec *oci_runtime_spec_parse_file_stream(FILE *stream, const struct parser_context *ctx, parser_error *err) {
    oci_runtime_spec *ptr = NULL;
    size_t filesize;
    char *content = NULL ;

    if (stream == NULL || err == NULL)
        return NULL;

    *err = NULL;
    content = fread_file(stream, &filesize);
    if (content == NULL) {
        *err = safe_strdup("cannot read the file");
        return NULL;
    }
    ptr = oci_runtime_spec_parse_data(content, ctx, err);
    free(content);
    return ptr;
}

oci_runtime_spec *oci_runtime_spec_parse_data(const char *jsondata, const struct parser_context *ctx, parser_error *err) {
    oci_runtime_spec *ptr = NULL;
    yajl_val tree;
    char errbuf[1024];
    struct parser_context tmp_ctx = { 0 };

    if (jsondata == NULL || err == NULL)
        return NULL;

    *err = NULL;
    if (ctx == NULL) {
       ctx = (const struct parser_context *)(&tmp_ctx);
    }
    tree = yajl_tree_parse(jsondata, errbuf, sizeof(errbuf));
    if (tree == NULL) {
        if (asprintf(err, "cannot parse the data: %s", errbuf) < 0)
            *err = safe_strdup("error allocating memory");
        return NULL;
    }
    ptr = make_oci_runtime_spec(tree, ctx, err);
    yajl_tree_free(tree);
    return ptr;
}
char *oci_runtime_spec_generate_json(const oci_runtime_spec *ptr, const struct parser_context *ctx, parser_error *err) {
    yajl_gen g = NULL;
    struct parser_context tmp_ctx = { 0 };
    const unsigned char *gen_buf = NULL;
    char *json_buf = NULL;
    size_t gen_len = 0;

    if (ptr == NULL || err == NULL)
        return NULL;

    *err = NULL;
    if (ctx == NULL) {
        ctx = (const struct parser_context *)(&tmp_ctx);
    }

    if (!json_gen_init(&g, ctx)) {
        *err = safe_strdup("Json_gen init failed");
        goto out;
    }
    if (yajl_gen_status_ok != gen_oci_runtime_spec(g, ptr, ctx, err)) {
        if (*err == NULL)
            *err = safe_strdup("Failed to generate json");
        goto free_out;
    }
    yajl_gen_get_buf(g, &gen_buf, &gen_len);
    if (gen_buf == NULL) {
        *err = safe_strdup("Error to get generated json");
        goto free_out;
    }

    json_buf = safe_malloc(gen_len + 1);
    (void)memcpy(json_buf, gen_buf, gen_len);
    json_buf[gen_len] = '\0';

free_out:
    yajl_gen_clear(g);
    yajl_gen_free(g);
out:
    return json_buf;
}

