// Generated from state.json. Do not edit!
#ifndef _GNU_SOURCE
#define _GNU_SOURCE
#endif
#include <string.h>
#include <read_file.h>
#include "oci_runtime_state.h"

oci_runtime_state *make_oci_runtime_state(yajl_val tree, const struct parser_context *ctx, parser_error *err) {
    oci_runtime_state *ret = NULL;
    *err = 0;
    if (tree == NULL)
        return ret;
    ret = safe_malloc(sizeof(*ret));
    {
        yajl_val val = get_val(tree, "ociVersion", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->oci_version = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val val = get_val(tree, "id", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->id = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val val = get_val(tree, "status", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->status = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val val = get_val(tree, "pid", yajl_t_number);
        if (val != NULL) {
            int invalid = common_safe_int(YAJL_GET_NUMBER(val), (int *)&ret->pid);
            if (invalid) {
                if (asprintf(err, "Invalid value '%s' with type 'integer' for key 'pid': %s", YAJL_GET_NUMBER(val), strerror(-invalid)) < 0)
                    *err = safe_strdup("error allocating memory");
                free_oci_runtime_state(ret);
                return NULL;
            }
        }
    }
    {
        yajl_val val = get_val(tree, "bundle", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->bundle = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val tmp = get_val(tree, "annotations", yajl_t_object);
        if (tmp != NULL) {
            ret->annotations = make_json_map_string_string(tmp, ctx, err);
            if (ret->annotations == NULL) {
                char *new_error = NULL;
                if (asprintf(&new_error, "Value error for key 'annotations': %s", *err ? *err : "null") < 0) {
                    new_error = safe_strdup("error allocating memory");
                }
                free(*err);
                *err = new_error;
                free_oci_runtime_state(ret);
                return NULL;
            }
        }
    }
    if (ret->oci_version == NULL) {
        if (asprintf(err, "Required field '%s' not present",  "ociVersion") < 0)
            *err = safe_strdup("error allocating memory");
        free_oci_runtime_state(ret);
        return NULL;
    }
    if (ret->id == NULL) {
        if (asprintf(err, "Required field '%s' not present",  "id") < 0)
            *err = safe_strdup("error allocating memory");
        free_oci_runtime_state(ret);
        return NULL;
    }
    if (ret->status == NULL) {
        if (asprintf(err, "Required field '%s' not present",  "status") < 0)
            *err = safe_strdup("error allocating memory");
        free_oci_runtime_state(ret);
        return NULL;
    }
    if (ret->bundle == NULL) {
        if (asprintf(err, "Required field '%s' not present",  "bundle") < 0)
            *err = safe_strdup("error allocating memory");
        free_oci_runtime_state(ret);
        return NULL;
    }

    if (tree->type == yajl_t_object)
    {
        size_t i;
        size_t j = 0;
        size_t cnt = tree->u.object.len;
        yajl_val resi = NULL;

        if (ctx->options & OPT_PARSE_FULLKEY)
        {
            resi = calloc (1, sizeof(*tree));
            if (resi == NULL)
            {
                free_oci_runtime_state(ret);
                return NULL;
            }
            resi->type = yajl_t_object;
            resi->u.object.keys = calloc (cnt, sizeof (const char *));
            if (resi->u.object.keys == NULL)
            {
               free_oci_runtime_state(ret);
               yajl_tree_free(resi);
               return NULL;
            }
            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
            if (resi->u.object.values == NULL)
            {
               free_oci_runtime_state(ret);
               yajl_tree_free(resi);
               return NULL;
            }
        }
        for (i = 0; i < tree->u.object.len; i++)
        {
           if (strcmp(tree->u.object.keys[i], "ociVersion") &&
                strcmp(tree->u.object.keys[i], "id") &&
                strcmp(tree->u.object.keys[i], "status") &&
                strcmp(tree->u.object.keys[i], "pid") &&
                strcmp(tree->u.object.keys[i], "bundle") &&
                strcmp(tree->u.object.keys[i], "annotations"))
           {
              if (ctx->options & OPT_PARSE_FULLKEY)
              {
                 resi->u.object.keys[j] = tree->u.object.keys[i];
                 tree->u.object.keys[i] = NULL;
                 resi->u.object.values[j] = tree->u.object.values[i];
                 tree->u.object.values[i] = NULL;
                 resi->u.object.len++;
              }
              j++;
           }
        }
        if (ctx->options & OPT_PARSE_STRICT)
        {
            if (j > 0 && ctx->stderr > 0)
                fprintf (ctx->stderr, "WARNING: unknown key found\n");
        }
        if (ctx->options & OPT_PARSE_FULLKEY)
            ret->_residual = resi;
        }
    return ret;
}

void free_oci_runtime_state(oci_runtime_state *ptr) {
    if (ptr == NULL)
        return;
    free(ptr->oci_version);
    ptr->oci_version = NULL;
    free(ptr->id);
    ptr->id = NULL;
    free(ptr->status);
    ptr->status = NULL;
    free(ptr->bundle);
    ptr->bundle = NULL;
    free_json_map_string_string(ptr->annotations);
    ptr->annotations = NULL;
    yajl_tree_free (ptr->_residual);
    ptr->_residual = NULL;
    free(ptr);
}

yajl_gen_status gen_oci_runtime_state(yajl_gen g, const oci_runtime_state *ptr, const struct parser_context *ctx, parser_error *err) {
    yajl_gen_status stat = yajl_gen_status_ok;
    *err = 0;
    stat = yajl_gen_map_open((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->oci_version != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("ociVersion"), strlen("ociVersion"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->oci_version != NULL) {
            str = ptr->oci_version;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->id != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("id"), strlen("id"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->id != NULL) {
            str = ptr->id;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->status != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("status"), strlen("status"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->status != NULL) {
            str = ptr->status;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->pid)) {
        long long int num = 0;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("pid"), strlen("pid"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->pid) {
            num = (long long int)ptr->pid;
        }
        stat = map_int(g, num);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->bundle != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("bundle"), strlen("bundle"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->bundle != NULL) {
            str = ptr->bundle;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->annotations != NULL)) {
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)("annotations"), strlen("annotations"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        stat = gen_json_map_string_string(g, ptr ? ptr->annotations : NULL, ctx, err);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if (ptr != NULL && ptr->_residual != NULL)
    {
        stat = gen_yajl_object_residual (ptr->_residual, g, err);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN (stat, err);
    }
    stat = yajl_gen_map_close((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    return yajl_gen_status_ok;
}


oci_runtime_state *oci_runtime_state_parse_file(const char *filename, const struct parser_context *ctx, parser_error *err) {
    oci_runtime_state *ptr = NULL;
    size_t filesize;
    char *content = NULL;

    if (filename == NULL || err == NULL)
        return NULL;

    *err = NULL;
    content = read_file(filename, &filesize);
    if (content == NULL) {
        if (asprintf(err, "cannot read the file: %s", filename) < 0)
            *err = safe_strdup("error allocating memory");
        return NULL;
    }
    ptr = oci_runtime_state_parse_data(content, ctx, err);
    free(content);
    return ptr;
}

oci_runtime_state *oci_runtime_state_parse_file_stream(FILE *stream, const struct parser_context *ctx, parser_error *err) {
    oci_runtime_state *ptr = NULL;
    size_t filesize;
    char *content = NULL ;

    if (stream == NULL || err == NULL)
        return NULL;

    *err = NULL;
    content = fread_file(stream, &filesize);
    if (content == NULL) {
        *err = safe_strdup("cannot read the file");
        return NULL;
    }
    ptr = oci_runtime_state_parse_data(content, ctx, err);
    free(content);
    return ptr;
}

oci_runtime_state *oci_runtime_state_parse_data(const char *jsondata, const struct parser_context *ctx, parser_error *err) {
    oci_runtime_state *ptr = NULL;
    yajl_val tree;
    char errbuf[1024];
    struct parser_context tmp_ctx = { 0 };

    if (jsondata == NULL || err == NULL)
        return NULL;

    *err = NULL;
    if (ctx == NULL) {
       ctx = (const struct parser_context *)(&tmp_ctx);
    }
    tree = yajl_tree_parse(jsondata, errbuf, sizeof(errbuf));
    if (tree == NULL) {
        if (asprintf(err, "cannot parse the data: %s", errbuf) < 0)
            *err = safe_strdup("error allocating memory");
        return NULL;
    }
    ptr = make_oci_runtime_state(tree, ctx, err);
    yajl_tree_free(tree);
    return ptr;
}
char *oci_runtime_state_generate_json(const oci_runtime_state *ptr, const struct parser_context *ctx, parser_error *err) {
    yajl_gen g = NULL;
    struct parser_context tmp_ctx = { 0 };
    const unsigned char *gen_buf = NULL;
    char *json_buf = NULL;
    size_t gen_len = 0;

    if (ptr == NULL || err == NULL)
        return NULL;

    *err = NULL;
    if (ctx == NULL) {
        ctx = (const struct parser_context *)(&tmp_ctx);
    }

    if (!json_gen_init(&g, ctx)) {
        *err = safe_strdup("Json_gen init failed");
        goto out;
    }
    if (yajl_gen_status_ok != gen_oci_runtime_state(g, ptr, ctx, err)) {
        if (*err == NULL)
            *err = safe_strdup("Failed to generate json");
        goto free_out;
    }
    yajl_gen_get_buf(g, &gen_buf, &gen_len);
    if (gen_buf == NULL) {
        *err = safe_strdup("Error to get generated json");
        goto free_out;
    }

    json_buf = safe_malloc(gen_len + 1);
    (void)memcpy(json_buf, gen_buf, gen_len);
    json_buf[gen_len] = '\0';

free_out:
    yajl_gen_clear(g);
    yajl_gen_free(g);
out:
    return json_buf;
}

